if (typeof _yuitest_coverage == "undefined"){
    _yuitest_coverage = {};
    _yuitest_coverline = function(src, line){
        var coverage = _yuitest_coverage[src];
        if (!coverage.lines[line]){
            coverage.calledLines++;
        }
        coverage.lines[line]++;
    };
    _yuitest_coverfunc = function(src, name, line){
        var coverage = _yuitest_coverage[src],
            funcId = name + ":" + line;
        if (!coverage.functions[funcId]){
            coverage.calledFunctions++;
        }
        coverage.functions[funcId]++;
    };
}
_yuitest_coverage["build/aui-carousel/aui-carousel.js"] = {
    lines: {},
    functions: {},
    coveredLines: 0,
    calledLines: 0,
    coveredFunctions: 0,
    calledFunctions: 0,
    path: "build/aui-carousel/aui-carousel.js",
    code: []
};
_yuitest_coverage["build/aui-carousel/aui-carousel.js"].code=["YUI.add('aui-carousel', function (A, NAME) {","","/**"," * The Carousel Component"," *"," * @module aui-carousel"," */","","var Lang = A.Lang,","","    STR_BLANK = ' ',","","    CAROUSEL = 'carousel',","","    getCN = A.getClassName,","","    CSS_ITEM = getCN(CAROUSEL, 'item'),","    CSS_ITEM_ACTIVE = getCN(CAROUSEL, 'item', 'active'),","    CSS_ITEM_TRANSITION = getCN(CAROUSEL, 'item', 'transition'),","    CSS_MENU_ACTIVE = getCN(CAROUSEL, 'menu', 'active'),","    CSS_MENU_INDEX = getCN(CAROUSEL, 'menu', 'index'),","    CSS_MENU_ITEM = getCN(CAROUSEL, 'menu', 'item'),","    CSS_MENU_NEXT = getCN(CAROUSEL, 'menu', 'next'),","    CSS_MENU_PLAY = getCN(CAROUSEL, 'menu', 'play'),","    CSS_MENU_PAUSE = getCN(CAROUSEL, 'menu', 'pause'),","    CSS_MENU_PREV = getCN(CAROUSEL, 'menu', 'prev'),","    CSS_MENU_ITEM_DEFAULT = [CSS_MENU_ITEM, CSS_MENU_INDEX].join(STR_BLANK),","    CSS_MENU_ITEM_ACTIVE = [CSS_MENU_ITEM, CSS_MENU_INDEX, CSS_MENU_ACTIVE].join(STR_BLANK),","","    DOT = '.',","","    SELECTOR_MENU_INDEX = DOT + CSS_MENU_INDEX,","    SELECTOR_MENU_NEXT = DOT + CSS_MENU_NEXT,","    SELECTOR_MENU_PAUSE = DOT + CSS_MENU_PAUSE,","    SELECTOR_MENU_PLAY = DOT + CSS_MENU_PLAY,","    SELECTOR_MENU_PLAY_OR_PAUSE = [SELECTOR_MENU_PLAY, SELECTOR_MENU_PAUSE].join(),","    SELECTOR_MENU_PREV = DOT + CSS_MENU_PREV,","","    TPL_ITEM = '<li><a class=\"' + CSS_MENU_ITEM + ' {cssClasses}\">{index}</a></li>',","","    TPL_MENU = '<menu>' +","                    '<li><a class=\"' + CSS_MENU_ITEM + ' ' + CSS_MENU_PLAY + '\"></a></li>' +","                    '<li><a class=\"' + CSS_MENU_ITEM + ' ' + CSS_MENU_PREV + '\"></a></li>' +","                    '{items}' +","                    '<li><a class=\"' + CSS_MENU_ITEM + ' ' + CSS_MENU_NEXT + '\"></a></li>' +","                '</menu>',","","    UI_SRC = A.Widget.UI_SRC,","","    MAP_EVENT_INFO = {","        src: UI_SRC","    };","","/**"," * A base class for Carousel"," *"," * Quick Example:<br/>"," *"," * <pre><code>var component = new A.Carousel("," *  {"," *      contentBox: '#demo',"," *      intervalTime: 1,"," *      activeIndex: 0,"," *      height: 254,"," *      width: 940"," *  }"," * ).render();"," * </code></pre>"," *"," * Check the list of <a href=\"Carousel.html#configattributes\">Configuration Attributes</a> available for"," * Carousel."," *"," * @class Carousel"," * @uses AUI-base,AUI-template,anim"," * @param config {Object} Object literal specifying widget configuration properties."," * @constructor","  */","var Carousel = A.Component.create(","    {","        /**","         * Static property provides a string to identify the class.","         *","         * @property Carousel.NAME","         * @type String","         * @static","         */","        NAME: CAROUSEL,","","        /**","         * Static property used to define the default attribute","         * configuration for the Carousel.","         *","         * @property Carousel.ATTRS","         * @type Object","         * @static","         */","        ATTRS: {","            /**","             * Index of the first visible item of the carousel","             *","             * @attribute activeIndex","             * @default 0","             * @type {Integer}","             */","            activeIndex: {","                value: 0,","                setter: '_setActiveIndex'","            },","","            /**","             * Duration of the animation in seconds when change index on","             * Carousel","             *","             * @attribute animationTime","             * @default 0.5","             * @type {Integer | Float}","             */","            animationTime: {","                value: 0.5","            },","","            /**","             * Interval time in seconds between an item transition","             *","             * @attribute intervalTime","             * @default 0.75","             * @type {Integer | Float}","             */","            intervalTime: {","                value: 0.75","            },","","            /**","             * CSS Selector whitch determines the items to be loaded to the","             * Carousel.","             *","             * @attribute itemSelector","             * @default >* (All first childs)","             * @type {String}","             */","            itemSelector: {","                value: '>*'","            },","","            /**","             * Node container of the navigation items","             *","             * @attribute nodeMenu","             * @default null","             * @type {Node | String}","             */","            nodeMenu: {","                value: null,","                setter: '_setNodeMenu'","            },","","            /**","             * CSS selector to match the navigation items","             *","             * @attribute nodeMenuItemSelector","             * @default .aui-carousel-menu-item","             * @type {String}","             */","            nodeMenuItemSelector: {","                value: DOT + CSS_MENU_ITEM","            },","","            /**","             * Attributes that determines the status of transitions between","             * items","             *","             * @attribute playing","             * @default true","             * @type {Boolean}","             */","            playing: {","                value: true","            }","        },","","        prototype: {","            animation: null,","            nodeSelection: null,","            nodeMenu: null,","","            /**","             * Construction logic executed during Carousel instantiation. Lifecycle.","             *","             * @method initializer","             * @protected","             */","            initializer: function() {","                var instance = this;","","                instance.animation = new A.Anim(","                    {","                        duration: instance.get('animationTime'),","                        to: {","                            opacity: 1","                        }","                    }","                );","            },","","            /**","             * Render de Carousel component instance. Lifecycle.","             *","             * @method renderUI","             * @protected","             */","            renderUI: function() {","                var instance = this;","","                instance._updateNodeSelection();","                instance.nodeMenu = instance.get('nodeMenu');","","                instance._updateMenuNodes();","            },","","            /**","             * Bind the events on the Carousel UI. Lifecycle.","             *","             * @method bindUI","             * @protected","             */","            bindUI: function() {","                var instance = this;","","                instance.after(","                    {","                        activeIndexChange: instance._afterActiveIndexChange,","                        animationTimeChange: instance._afterAnimationTimeChange,","                        itemSelectorChange: instance._afterItemSelectorChange,","                        intervalTimeChange: instance._afterIntervalTimeChange,","                        nodeMenuItemSelector: instance._afterNodeMenuItemSelectorChange,","                        playingChange: instance._afterPlayingChange","                    }","                );","","                instance._bindMenu();","","                if (instance.get('playing') === true) {","                    instance._afterPlayingChange(","                        {","                            prevVal: false,","                            newVal: true","                        }","                    );","                }","            },","","            /**","             * Sync the Carousel UI. Lifecycle.","             *","             * @method syncUI","             * @protected","             */","            syncUI: function() {","                var instance = this;","","                instance._uiSetActiveIndex(instance.get('activeIndex'));","            },","","            /**","             * Sync the Carousel UI. Lifecycle.","             *","             * @method syncUI","             * @param {Integer}","             * @protected","             */","            item: function(val) {","                var instance = this;","","                instance.set('activeIndex', val);","            },","","            /**","             * Go to the next index.","             *","             * @method next","             */","            next: function() {","                var instance = this;","","                instance._updateIndexNext();","            },","","            /**","             * Sets the <a","             * href=\"Carousel.html#config_play\">playing</a> attribute","             * to false which pauses the animation","             *","             * @method pause","             */","            pause: function() {","                var instance = this;","","                instance.set('playing', false);","            },","","            /**","             * Sets the <a","             * href=\"Carousel.html#config_play\">playing</a> attribute","             * to true which starts the animation","             *","             * @method play","             */","            play: function() {","                var instance = this;","","                instance.set('playing', true);","            },","","            /**","             * Go to previous index.","             *","             * @method prev","             */","            prev: function() {","                var instance = this;","","                instance._updateIndexPrev();","            },","","            /**","             * Fires after activeIndex attribute changes","             *","             * @method _afterActiveIndexChange","             * @param event","             * @protected","             */","            _afterActiveIndexChange: function(event) {","                var instance = this;","","                instance._uiSetActiveIndex(","                    event.newVal,","                    {","                        prevVal: event.prevVal,","                        animate: instance.get('playing'),","                        src: event.src","                    }","                );","            },","","            /**","             * Fires after animationTime attribute changes","             *","             * @method _afterAnimationTimeChange","             * @param event","             */","            _afterAnimationTimeChange: function(event) {","                var instance = this;","","                instance.animation.set('duration', event.newVal);","            },","","            /**","             * Fires after itemSelector attribute changes","             *","             * @method _afterItemSelectorChange","             * @param event","             * @protected","             */","            _afterItemSelectorChange: function(event) {","                var instance = this;","","                instance._updateNodeSelection();","            },","","            /**","             * Fires after nodeMenuItemSelector attribute changes","             *","             * @method _afterNodeMenuItemSelectorChange","             * @param event","             * @protected","             */","            _afterNodeMenuItemSelectorChange: function(event) {","                var instance = this;","","                instance.nodeMenuItemSelector = event.newVal;","","                instance._updateMenuNodes();","            },","","            /**","             * Fires after intervalTime attribute changes","             *","             * @method _afterIntervalTimeChange","             * @param event","             * @protected","             */","            _afterIntervalTimeChange: function(event) {","                var instance = this;","","                instance._clearIntervalRotationTask();","                instance._createIntervalRotationTask();","            },","","            /**","             * Fires after playing attribute changes","             *","             * @method _afterPlayingChange","             * @param event","             * @protected","             */","            _afterPlayingChange: function(event) {","                var instance = this;","","                var menuPlayItem = instance.nodeMenu.one(SELECTOR_MENU_PLAY_OR_PAUSE);","                var playing = event.newVal;","","                var fromClass = CSS_MENU_PAUSE;","                var toClass = CSS_MENU_PLAY;","","                var rotationTaskMethod = '_clearIntervalRotationTask';","","                if (playing) {","                    fromClass = CSS_MENU_PLAY;","                    toClass = CSS_MENU_PAUSE;","","                    rotationTaskMethod = '_createIntervalRotationTask';","                }","","                instance[rotationTaskMethod]();","","                if (menuPlayItem) {","                    menuPlayItem.replaceClass(fromClass, toClass);","                }","            },","","            /**","             * Attach delegate to the carousel menu","             *","             * @method _bindMenu","             * @protected","             */","            _bindMenu: function() {","                var instance = this;","","                var menu = instance.nodeMenu;","","                var nodeMenuItemSelector = instance.get('nodeMenuItemSelector');","","                menu.delegate('click', instance._onClickDelegate, nodeMenuItemSelector, instance);","","                instance.nodeMenuItemSelector = nodeMenuItemSelector;","            },","","            /**","             * Clear the rotation task interval","             *","             * @method _clearIntervalRotationTask","             * @protected","             */","            _clearIntervalRotationTask: function() {","                var instance = this;","","                clearInterval(instance._intervalRotationTask);","            },","","            /**","             * Creates an random number to be current index","             *","             * @method _createIndexRandom","             * @protected","             */","            _createIndexRandom: function() {","                var instance = this;","","                return Math.ceil(Math.random() * instance.nodeSelection.size()) - 1;","            },","","            /**","             * Creates an timer for the rotation task","             *","             * @method _createIntervalRotationTask","             * @protected","             */","            _createIntervalRotationTask: function() {","                var instance = this;","","                instance._clearIntervalRotationTask();","","                instance._intervalRotationTask = setInterval(","                    function() {","                        instance._updateIndexNext(","                            {","                                animate: true","                            }","                        );","                    },","                    instance.get('intervalTime') * 1000","                );","            },","","            /**","             * Fires when animation ends","             *","             * @method _onAnimationEnd","             * @param event, newImage, oldImage, newMenuItem, oldMenuItem","             * @protected","             */","            _onAnimationEnd: function(event, newImage, oldImage, newMenuItem, oldMenuItem) {","                var instance = this;","","                if (oldImage) {","                    oldImage.removeClass(CSS_ITEM_TRANSITION);","                }","","                newImage.setStyle('opacity', '1');","            },","","            /**","             * Fires when animation starts","             *","             * @method _onAnimationStart","             * @param event, newImage, oldImage, newMenuItem, oldMenuItem","             * @protected","             */","            _onAnimationStart: function(event, newImage, oldImage, newMenuItem, oldMenuItem) {","                var instance = this;","","                newImage.addClass(CSS_ITEM_ACTIVE);","","                if (newMenuItem) {","                    newMenuItem.addClass(CSS_MENU_ACTIVE);","                }","","                if (oldImage) {","                    oldImage.replaceClass(CSS_ITEM_ACTIVE, CSS_ITEM_TRANSITION);","                }","","                if (oldMenuItem) {","                    oldMenuItem.removeClass(CSS_MENU_ACTIVE);","                }","            },","","            /**","             * Fires when a click is fired on menu","             *","             * @method _onClickDelegate","             * @param event","             * @protected","             */","            _onClickDelegate: function(event) {","                var instance = this;","","                event.preventDefault();","","                var currentTarget = event.currentTarget;","","                var handler;","","                if (currentTarget.hasClass(CSS_MENU_INDEX)) {","                    handler = instance._onMenuItemClick;","                }","                else if (currentTarget.hasClass(CSS_MENU_PREV)) {","                    handler = instance._updateIndexPrev;","                }","                else if (currentTarget.hasClass(CSS_MENU_NEXT)) {","                    handler = instance._updateIndexNext;","                }","                else if (currentTarget.test(SELECTOR_MENU_PLAY_OR_PAUSE)) {","                    handler = instance._onMenuPlayClick;","                }","","                if (handler) {","                    handler.apply(instance, arguments);","                }","            },","","            /**","             * Executed when delegates handle menuItem click","             *","             * @method _onMenuItemClick","             * @param event","             * @protected","             */","            _onMenuItemClick: function(event) {","                var instance = this;","","                event.preventDefault();","","                var newIndex = instance.menuNodes.indexOf(event.currentTarget);","","                instance.set('activeIndex', newIndex, MAP_EVENT_INFO);","            },","","            /**","             * Executed when delegates handle play click","             *","             * @method _onMenuPlayClick","             * @param event","             * @protected","             */","            _onMenuPlayClick: function(event) {","                var instance = this;","","                this.set('playing', !this.get('playing'));","            },","","            /**","             * Render the menu in DOM","             *","             * @method _renderMenu","             * @protected","             */","            _renderMenu: function() {","                var instance = this,","                    activeIndex = instance.get('activeIndex'),","                    items = [],","                    i,","                    len = instance.nodeSelection.size();","","                for (i = 0; i < len; i++) {","                    items.push(","                        Lang.sub(TPL_ITEM, {","                            cssClasses: activeIndex === i ? CSS_MENU_ITEM_ACTIVE : CSS_MENU_ITEM_DEFAULT,","                            index: i","                        })","                    );","                }","","                var menu = A.Node.create(Lang.sub(TPL_MENU, { items: items.join(STR_BLANK) }));","","                instance.get('contentBox').appendChild(menu);","","                return menu;","            },","","            /**","             * Set the activeIndex attribute","             *","             * @method _setActiveIndex","             * @param val","             * @protected","             */","            _setActiveIndex: function(val) {","                var instance = this;","","                if (val == 'rand') {","                    val = instance._createIndexRandom();","                }","                else {","                    val = Math.max(Math.min(val, instance.nodeSelection.size()), -1);","                }","","                return val;","            },","","            /**","             * Set the nodeMenu attribute","             *","             * @method _setNodeMenu","             * @param val","             * @protected","             */","            _setNodeMenu: function(val) {","                var instance = this;","","                return A.one(val) || instance._renderMenu();","            },","","            /**","             * Set the activeIndex on the UI","             *","             * @method _uiSetActiveIndex","             * @param newVal, objOptions","             * @protected","             */","            _uiSetActiveIndex: function(newVal, objOptions) {","                var instance = this;","","                var oldImage = null;","                var oldMenuItem = null;","                var onStart = null;","                var onEnd = null;","","                var newImage = instance.nodeSelection.item(newVal);","","                var menuNodes = instance.menuNodes;","","                var newMenuItem = menuNodes.item(newVal);","","                instance.animation.set('node', newImage);","","                if (objOptions && !Lang.isUndefined(objOptions.prevVal)) {","                    var prevVal = objOptions.prevVal;","","                    newImage.setStyle('opacity', '0');","","                    oldMenuItem = menuNodes.item(prevVal);","                    oldImage = instance.nodeSelection.item(prevVal);","","                    oldImage.replaceClass(CSS_ITEM_ACTIVE, CSS_ITEM_TRANSITION);","","                    instance.animation.stop();","                }","                else {","                    newImage.addClass(CSS_ITEM_ACTIVE);","","                    newImage.setStyle('opacity', '1');","                }","","                onStart = instance.animation.on(","                    'start',","                    function(event) {","                        instance._onAnimationStart(event, newImage, oldImage, newMenuItem, oldMenuItem);","","                        onStart.detach();","                    }","                );","","                onEnd = instance.animation.on(","                    'end',","                    function(event) {","                        instance._onAnimationEnd(event, newImage, oldImage, newMenuItem, oldMenuItem);","","                        onEnd.detach();","                    }","                );","","                if (objOptions) {","                    if (objOptions.animate) {","                        instance.animation.run();","                    }","                    else {","                        instance.animation.fire('start');","                        instance.animation.fire('end');","                    }","","                    if (objOptions.src == UI_SRC && objOptions.animate) {","                        instance._createIntervalRotationTask();","                    }","                }","            },","","            /**","             * Set the activeIndex to the next index","             *","             * @method _updateIndexNext","             * @param options","             * @protected","             */","            _updateIndexNext: function(options) {","                var instance = this;","","                var currentIndex = instance.get('activeIndex');","                var nodeSelectionSize = instance.nodeSelection.size();","","                var newIndex = currentIndex + 1;","","                if (newIndex > (nodeSelectionSize - 1)) {","                    newIndex = 0;","                }","","                if (options) {","                    options.src = UI_SRC;","                }","","                instance.set('activeIndex', newIndex, options);","            },","","            /**","             * Set the activeIndex to the previous index","             *","             * @method _updateIndexPrev","             * @param options","             * @protected","             */","            _updateIndexPrev: function(options) {","                var instance = this;","","                var currentIndex = instance.get('activeIndex');","","                var newIndex = currentIndex - 1;","","                if (newIndex < 0) {","                    newIndex = instance.nodeSelection.size() - 1;","                }","","                if (options) {","                    options.src = UI_SRC;","                }","","                instance.set('activeIndex', newIndex, options);","            },","","            /**","             * Set the menuNodes attribute based on the selector menu index","             *","             * @method _updateMenuNodes","             * @param options","             * @protected","             */","            _updateMenuNodes: function() {","                var instance = this;","","                instance.menuNodes = instance.nodeMenu.all(SELECTOR_MENU_INDEX);","            },","","            /**","             * Upates the nodeSelecton by adding the CSS_ITEM class","             *","             * @method _updateMenuNodes","             * @param options","             * @protected","             */","            _updateNodeSelection: function() {","                var instance = this;","","                var itemSelector = instance.get('itemSelector');","","                var nodeSelection = instance.get('contentBox').all(itemSelector);","","                nodeSelection.addClass(CSS_ITEM);","","                instance.nodeSelection = nodeSelection;","            },","","            _intervalRotationTask: null","        }","    }",");","","A.Carousel = Carousel;","","}, '2.0.0pr1', {\"requires\": [\"anim\", \"node-event-delegate\", \"aui-component\"], \"skinnable\": true});"];
_yuitest_coverage["build/aui-carousel/aui-carousel.js"].lines = {"1":0,"9":0,"78":0,"193":0,"195":0,"212":0,"214":0,"215":0,"217":0,"227":0,"229":0,"240":0,"242":0,"243":0,"259":0,"261":0,"272":0,"274":0,"283":0,"285":0,"296":0,"298":0,"309":0,"311":0,"320":0,"322":0,"333":0,"335":0,"352":0,"354":0,"365":0,"367":0,"378":0,"380":0,"382":0,"393":0,"395":0,"396":0,"407":0,"409":0,"410":0,"412":0,"413":0,"415":0,"417":0,"418":0,"419":0,"421":0,"424":0,"426":0,"427":0,"438":0,"440":0,"442":0,"444":0,"446":0,"456":0,"458":0,"468":0,"470":0,"480":0,"482":0,"484":0,"486":0,"504":0,"506":0,"507":0,"510":0,"521":0,"523":0,"525":0,"526":0,"529":0,"530":0,"533":0,"534":0,"546":0,"548":0,"550":0,"552":0,"554":0,"555":0,"557":0,"558":0,"560":0,"561":0,"563":0,"564":0,"567":0,"568":0,"580":0,"582":0,"584":0,"586":0,"597":0,"599":0,"609":0,"615":0,"616":0,"624":0,"626":0,"628":0,"639":0,"641":0,"642":0,"645":0,"648":0,"659":0,"661":0,"672":0,"674":0,"675":0,"676":0,"677":0,"679":0,"681":0,"683":0,"685":0,"687":0,"688":0,"690":0,"692":0,"693":0,"695":0,"697":0,"700":0,"702":0,"705":0,"708":0,"710":0,"714":0,"717":0,"719":0,"723":0,"724":0,"725":0,"728":0,"729":0,"732":0,"733":0,"746":0,"748":0,"749":0,"751":0,"753":0,"754":0,"757":0,"758":0,"761":0,"772":0,"774":0,"776":0,"778":0,"779":0,"782":0,"783":0,"786":0,"797":0,"799":0,"810":0,"812":0,"814":0,"816":0,"818":0,"826":0};
_yuitest_coverage["build/aui-carousel/aui-carousel.js"].functions = {"initializer:192":0,"renderUI:211":0,"bindUI:226":0,"syncUI:258":0,"item:271":0,"next:282":0,"pause:295":0,"play:308":0,"prev:319":0,"_afterActiveIndexChange:332":0,"_afterAnimationTimeChange:351":0,"_afterItemSelectorChange:364":0,"_afterNodeMenuItemSelectorChange:377":0,"_afterIntervalTimeChange:392":0,"_afterPlayingChange:406":0,"_bindMenu:437":0,"_clearIntervalRotationTask:455":0,"_createIndexRandom:467":0,"(anonymous 2):485":0,"_createIntervalRotationTask:479":0,"_onAnimationEnd:503":0,"_onAnimationStart:520":0,"_onClickDelegate:545":0,"_onMenuItemClick:579":0,"_onMenuPlayClick:596":0,"_renderMenu:608":0,"_setActiveIndex:638":0,"_setNodeMenu:658":0,"(anonymous 3):707":0,"(anonymous 4):716":0,"_uiSetActiveIndex:671":0,"_updateIndexNext:745":0,"_updateIndexPrev:771":0,"_updateMenuNodes:796":0,"_updateNodeSelection:809":0,"(anonymous 1):1":0};
_yuitest_coverage["build/aui-carousel/aui-carousel.js"].coveredLines = 165;
_yuitest_coverage["build/aui-carousel/aui-carousel.js"].coveredFunctions = 36;
_yuitest_coverline("build/aui-carousel/aui-carousel.js", 1);
YUI.add('aui-carousel', function (A, NAME) {

/**
 * The Carousel Component
 *
 * @module aui-carousel
 */

_yuitest_coverfunc("build/aui-carousel/aui-carousel.js", "(anonymous 1)", 1);
_yuitest_coverline("build/aui-carousel/aui-carousel.js", 9);
var Lang = A.Lang,

    STR_BLANK = ' ',

    CAROUSEL = 'carousel',

    getCN = A.getClassName,

    CSS_ITEM = getCN(CAROUSEL, 'item'),
    CSS_ITEM_ACTIVE = getCN(CAROUSEL, 'item', 'active'),
    CSS_ITEM_TRANSITION = getCN(CAROUSEL, 'item', 'transition'),
    CSS_MENU_ACTIVE = getCN(CAROUSEL, 'menu', 'active'),
    CSS_MENU_INDEX = getCN(CAROUSEL, 'menu', 'index'),
    CSS_MENU_ITEM = getCN(CAROUSEL, 'menu', 'item'),
    CSS_MENU_NEXT = getCN(CAROUSEL, 'menu', 'next'),
    CSS_MENU_PLAY = getCN(CAROUSEL, 'menu', 'play'),
    CSS_MENU_PAUSE = getCN(CAROUSEL, 'menu', 'pause'),
    CSS_MENU_PREV = getCN(CAROUSEL, 'menu', 'prev'),
    CSS_MENU_ITEM_DEFAULT = [CSS_MENU_ITEM, CSS_MENU_INDEX].join(STR_BLANK),
    CSS_MENU_ITEM_ACTIVE = [CSS_MENU_ITEM, CSS_MENU_INDEX, CSS_MENU_ACTIVE].join(STR_BLANK),

    DOT = '.',

    SELECTOR_MENU_INDEX = DOT + CSS_MENU_INDEX,
    SELECTOR_MENU_NEXT = DOT + CSS_MENU_NEXT,
    SELECTOR_MENU_PAUSE = DOT + CSS_MENU_PAUSE,
    SELECTOR_MENU_PLAY = DOT + CSS_MENU_PLAY,
    SELECTOR_MENU_PLAY_OR_PAUSE = [SELECTOR_MENU_PLAY, SELECTOR_MENU_PAUSE].join(),
    SELECTOR_MENU_PREV = DOT + CSS_MENU_PREV,

    TPL_ITEM = '<li><a class="' + CSS_MENU_ITEM + ' {cssClasses}">{index}</a></li>',

    TPL_MENU = '<menu>' +
                    '<li><a class="' + CSS_MENU_ITEM + ' ' + CSS_MENU_PLAY + '"></a></li>' +
                    '<li><a class="' + CSS_MENU_ITEM + ' ' + CSS_MENU_PREV + '"></a></li>' +
                    '{items}' +
                    '<li><a class="' + CSS_MENU_ITEM + ' ' + CSS_MENU_NEXT + '"></a></li>' +
                '</menu>',

    UI_SRC = A.Widget.UI_SRC,

    MAP_EVENT_INFO = {
        src: UI_SRC
    };

/**
 * A base class for Carousel
 *
 * Quick Example:<br/>
 *
 * <pre><code>var component = new A.Carousel(
 *  {
 *      contentBox: '#demo',
 *      intervalTime: 1,
 *      activeIndex: 0,
 *      height: 254,
 *      width: 940
 *  }
 * ).render();
 * </code></pre>
 *
 * Check the list of <a href="Carousel.html#configattributes">Configuration Attributes</a> available for
 * Carousel.
 *
 * @class Carousel
 * @uses AUI-base,AUI-template,anim
 * @param config {Object} Object literal specifying widget configuration properties.
 * @constructor
  */
_yuitest_coverline("build/aui-carousel/aui-carousel.js", 78);
var Carousel = A.Component.create(
    {
        /**
         * Static property provides a string to identify the class.
         *
         * @property Carousel.NAME
         * @type String
         * @static
         */
        NAME: CAROUSEL,

        /**
         * Static property used to define the default attribute
         * configuration for the Carousel.
         *
         * @property Carousel.ATTRS
         * @type Object
         * @static
         */
        ATTRS: {
            /**
             * Index of the first visible item of the carousel
             *
             * @attribute activeIndex
             * @default 0
             * @type {Integer}
             */
            activeIndex: {
                value: 0,
                setter: '_setActiveIndex'
            },

            /**
             * Duration of the animation in seconds when change index on
             * Carousel
             *
             * @attribute animationTime
             * @default 0.5
             * @type {Integer | Float}
             */
            animationTime: {
                value: 0.5
            },

            /**
             * Interval time in seconds between an item transition
             *
             * @attribute intervalTime
             * @default 0.75
             * @type {Integer | Float}
             */
            intervalTime: {
                value: 0.75
            },

            /**
             * CSS Selector whitch determines the items to be loaded to the
             * Carousel.
             *
             * @attribute itemSelector
             * @default >* (All first childs)
             * @type {String}
             */
            itemSelector: {
                value: '>*'
            },

            /**
             * Node container of the navigation items
             *
             * @attribute nodeMenu
             * @default null
             * @type {Node | String}
             */
            nodeMenu: {
                value: null,
                setter: '_setNodeMenu'
            },

            /**
             * CSS selector to match the navigation items
             *
             * @attribute nodeMenuItemSelector
             * @default .aui-carousel-menu-item
             * @type {String}
             */
            nodeMenuItemSelector: {
                value: DOT + CSS_MENU_ITEM
            },

            /**
             * Attributes that determines the status of transitions between
             * items
             *
             * @attribute playing
             * @default true
             * @type {Boolean}
             */
            playing: {
                value: true
            }
        },

        prototype: {
            animation: null,
            nodeSelection: null,
            nodeMenu: null,

            /**
             * Construction logic executed during Carousel instantiation. Lifecycle.
             *
             * @method initializer
             * @protected
             */
            initializer: function() {
                _yuitest_coverfunc("build/aui-carousel/aui-carousel.js", "initializer", 192);
_yuitest_coverline("build/aui-carousel/aui-carousel.js", 193);
var instance = this;

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 195);
instance.animation = new A.Anim(
                    {
                        duration: instance.get('animationTime'),
                        to: {
                            opacity: 1
                        }
                    }
                );
            },

            /**
             * Render de Carousel component instance. Lifecycle.
             *
             * @method renderUI
             * @protected
             */
            renderUI: function() {
                _yuitest_coverfunc("build/aui-carousel/aui-carousel.js", "renderUI", 211);
_yuitest_coverline("build/aui-carousel/aui-carousel.js", 212);
var instance = this;

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 214);
instance._updateNodeSelection();
                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 215);
instance.nodeMenu = instance.get('nodeMenu');

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 217);
instance._updateMenuNodes();
            },

            /**
             * Bind the events on the Carousel UI. Lifecycle.
             *
             * @method bindUI
             * @protected
             */
            bindUI: function() {
                _yuitest_coverfunc("build/aui-carousel/aui-carousel.js", "bindUI", 226);
_yuitest_coverline("build/aui-carousel/aui-carousel.js", 227);
var instance = this;

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 229);
instance.after(
                    {
                        activeIndexChange: instance._afterActiveIndexChange,
                        animationTimeChange: instance._afterAnimationTimeChange,
                        itemSelectorChange: instance._afterItemSelectorChange,
                        intervalTimeChange: instance._afterIntervalTimeChange,
                        nodeMenuItemSelector: instance._afterNodeMenuItemSelectorChange,
                        playingChange: instance._afterPlayingChange
                    }
                );

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 240);
instance._bindMenu();

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 242);
if (instance.get('playing') === true) {
                    _yuitest_coverline("build/aui-carousel/aui-carousel.js", 243);
instance._afterPlayingChange(
                        {
                            prevVal: false,
                            newVal: true
                        }
                    );
                }
            },

            /**
             * Sync the Carousel UI. Lifecycle.
             *
             * @method syncUI
             * @protected
             */
            syncUI: function() {
                _yuitest_coverfunc("build/aui-carousel/aui-carousel.js", "syncUI", 258);
_yuitest_coverline("build/aui-carousel/aui-carousel.js", 259);
var instance = this;

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 261);
instance._uiSetActiveIndex(instance.get('activeIndex'));
            },

            /**
             * Sync the Carousel UI. Lifecycle.
             *
             * @method syncUI
             * @param {Integer}
             * @protected
             */
            item: function(val) {
                _yuitest_coverfunc("build/aui-carousel/aui-carousel.js", "item", 271);
_yuitest_coverline("build/aui-carousel/aui-carousel.js", 272);
var instance = this;

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 274);
instance.set('activeIndex', val);
            },

            /**
             * Go to the next index.
             *
             * @method next
             */
            next: function() {
                _yuitest_coverfunc("build/aui-carousel/aui-carousel.js", "next", 282);
_yuitest_coverline("build/aui-carousel/aui-carousel.js", 283);
var instance = this;

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 285);
instance._updateIndexNext();
            },

            /**
             * Sets the <a
             * href="Carousel.html#config_play">playing</a> attribute
             * to false which pauses the animation
             *
             * @method pause
             */
            pause: function() {
                _yuitest_coverfunc("build/aui-carousel/aui-carousel.js", "pause", 295);
_yuitest_coverline("build/aui-carousel/aui-carousel.js", 296);
var instance = this;

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 298);
instance.set('playing', false);
            },

            /**
             * Sets the <a
             * href="Carousel.html#config_play">playing</a> attribute
             * to true which starts the animation
             *
             * @method play
             */
            play: function() {
                _yuitest_coverfunc("build/aui-carousel/aui-carousel.js", "play", 308);
_yuitest_coverline("build/aui-carousel/aui-carousel.js", 309);
var instance = this;

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 311);
instance.set('playing', true);
            },

            /**
             * Go to previous index.
             *
             * @method prev
             */
            prev: function() {
                _yuitest_coverfunc("build/aui-carousel/aui-carousel.js", "prev", 319);
_yuitest_coverline("build/aui-carousel/aui-carousel.js", 320);
var instance = this;

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 322);
instance._updateIndexPrev();
            },

            /**
             * Fires after activeIndex attribute changes
             *
             * @method _afterActiveIndexChange
             * @param event
             * @protected
             */
            _afterActiveIndexChange: function(event) {
                _yuitest_coverfunc("build/aui-carousel/aui-carousel.js", "_afterActiveIndexChange", 332);
_yuitest_coverline("build/aui-carousel/aui-carousel.js", 333);
var instance = this;

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 335);
instance._uiSetActiveIndex(
                    event.newVal,
                    {
                        prevVal: event.prevVal,
                        animate: instance.get('playing'),
                        src: event.src
                    }
                );
            },

            /**
             * Fires after animationTime attribute changes
             *
             * @method _afterAnimationTimeChange
             * @param event
             */
            _afterAnimationTimeChange: function(event) {
                _yuitest_coverfunc("build/aui-carousel/aui-carousel.js", "_afterAnimationTimeChange", 351);
_yuitest_coverline("build/aui-carousel/aui-carousel.js", 352);
var instance = this;

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 354);
instance.animation.set('duration', event.newVal);
            },

            /**
             * Fires after itemSelector attribute changes
             *
             * @method _afterItemSelectorChange
             * @param event
             * @protected
             */
            _afterItemSelectorChange: function(event) {
                _yuitest_coverfunc("build/aui-carousel/aui-carousel.js", "_afterItemSelectorChange", 364);
_yuitest_coverline("build/aui-carousel/aui-carousel.js", 365);
var instance = this;

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 367);
instance._updateNodeSelection();
            },

            /**
             * Fires after nodeMenuItemSelector attribute changes
             *
             * @method _afterNodeMenuItemSelectorChange
             * @param event
             * @protected
             */
            _afterNodeMenuItemSelectorChange: function(event) {
                _yuitest_coverfunc("build/aui-carousel/aui-carousel.js", "_afterNodeMenuItemSelectorChange", 377);
_yuitest_coverline("build/aui-carousel/aui-carousel.js", 378);
var instance = this;

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 380);
instance.nodeMenuItemSelector = event.newVal;

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 382);
instance._updateMenuNodes();
            },

            /**
             * Fires after intervalTime attribute changes
             *
             * @method _afterIntervalTimeChange
             * @param event
             * @protected
             */
            _afterIntervalTimeChange: function(event) {
                _yuitest_coverfunc("build/aui-carousel/aui-carousel.js", "_afterIntervalTimeChange", 392);
_yuitest_coverline("build/aui-carousel/aui-carousel.js", 393);
var instance = this;

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 395);
instance._clearIntervalRotationTask();
                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 396);
instance._createIntervalRotationTask();
            },

            /**
             * Fires after playing attribute changes
             *
             * @method _afterPlayingChange
             * @param event
             * @protected
             */
            _afterPlayingChange: function(event) {
                _yuitest_coverfunc("build/aui-carousel/aui-carousel.js", "_afterPlayingChange", 406);
_yuitest_coverline("build/aui-carousel/aui-carousel.js", 407);
var instance = this;

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 409);
var menuPlayItem = instance.nodeMenu.one(SELECTOR_MENU_PLAY_OR_PAUSE);
                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 410);
var playing = event.newVal;

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 412);
var fromClass = CSS_MENU_PAUSE;
                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 413);
var toClass = CSS_MENU_PLAY;

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 415);
var rotationTaskMethod = '_clearIntervalRotationTask';

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 417);
if (playing) {
                    _yuitest_coverline("build/aui-carousel/aui-carousel.js", 418);
fromClass = CSS_MENU_PLAY;
                    _yuitest_coverline("build/aui-carousel/aui-carousel.js", 419);
toClass = CSS_MENU_PAUSE;

                    _yuitest_coverline("build/aui-carousel/aui-carousel.js", 421);
rotationTaskMethod = '_createIntervalRotationTask';
                }

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 424);
instance[rotationTaskMethod]();

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 426);
if (menuPlayItem) {
                    _yuitest_coverline("build/aui-carousel/aui-carousel.js", 427);
menuPlayItem.replaceClass(fromClass, toClass);
                }
            },

            /**
             * Attach delegate to the carousel menu
             *
             * @method _bindMenu
             * @protected
             */
            _bindMenu: function() {
                _yuitest_coverfunc("build/aui-carousel/aui-carousel.js", "_bindMenu", 437);
_yuitest_coverline("build/aui-carousel/aui-carousel.js", 438);
var instance = this;

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 440);
var menu = instance.nodeMenu;

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 442);
var nodeMenuItemSelector = instance.get('nodeMenuItemSelector');

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 444);
menu.delegate('click', instance._onClickDelegate, nodeMenuItemSelector, instance);

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 446);
instance.nodeMenuItemSelector = nodeMenuItemSelector;
            },

            /**
             * Clear the rotation task interval
             *
             * @method _clearIntervalRotationTask
             * @protected
             */
            _clearIntervalRotationTask: function() {
                _yuitest_coverfunc("build/aui-carousel/aui-carousel.js", "_clearIntervalRotationTask", 455);
_yuitest_coverline("build/aui-carousel/aui-carousel.js", 456);
var instance = this;

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 458);
clearInterval(instance._intervalRotationTask);
            },

            /**
             * Creates an random number to be current index
             *
             * @method _createIndexRandom
             * @protected
             */
            _createIndexRandom: function() {
                _yuitest_coverfunc("build/aui-carousel/aui-carousel.js", "_createIndexRandom", 467);
_yuitest_coverline("build/aui-carousel/aui-carousel.js", 468);
var instance = this;

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 470);
return Math.ceil(Math.random() * instance.nodeSelection.size()) - 1;
            },

            /**
             * Creates an timer for the rotation task
             *
             * @method _createIntervalRotationTask
             * @protected
             */
            _createIntervalRotationTask: function() {
                _yuitest_coverfunc("build/aui-carousel/aui-carousel.js", "_createIntervalRotationTask", 479);
_yuitest_coverline("build/aui-carousel/aui-carousel.js", 480);
var instance = this;

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 482);
instance._clearIntervalRotationTask();

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 484);
instance._intervalRotationTask = setInterval(
                    function() {
                        _yuitest_coverfunc("build/aui-carousel/aui-carousel.js", "(anonymous 2)", 485);
_yuitest_coverline("build/aui-carousel/aui-carousel.js", 486);
instance._updateIndexNext(
                            {
                                animate: true
                            }
                        );
                    },
                    instance.get('intervalTime') * 1000
                );
            },

            /**
             * Fires when animation ends
             *
             * @method _onAnimationEnd
             * @param event, newImage, oldImage, newMenuItem, oldMenuItem
             * @protected
             */
            _onAnimationEnd: function(event, newImage, oldImage, newMenuItem, oldMenuItem) {
                _yuitest_coverfunc("build/aui-carousel/aui-carousel.js", "_onAnimationEnd", 503);
_yuitest_coverline("build/aui-carousel/aui-carousel.js", 504);
var instance = this;

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 506);
if (oldImage) {
                    _yuitest_coverline("build/aui-carousel/aui-carousel.js", 507);
oldImage.removeClass(CSS_ITEM_TRANSITION);
                }

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 510);
newImage.setStyle('opacity', '1');
            },

            /**
             * Fires when animation starts
             *
             * @method _onAnimationStart
             * @param event, newImage, oldImage, newMenuItem, oldMenuItem
             * @protected
             */
            _onAnimationStart: function(event, newImage, oldImage, newMenuItem, oldMenuItem) {
                _yuitest_coverfunc("build/aui-carousel/aui-carousel.js", "_onAnimationStart", 520);
_yuitest_coverline("build/aui-carousel/aui-carousel.js", 521);
var instance = this;

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 523);
newImage.addClass(CSS_ITEM_ACTIVE);

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 525);
if (newMenuItem) {
                    _yuitest_coverline("build/aui-carousel/aui-carousel.js", 526);
newMenuItem.addClass(CSS_MENU_ACTIVE);
                }

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 529);
if (oldImage) {
                    _yuitest_coverline("build/aui-carousel/aui-carousel.js", 530);
oldImage.replaceClass(CSS_ITEM_ACTIVE, CSS_ITEM_TRANSITION);
                }

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 533);
if (oldMenuItem) {
                    _yuitest_coverline("build/aui-carousel/aui-carousel.js", 534);
oldMenuItem.removeClass(CSS_MENU_ACTIVE);
                }
            },

            /**
             * Fires when a click is fired on menu
             *
             * @method _onClickDelegate
             * @param event
             * @protected
             */
            _onClickDelegate: function(event) {
                _yuitest_coverfunc("build/aui-carousel/aui-carousel.js", "_onClickDelegate", 545);
_yuitest_coverline("build/aui-carousel/aui-carousel.js", 546);
var instance = this;

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 548);
event.preventDefault();

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 550);
var currentTarget = event.currentTarget;

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 552);
var handler;

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 554);
if (currentTarget.hasClass(CSS_MENU_INDEX)) {
                    _yuitest_coverline("build/aui-carousel/aui-carousel.js", 555);
handler = instance._onMenuItemClick;
                }
                else {_yuitest_coverline("build/aui-carousel/aui-carousel.js", 557);
if (currentTarget.hasClass(CSS_MENU_PREV)) {
                    _yuitest_coverline("build/aui-carousel/aui-carousel.js", 558);
handler = instance._updateIndexPrev;
                }
                else {_yuitest_coverline("build/aui-carousel/aui-carousel.js", 560);
if (currentTarget.hasClass(CSS_MENU_NEXT)) {
                    _yuitest_coverline("build/aui-carousel/aui-carousel.js", 561);
handler = instance._updateIndexNext;
                }
                else {_yuitest_coverline("build/aui-carousel/aui-carousel.js", 563);
if (currentTarget.test(SELECTOR_MENU_PLAY_OR_PAUSE)) {
                    _yuitest_coverline("build/aui-carousel/aui-carousel.js", 564);
handler = instance._onMenuPlayClick;
                }}}}

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 567);
if (handler) {
                    _yuitest_coverline("build/aui-carousel/aui-carousel.js", 568);
handler.apply(instance, arguments);
                }
            },

            /**
             * Executed when delegates handle menuItem click
             *
             * @method _onMenuItemClick
             * @param event
             * @protected
             */
            _onMenuItemClick: function(event) {
                _yuitest_coverfunc("build/aui-carousel/aui-carousel.js", "_onMenuItemClick", 579);
_yuitest_coverline("build/aui-carousel/aui-carousel.js", 580);
var instance = this;

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 582);
event.preventDefault();

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 584);
var newIndex = instance.menuNodes.indexOf(event.currentTarget);

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 586);
instance.set('activeIndex', newIndex, MAP_EVENT_INFO);
            },

            /**
             * Executed when delegates handle play click
             *
             * @method _onMenuPlayClick
             * @param event
             * @protected
             */
            _onMenuPlayClick: function(event) {
                _yuitest_coverfunc("build/aui-carousel/aui-carousel.js", "_onMenuPlayClick", 596);
_yuitest_coverline("build/aui-carousel/aui-carousel.js", 597);
var instance = this;

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 599);
this.set('playing', !this.get('playing'));
            },

            /**
             * Render the menu in DOM
             *
             * @method _renderMenu
             * @protected
             */
            _renderMenu: function() {
                _yuitest_coverfunc("build/aui-carousel/aui-carousel.js", "_renderMenu", 608);
_yuitest_coverline("build/aui-carousel/aui-carousel.js", 609);
var instance = this,
                    activeIndex = instance.get('activeIndex'),
                    items = [],
                    i,
                    len = instance.nodeSelection.size();

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 615);
for (i = 0; i < len; i++) {
                    _yuitest_coverline("build/aui-carousel/aui-carousel.js", 616);
items.push(
                        Lang.sub(TPL_ITEM, {
                            cssClasses: activeIndex === i ? CSS_MENU_ITEM_ACTIVE : CSS_MENU_ITEM_DEFAULT,
                            index: i
                        })
                    );
                }

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 624);
var menu = A.Node.create(Lang.sub(TPL_MENU, { items: items.join(STR_BLANK) }));

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 626);
instance.get('contentBox').appendChild(menu);

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 628);
return menu;
            },

            /**
             * Set the activeIndex attribute
             *
             * @method _setActiveIndex
             * @param val
             * @protected
             */
            _setActiveIndex: function(val) {
                _yuitest_coverfunc("build/aui-carousel/aui-carousel.js", "_setActiveIndex", 638);
_yuitest_coverline("build/aui-carousel/aui-carousel.js", 639);
var instance = this;

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 641);
if (val == 'rand') {
                    _yuitest_coverline("build/aui-carousel/aui-carousel.js", 642);
val = instance._createIndexRandom();
                }
                else {
                    _yuitest_coverline("build/aui-carousel/aui-carousel.js", 645);
val = Math.max(Math.min(val, instance.nodeSelection.size()), -1);
                }

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 648);
return val;
            },

            /**
             * Set the nodeMenu attribute
             *
             * @method _setNodeMenu
             * @param val
             * @protected
             */
            _setNodeMenu: function(val) {
                _yuitest_coverfunc("build/aui-carousel/aui-carousel.js", "_setNodeMenu", 658);
_yuitest_coverline("build/aui-carousel/aui-carousel.js", 659);
var instance = this;

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 661);
return A.one(val) || instance._renderMenu();
            },

            /**
             * Set the activeIndex on the UI
             *
             * @method _uiSetActiveIndex
             * @param newVal, objOptions
             * @protected
             */
            _uiSetActiveIndex: function(newVal, objOptions) {
                _yuitest_coverfunc("build/aui-carousel/aui-carousel.js", "_uiSetActiveIndex", 671);
_yuitest_coverline("build/aui-carousel/aui-carousel.js", 672);
var instance = this;

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 674);
var oldImage = null;
                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 675);
var oldMenuItem = null;
                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 676);
var onStart = null;
                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 677);
var onEnd = null;

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 679);
var newImage = instance.nodeSelection.item(newVal);

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 681);
var menuNodes = instance.menuNodes;

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 683);
var newMenuItem = menuNodes.item(newVal);

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 685);
instance.animation.set('node', newImage);

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 687);
if (objOptions && !Lang.isUndefined(objOptions.prevVal)) {
                    _yuitest_coverline("build/aui-carousel/aui-carousel.js", 688);
var prevVal = objOptions.prevVal;

                    _yuitest_coverline("build/aui-carousel/aui-carousel.js", 690);
newImage.setStyle('opacity', '0');

                    _yuitest_coverline("build/aui-carousel/aui-carousel.js", 692);
oldMenuItem = menuNodes.item(prevVal);
                    _yuitest_coverline("build/aui-carousel/aui-carousel.js", 693);
oldImage = instance.nodeSelection.item(prevVal);

                    _yuitest_coverline("build/aui-carousel/aui-carousel.js", 695);
oldImage.replaceClass(CSS_ITEM_ACTIVE, CSS_ITEM_TRANSITION);

                    _yuitest_coverline("build/aui-carousel/aui-carousel.js", 697);
instance.animation.stop();
                }
                else {
                    _yuitest_coverline("build/aui-carousel/aui-carousel.js", 700);
newImage.addClass(CSS_ITEM_ACTIVE);

                    _yuitest_coverline("build/aui-carousel/aui-carousel.js", 702);
newImage.setStyle('opacity', '1');
                }

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 705);
onStart = instance.animation.on(
                    'start',
                    function(event) {
                        _yuitest_coverfunc("build/aui-carousel/aui-carousel.js", "(anonymous 3)", 707);
_yuitest_coverline("build/aui-carousel/aui-carousel.js", 708);
instance._onAnimationStart(event, newImage, oldImage, newMenuItem, oldMenuItem);

                        _yuitest_coverline("build/aui-carousel/aui-carousel.js", 710);
onStart.detach();
                    }
                );

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 714);
onEnd = instance.animation.on(
                    'end',
                    function(event) {
                        _yuitest_coverfunc("build/aui-carousel/aui-carousel.js", "(anonymous 4)", 716);
_yuitest_coverline("build/aui-carousel/aui-carousel.js", 717);
instance._onAnimationEnd(event, newImage, oldImage, newMenuItem, oldMenuItem);

                        _yuitest_coverline("build/aui-carousel/aui-carousel.js", 719);
onEnd.detach();
                    }
                );

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 723);
if (objOptions) {
                    _yuitest_coverline("build/aui-carousel/aui-carousel.js", 724);
if (objOptions.animate) {
                        _yuitest_coverline("build/aui-carousel/aui-carousel.js", 725);
instance.animation.run();
                    }
                    else {
                        _yuitest_coverline("build/aui-carousel/aui-carousel.js", 728);
instance.animation.fire('start');
                        _yuitest_coverline("build/aui-carousel/aui-carousel.js", 729);
instance.animation.fire('end');
                    }

                    _yuitest_coverline("build/aui-carousel/aui-carousel.js", 732);
if (objOptions.src == UI_SRC && objOptions.animate) {
                        _yuitest_coverline("build/aui-carousel/aui-carousel.js", 733);
instance._createIntervalRotationTask();
                    }
                }
            },

            /**
             * Set the activeIndex to the next index
             *
             * @method _updateIndexNext
             * @param options
             * @protected
             */
            _updateIndexNext: function(options) {
                _yuitest_coverfunc("build/aui-carousel/aui-carousel.js", "_updateIndexNext", 745);
_yuitest_coverline("build/aui-carousel/aui-carousel.js", 746);
var instance = this;

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 748);
var currentIndex = instance.get('activeIndex');
                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 749);
var nodeSelectionSize = instance.nodeSelection.size();

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 751);
var newIndex = currentIndex + 1;

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 753);
if (newIndex > (nodeSelectionSize - 1)) {
                    _yuitest_coverline("build/aui-carousel/aui-carousel.js", 754);
newIndex = 0;
                }

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 757);
if (options) {
                    _yuitest_coverline("build/aui-carousel/aui-carousel.js", 758);
options.src = UI_SRC;
                }

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 761);
instance.set('activeIndex', newIndex, options);
            },

            /**
             * Set the activeIndex to the previous index
             *
             * @method _updateIndexPrev
             * @param options
             * @protected
             */
            _updateIndexPrev: function(options) {
                _yuitest_coverfunc("build/aui-carousel/aui-carousel.js", "_updateIndexPrev", 771);
_yuitest_coverline("build/aui-carousel/aui-carousel.js", 772);
var instance = this;

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 774);
var currentIndex = instance.get('activeIndex');

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 776);
var newIndex = currentIndex - 1;

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 778);
if (newIndex < 0) {
                    _yuitest_coverline("build/aui-carousel/aui-carousel.js", 779);
newIndex = instance.nodeSelection.size() - 1;
                }

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 782);
if (options) {
                    _yuitest_coverline("build/aui-carousel/aui-carousel.js", 783);
options.src = UI_SRC;
                }

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 786);
instance.set('activeIndex', newIndex, options);
            },

            /**
             * Set the menuNodes attribute based on the selector menu index
             *
             * @method _updateMenuNodes
             * @param options
             * @protected
             */
            _updateMenuNodes: function() {
                _yuitest_coverfunc("build/aui-carousel/aui-carousel.js", "_updateMenuNodes", 796);
_yuitest_coverline("build/aui-carousel/aui-carousel.js", 797);
var instance = this;

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 799);
instance.menuNodes = instance.nodeMenu.all(SELECTOR_MENU_INDEX);
            },

            /**
             * Upates the nodeSelecton by adding the CSS_ITEM class
             *
             * @method _updateMenuNodes
             * @param options
             * @protected
             */
            _updateNodeSelection: function() {
                _yuitest_coverfunc("build/aui-carousel/aui-carousel.js", "_updateNodeSelection", 809);
_yuitest_coverline("build/aui-carousel/aui-carousel.js", 810);
var instance = this;

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 812);
var itemSelector = instance.get('itemSelector');

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 814);
var nodeSelection = instance.get('contentBox').all(itemSelector);

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 816);
nodeSelection.addClass(CSS_ITEM);

                _yuitest_coverline("build/aui-carousel/aui-carousel.js", 818);
instance.nodeSelection = nodeSelection;
            },

            _intervalRotationTask: null
        }
    }
);

_yuitest_coverline("build/aui-carousel/aui-carousel.js", 826);
A.Carousel = Carousel;

}, '2.0.0pr1', {"requires": ["anim", "node-event-delegate", "aui-component"], "skinnable": true});
