if (typeof _yuitest_coverage == "undefined"){
    _yuitest_coverage = {};
    _yuitest_coverline = function(src, line){
        var coverage = _yuitest_coverage[src];
        if (!coverage.lines[line]){
            coverage.calledLines++;
        }
        coverage.lines[line]++;
    };
    _yuitest_coverfunc = function(src, name, line){
        var coverage = _yuitest_coverage[src],
            funcId = name + ":" + line;
        if (!coverage.functions[funcId]){
            coverage.calledFunctions++;
        }
        coverage.functions[funcId]++;
    };
}
_yuitest_coverage["build/aui-component/aui-component.js"] = {
    lines: {},
    functions: {},
    coveredLines: 0,
    calledLines: 0,
    coveredFunctions: 0,
    calledFunctions: 0,
    path: "build/aui-component/aui-component.js",
    code: []
};
_yuitest_coverage["build/aui-component/aui-component.js"].code=["YUI.add('aui-component', function (A, NAME) {","","/**"," * The Component Utility"," *"," * @module aui-component"," */","","var Lang = A.Lang,","","	concat = function(arr, arr2) {","		return (arr || []).concat(arr2 || []);","	},","","	getClassName = A.getClassName,","","	NAME = 'component',","","	CSS_HIDE = getClassName('hide'),","	CONSTRUCTOR_OBJECT = A.config.win.Object.prototype.constructor;","","/**"," * A base class for Component, providing:"," * <ul>"," *    <li>Widget Lifecycle (initializer, renderUI, bindUI, syncUI, destructor)</li>"," *    <li></li>"," * </ul>"," *"," * Check the list of <a href=\"Component.html#configattributes\">Configuration Attributes</a> available for"," * Component."," *"," * @param config {Object} Object literal specifying widget configuration properties."," *"," * @class Component"," * @constructor"," * @extends Widget"," */","var Component = function(config) {","	var instance = this;","","	instance._originalConfig = config;","","	instance._setRender(config);","","	Component.superclass.constructor.apply(this, arguments);","","	INSTANCES[instance.get('id')] = instance;","};","","var INSTANCES = Component._INSTANCES = {};","","/**"," * Static property provides a string to identify the class."," *"," * @property Component.NAME"," * @type String"," * @static"," */","Component.NAME = 'component';","","/**"," * Static property used to define the default attribute"," * configuration for the Component."," *"," * @property Component.ATTRS"," * @type Object"," * @static"," */","Component.ATTRS = {","	/**","	* Boolean indicating if use of the WAI-ARIA Roles and States should be","	* enabled for the Widget.","	*","	* @attribute useARIA","	* @readOnly","	* @writeOnce","	* @default true","	* @type boolean","	*/","	useARIA: {","		writeOnce: true,","		value: false,","		validator: Lang.isBoolean","	},","","	/**","	 * CSS class to be automatically added to the <code>boundingBox</code>.","	 *","	 * @attribute cssClass","	 * @default null","	 * @type String","	 */","	cssClass: {","		lazyAdd: false,","		value: null","	},","","	/**","	 * css class added to hide the <code>boundingBox</code> when","     * <a href=\"Component.html#config_visible\">visible</a> is set to","     * <code>false</code>.","	 *","	 * @attribute hideClass","	 * @default 'aui-hide'","	 * @type String","	 */","	hideClass: {","		value: CSS_HIDE","	},","","	/**","	 * If <code>true</code> the render phase will be autimatically invoked","     * preventing the <code>.render()</code> manual call.","	 *","	 * @attribute render","	 * @default false","	 * @type boolean | Node","	 */","	render: {","		value: false,","		writeOnce: true","	}","};","","A.extend(","	Component,","	A.Widget,","	{","		/**","		 * Construction logic executed during Component instantiation. Lifecycle.","		 *","		 * @method initializer","		 * @protected","		 */","		initializer: function(config) {","			var instance = this;","","			if (config && config.cssClass) {","				instance._uiSetCssClass(config.cssClass);","			}","","			instance._setComponentClassNames();","","			instance.after('cssClassChange', instance._afterCssClassChange);","		},","","		/**","		 * Clone the current Component.","		 *","		 * @method clone","		 * @param {Object} config","		 * @return {Widget} Cloned instance.","		 */","		clone: function(config) {","			var instance = this;","","			config = config || {};","","			config.id = config.id || A.guid();","","			A.mix(config, instance._originalConfig);","","			return new instance.constructor(config);","		},","","		/**","		 * Toggle the visibility of the Panel toggling the value of the","	     * <a href=\"Widget.html#config_visible\">visible</a> attribute.","		 *","		 * @method toggle","		 * @param visible Force the visibility of the component to this state.","		 */","		toggle: function(visible) {","			var instance = this;","","			if (!Lang.isBoolean(visible)) {","				visible = !instance.get('visible');","			}","","			return instance.set('visible', visible);","		},","","		_uiSetVisible: function(value) {","			var instance = this;","","			var superUISetVisible = Component.superclass._uiSetVisible;","","			if (superUISetVisible) {","				superUISetVisible.apply(instance, arguments);","			}","","			var hideClass = instance.get('hideClass');","","			if (hideClass !== false) {","				var boundingBox = instance.get('boundingBox');","","				boundingBox.toggleClass(hideClass || CSS_HIDE, !value);","			}","		},","","		/**","		 * Fires after the value of the","		 * <a href=\"Component.html#config_cssClass\">cssClass</a> attribute change.","		 *","		 * @method _afterCssClassChange","		 * @param {EventFacade} event","		 * @protected","		 */","		_afterCssClassChange: function(event) {","			var instance = this;","","			instance._uiSetCssClass(event.newVal, event.prevVal);","		},","","		/**","		 * Renders the Component based upon a passed in interaction.","		 *","		 * @method _renderInteraction","		 * @protected","		 */","		_renderInteraction: function(event, parentNode) {","			var instance = this;","","			instance.render(parentNode);","","			var renderHandles = instance._renderHandles;","","			for (var i = renderHandles.length - 1; i >= 0; i--) {","				var handle = renderHandles.pop();","","				handle.detach();","			}","		},","","		/**","		 * Set the class names on the Component <code>contentBox</code>.","		 *","		 * @method _setComponentClassNames","		 * @protected","		 */","		_setComponentClassNames: function() {","			var instance = this;","","			var classes = instance._getClasses();","			var name;","			var buffer = [];","","			for (var i = classes.length - 4; i >= 0; i--) {","				name = String(classes[i].NAME).toLowerCase();","","				buffer.push(getClassName(name, 'content'));","			}","","			instance.get('contentBox').addClass(buffer.join(' '));","		},","","		/**","		 * Set the interaction and render behavior based upon an object","		 * (intercepts the default rendering behavior).","		 *","		 * @method _setRender","		 * @protected","		 */","		_setRender: function(config) {","			var instance = this;","","			var render = config && config.render;","","			if (render && render.constructor == CONSTRUCTOR_OBJECT) {","				var eventType = render.eventType || 'mousemove';","				var parentNode = render.parentNode;","				var selector = render.selector || parentNode;","","				if (selector) {","					instance._renderHandles = [];","","					var renderHandles = instance._renderHandles;","","					if (!Lang.isArray(eventType)) {","						eventType = [eventType];","					}","","					var renderInteraction = A.rbind(instance._renderInteraction, instance, parentNode);","","					var interactionNode = A.one(selector);","","					for (var i = eventType.length - 1; i >= 0; i--) {","						renderHandles[i] = interactionNode.once(eventType[i], renderInteraction);","					}","","					delete config.render;","				}","			}","		},","","		/**","		 * Applies the CSS classes to the <code>boundingBox</code> and","         * <code>contentBox</code>.","		 *","		 * @method _uiSetCssClass","		 * @protected","		 * @param {String} newVal","		 * @param {String} prevVal","		 */","		_uiSetCssClass: function(newVal, prevVal) {","			var instance = this;","","			var prevValContent = prevVal + '-content';","","			var newValContent = newVal + '-content';","","			var boundingBox = instance.get('boundingBox');","			var contentBox = instance.get('contentBox');","","			boundingBox.replaceClass(prevVal, newVal);","			contentBox.replaceClass(prevValContent, newValContent);","		}","	}",");","","Component.getById = function(id) {","	return INSTANCES[id];","};","","var COMP_PROTO = Component.prototype;","","var DEFAULT_UI_ATTRS = A.Widget.prototype._UI_ATTRS;","","Component._applyCssPrefix = function(component) {","	if (component && component.NAME && !('CSS_PREFIX' in component)) {","		component.CSS_PREFIX = A.getClassName(String(component.NAME).toLowerCase());","	}","","	return component;","};","","Component.create = function(config) {","	config = config || {};","","	var extendsClass = config.EXTENDS || A.Component;","","	var component = config.constructor;","","	if (!A.Object.owns(config, 'constructor')){","		component = function(){","			component.superclass.constructor.apply(this, arguments);","		};","	}","","	var configProto = config.prototype;","","	if (configProto) {","		if (config.UI_ATTRS || config.BIND_UI_ATTRS || config.SYNC_UI_ATTRS) {","			var BIND_UI_ATTRS = concat(config.BIND_UI_ATTRS, config.UI_ATTRS);","			var SYNC_UI_ATTRS = concat(config.SYNC_UI_ATTRS, config.UI_ATTRS);","","			var extendsProto = extendsClass.prototype;","			var extendsUIAttrs = (extendsProto && extendsProto._UI_ATTRS) || DEFAULT_UI_ATTRS;","","			BIND_UI_ATTRS = concat(extendsUIAttrs.BIND, BIND_UI_ATTRS);","			SYNC_UI_ATTRS = concat(extendsUIAttrs.SYNC, SYNC_UI_ATTRS);","","			var configProtoUIAttrs = configProto._UI_ATTRS;","","			if (!configProtoUIAttrs) {","				configProtoUIAttrs = configProto._UI_ATTRS = {};","			}","","			if (BIND_UI_ATTRS.length) {","				configProtoUIAttrs.BIND = BIND_UI_ATTRS;","			}","","			if (SYNC_UI_ATTRS.length) {","				configProtoUIAttrs.SYNC = SYNC_UI_ATTRS;","			}","		}","	}","","	var augmentsClasses = config.AUGMENTS;","","	if (augmentsClasses && !Lang.isArray(augmentsClasses)) {","		augmentsClasses = [augmentsClasses];","	}","","	A.mix(component, config);","","	delete component.prototype;","","	A.extend(component, extendsClass, configProto);","","	if (augmentsClasses) {","		component = A.Base.build(config.NAME, component, augmentsClasses, { dynamic: false });","	}","","	Component._applyCssPrefix(component);","","	return component;","};","","Component.CSS_PREFIX = getClassName('component');","","var Base = A.Base;","","Component.build = function() {","	var component = Base.build.apply(Base, arguments);","","	Component._applyCssPrefix(component);","","	return component;","};","","A.Component = Component;","","}, '2.0.0pr1', {\"requires\": [\"aui-classnamemanager\", \"base-build\", \"widget-base\"]});"];
_yuitest_coverage["build/aui-component/aui-component.js"].lines = {"1":0,"9":0,"12":0,"38":0,"39":0,"41":0,"43":0,"45":0,"47":0,"50":0,"59":0,"69":0,"125":0,"136":0,"138":0,"139":0,"142":0,"144":0,"155":0,"157":0,"159":0,"161":0,"163":0,"174":0,"176":0,"177":0,"180":0,"184":0,"186":0,"188":0,"189":0,"192":0,"194":0,"195":0,"197":0,"210":0,"212":0,"222":0,"224":0,"226":0,"228":0,"229":0,"231":0,"242":0,"244":0,"245":0,"246":0,"248":0,"249":0,"251":0,"254":0,"265":0,"267":0,"269":0,"270":0,"271":0,"272":0,"274":0,"275":0,"277":0,"279":0,"280":0,"283":0,"285":0,"287":0,"288":0,"291":0,"306":0,"308":0,"310":0,"312":0,"313":0,"315":0,"316":0,"321":0,"322":0,"325":0,"327":0,"329":0,"330":0,"331":0,"334":0,"337":0,"338":0,"340":0,"342":0,"344":0,"345":0,"346":0,"350":0,"352":0,"353":0,"354":0,"355":0,"357":0,"358":0,"360":0,"361":0,"363":0,"365":0,"366":0,"369":0,"370":0,"373":0,"374":0,"379":0,"381":0,"382":0,"385":0,"387":0,"389":0,"391":0,"392":0,"395":0,"397":0,"400":0,"402":0,"404":0,"405":0,"407":0,"409":0,"412":0};
_yuitest_coverage["build/aui-component/aui-component.js"].functions = {"concat:11":0,"Component:38":0,"initializer:135":0,"clone:154":0,"toggle:173":0,"_uiSetVisible:183":0,"_afterCssClassChange:209":0,"_renderInteraction:221":0,"_setComponentClassNames:241":0,"_setRender:264":0,"_uiSetCssClass:305":0,"getById:321":0,"_applyCssPrefix:329":0,"component:345":0,"create:337":0,"build:404":0,"(anonymous 1):1":0};
_yuitest_coverage["build/aui-component/aui-component.js"].coveredLines = 122;
_yuitest_coverage["build/aui-component/aui-component.js"].coveredFunctions = 17;
_yuitest_coverline("build/aui-component/aui-component.js", 1);
YUI.add('aui-component', function (A, NAME) {

/**
 * The Component Utility
 *
 * @module aui-component
 */

_yuitest_coverfunc("build/aui-component/aui-component.js", "(anonymous 1)", 1);
_yuitest_coverline("build/aui-component/aui-component.js", 9);
var Lang = A.Lang,

	concat = function(arr, arr2) {
		_yuitest_coverfunc("build/aui-component/aui-component.js", "concat", 11);
_yuitest_coverline("build/aui-component/aui-component.js", 12);
return (arr || []).concat(arr2 || []);
	},

	getClassName = A.getClassName,

	NAME = 'component',

	CSS_HIDE = getClassName('hide'),
	CONSTRUCTOR_OBJECT = A.config.win.Object.prototype.constructor;

/**
 * A base class for Component, providing:
 * <ul>
 *    <li>Widget Lifecycle (initializer, renderUI, bindUI, syncUI, destructor)</li>
 *    <li></li>
 * </ul>
 *
 * Check the list of <a href="Component.html#configattributes">Configuration Attributes</a> available for
 * Component.
 *
 * @param config {Object} Object literal specifying widget configuration properties.
 *
 * @class Component
 * @constructor
 * @extends Widget
 */
_yuitest_coverline("build/aui-component/aui-component.js", 38);
var Component = function(config) {
	_yuitest_coverfunc("build/aui-component/aui-component.js", "Component", 38);
_yuitest_coverline("build/aui-component/aui-component.js", 39);
var instance = this;

	_yuitest_coverline("build/aui-component/aui-component.js", 41);
instance._originalConfig = config;

	_yuitest_coverline("build/aui-component/aui-component.js", 43);
instance._setRender(config);

	_yuitest_coverline("build/aui-component/aui-component.js", 45);
Component.superclass.constructor.apply(this, arguments);

	_yuitest_coverline("build/aui-component/aui-component.js", 47);
INSTANCES[instance.get('id')] = instance;
};

_yuitest_coverline("build/aui-component/aui-component.js", 50);
var INSTANCES = Component._INSTANCES = {};

/**
 * Static property provides a string to identify the class.
 *
 * @property Component.NAME
 * @type String
 * @static
 */
_yuitest_coverline("build/aui-component/aui-component.js", 59);
Component.NAME = 'component';

/**
 * Static property used to define the default attribute
 * configuration for the Component.
 *
 * @property Component.ATTRS
 * @type Object
 * @static
 */
_yuitest_coverline("build/aui-component/aui-component.js", 69);
Component.ATTRS = {
	/**
	* Boolean indicating if use of the WAI-ARIA Roles and States should be
	* enabled for the Widget.
	*
	* @attribute useARIA
	* @readOnly
	* @writeOnce
	* @default true
	* @type boolean
	*/
	useARIA: {
		writeOnce: true,
		value: false,
		validator: Lang.isBoolean
	},

	/**
	 * CSS class to be automatically added to the <code>boundingBox</code>.
	 *
	 * @attribute cssClass
	 * @default null
	 * @type String
	 */
	cssClass: {
		lazyAdd: false,
		value: null
	},

	/**
	 * css class added to hide the <code>boundingBox</code> when
     * <a href="Component.html#config_visible">visible</a> is set to
     * <code>false</code>.
	 *
	 * @attribute hideClass
	 * @default 'aui-hide'
	 * @type String
	 */
	hideClass: {
		value: CSS_HIDE
	},

	/**
	 * If <code>true</code> the render phase will be autimatically invoked
     * preventing the <code>.render()</code> manual call.
	 *
	 * @attribute render
	 * @default false
	 * @type boolean | Node
	 */
	render: {
		value: false,
		writeOnce: true
	}
};

_yuitest_coverline("build/aui-component/aui-component.js", 125);
A.extend(
	Component,
	A.Widget,
	{
		/**
		 * Construction logic executed during Component instantiation. Lifecycle.
		 *
		 * @method initializer
		 * @protected
		 */
		initializer: function(config) {
			_yuitest_coverfunc("build/aui-component/aui-component.js", "initializer", 135);
_yuitest_coverline("build/aui-component/aui-component.js", 136);
var instance = this;

			_yuitest_coverline("build/aui-component/aui-component.js", 138);
if (config && config.cssClass) {
				_yuitest_coverline("build/aui-component/aui-component.js", 139);
instance._uiSetCssClass(config.cssClass);
			}

			_yuitest_coverline("build/aui-component/aui-component.js", 142);
instance._setComponentClassNames();

			_yuitest_coverline("build/aui-component/aui-component.js", 144);
instance.after('cssClassChange', instance._afterCssClassChange);
		},

		/**
		 * Clone the current Component.
		 *
		 * @method clone
		 * @param {Object} config
		 * @return {Widget} Cloned instance.
		 */
		clone: function(config) {
			_yuitest_coverfunc("build/aui-component/aui-component.js", "clone", 154);
_yuitest_coverline("build/aui-component/aui-component.js", 155);
var instance = this;

			_yuitest_coverline("build/aui-component/aui-component.js", 157);
config = config || {};

			_yuitest_coverline("build/aui-component/aui-component.js", 159);
config.id = config.id || A.guid();

			_yuitest_coverline("build/aui-component/aui-component.js", 161);
A.mix(config, instance._originalConfig);

			_yuitest_coverline("build/aui-component/aui-component.js", 163);
return new instance.constructor(config);
		},

		/**
		 * Toggle the visibility of the Panel toggling the value of the
	     * <a href="Widget.html#config_visible">visible</a> attribute.
		 *
		 * @method toggle
		 * @param visible Force the visibility of the component to this state.
		 */
		toggle: function(visible) {
			_yuitest_coverfunc("build/aui-component/aui-component.js", "toggle", 173);
_yuitest_coverline("build/aui-component/aui-component.js", 174);
var instance = this;

			_yuitest_coverline("build/aui-component/aui-component.js", 176);
if (!Lang.isBoolean(visible)) {
				_yuitest_coverline("build/aui-component/aui-component.js", 177);
visible = !instance.get('visible');
			}

			_yuitest_coverline("build/aui-component/aui-component.js", 180);
return instance.set('visible', visible);
		},

		_uiSetVisible: function(value) {
			_yuitest_coverfunc("build/aui-component/aui-component.js", "_uiSetVisible", 183);
_yuitest_coverline("build/aui-component/aui-component.js", 184);
var instance = this;

			_yuitest_coverline("build/aui-component/aui-component.js", 186);
var superUISetVisible = Component.superclass._uiSetVisible;

			_yuitest_coverline("build/aui-component/aui-component.js", 188);
if (superUISetVisible) {
				_yuitest_coverline("build/aui-component/aui-component.js", 189);
superUISetVisible.apply(instance, arguments);
			}

			_yuitest_coverline("build/aui-component/aui-component.js", 192);
var hideClass = instance.get('hideClass');

			_yuitest_coverline("build/aui-component/aui-component.js", 194);
if (hideClass !== false) {
				_yuitest_coverline("build/aui-component/aui-component.js", 195);
var boundingBox = instance.get('boundingBox');

				_yuitest_coverline("build/aui-component/aui-component.js", 197);
boundingBox.toggleClass(hideClass || CSS_HIDE, !value);
			}
		},

		/**
		 * Fires after the value of the
		 * <a href="Component.html#config_cssClass">cssClass</a> attribute change.
		 *
		 * @method _afterCssClassChange
		 * @param {EventFacade} event
		 * @protected
		 */
		_afterCssClassChange: function(event) {
			_yuitest_coverfunc("build/aui-component/aui-component.js", "_afterCssClassChange", 209);
_yuitest_coverline("build/aui-component/aui-component.js", 210);
var instance = this;

			_yuitest_coverline("build/aui-component/aui-component.js", 212);
instance._uiSetCssClass(event.newVal, event.prevVal);
		},

		/**
		 * Renders the Component based upon a passed in interaction.
		 *
		 * @method _renderInteraction
		 * @protected
		 */
		_renderInteraction: function(event, parentNode) {
			_yuitest_coverfunc("build/aui-component/aui-component.js", "_renderInteraction", 221);
_yuitest_coverline("build/aui-component/aui-component.js", 222);
var instance = this;

			_yuitest_coverline("build/aui-component/aui-component.js", 224);
instance.render(parentNode);

			_yuitest_coverline("build/aui-component/aui-component.js", 226);
var renderHandles = instance._renderHandles;

			_yuitest_coverline("build/aui-component/aui-component.js", 228);
for (var i = renderHandles.length - 1; i >= 0; i--) {
				_yuitest_coverline("build/aui-component/aui-component.js", 229);
var handle = renderHandles.pop();

				_yuitest_coverline("build/aui-component/aui-component.js", 231);
handle.detach();
			}
		},

		/**
		 * Set the class names on the Component <code>contentBox</code>.
		 *
		 * @method _setComponentClassNames
		 * @protected
		 */
		_setComponentClassNames: function() {
			_yuitest_coverfunc("build/aui-component/aui-component.js", "_setComponentClassNames", 241);
_yuitest_coverline("build/aui-component/aui-component.js", 242);
var instance = this;

			_yuitest_coverline("build/aui-component/aui-component.js", 244);
var classes = instance._getClasses();
			_yuitest_coverline("build/aui-component/aui-component.js", 245);
var name;
			_yuitest_coverline("build/aui-component/aui-component.js", 246);
var buffer = [];

			_yuitest_coverline("build/aui-component/aui-component.js", 248);
for (var i = classes.length - 4; i >= 0; i--) {
				_yuitest_coverline("build/aui-component/aui-component.js", 249);
name = String(classes[i].NAME).toLowerCase();

				_yuitest_coverline("build/aui-component/aui-component.js", 251);
buffer.push(getClassName(name, 'content'));
			}

			_yuitest_coverline("build/aui-component/aui-component.js", 254);
instance.get('contentBox').addClass(buffer.join(' '));
		},

		/**
		 * Set the interaction and render behavior based upon an object
		 * (intercepts the default rendering behavior).
		 *
		 * @method _setRender
		 * @protected
		 */
		_setRender: function(config) {
			_yuitest_coverfunc("build/aui-component/aui-component.js", "_setRender", 264);
_yuitest_coverline("build/aui-component/aui-component.js", 265);
var instance = this;

			_yuitest_coverline("build/aui-component/aui-component.js", 267);
var render = config && config.render;

			_yuitest_coverline("build/aui-component/aui-component.js", 269);
if (render && render.constructor == CONSTRUCTOR_OBJECT) {
				_yuitest_coverline("build/aui-component/aui-component.js", 270);
var eventType = render.eventType || 'mousemove';
				_yuitest_coverline("build/aui-component/aui-component.js", 271);
var parentNode = render.parentNode;
				_yuitest_coverline("build/aui-component/aui-component.js", 272);
var selector = render.selector || parentNode;

				_yuitest_coverline("build/aui-component/aui-component.js", 274);
if (selector) {
					_yuitest_coverline("build/aui-component/aui-component.js", 275);
instance._renderHandles = [];

					_yuitest_coverline("build/aui-component/aui-component.js", 277);
var renderHandles = instance._renderHandles;

					_yuitest_coverline("build/aui-component/aui-component.js", 279);
if (!Lang.isArray(eventType)) {
						_yuitest_coverline("build/aui-component/aui-component.js", 280);
eventType = [eventType];
					}

					_yuitest_coverline("build/aui-component/aui-component.js", 283);
var renderInteraction = A.rbind(instance._renderInteraction, instance, parentNode);

					_yuitest_coverline("build/aui-component/aui-component.js", 285);
var interactionNode = A.one(selector);

					_yuitest_coverline("build/aui-component/aui-component.js", 287);
for (var i = eventType.length - 1; i >= 0; i--) {
						_yuitest_coverline("build/aui-component/aui-component.js", 288);
renderHandles[i] = interactionNode.once(eventType[i], renderInteraction);
					}

					_yuitest_coverline("build/aui-component/aui-component.js", 291);
delete config.render;
				}
			}
		},

		/**
		 * Applies the CSS classes to the <code>boundingBox</code> and
         * <code>contentBox</code>.
		 *
		 * @method _uiSetCssClass
		 * @protected
		 * @param {String} newVal
		 * @param {String} prevVal
		 */
		_uiSetCssClass: function(newVal, prevVal) {
			_yuitest_coverfunc("build/aui-component/aui-component.js", "_uiSetCssClass", 305);
_yuitest_coverline("build/aui-component/aui-component.js", 306);
var instance = this;

			_yuitest_coverline("build/aui-component/aui-component.js", 308);
var prevValContent = prevVal + '-content';

			_yuitest_coverline("build/aui-component/aui-component.js", 310);
var newValContent = newVal + '-content';

			_yuitest_coverline("build/aui-component/aui-component.js", 312);
var boundingBox = instance.get('boundingBox');
			_yuitest_coverline("build/aui-component/aui-component.js", 313);
var contentBox = instance.get('contentBox');

			_yuitest_coverline("build/aui-component/aui-component.js", 315);
boundingBox.replaceClass(prevVal, newVal);
			_yuitest_coverline("build/aui-component/aui-component.js", 316);
contentBox.replaceClass(prevValContent, newValContent);
		}
	}
);

_yuitest_coverline("build/aui-component/aui-component.js", 321);
Component.getById = function(id) {
	_yuitest_coverfunc("build/aui-component/aui-component.js", "getById", 321);
_yuitest_coverline("build/aui-component/aui-component.js", 322);
return INSTANCES[id];
};

_yuitest_coverline("build/aui-component/aui-component.js", 325);
var COMP_PROTO = Component.prototype;

_yuitest_coverline("build/aui-component/aui-component.js", 327);
var DEFAULT_UI_ATTRS = A.Widget.prototype._UI_ATTRS;

_yuitest_coverline("build/aui-component/aui-component.js", 329);
Component._applyCssPrefix = function(component) {
	_yuitest_coverfunc("build/aui-component/aui-component.js", "_applyCssPrefix", 329);
_yuitest_coverline("build/aui-component/aui-component.js", 330);
if (component && component.NAME && !('CSS_PREFIX' in component)) {
		_yuitest_coverline("build/aui-component/aui-component.js", 331);
component.CSS_PREFIX = A.getClassName(String(component.NAME).toLowerCase());
	}

	_yuitest_coverline("build/aui-component/aui-component.js", 334);
return component;
};

_yuitest_coverline("build/aui-component/aui-component.js", 337);
Component.create = function(config) {
	_yuitest_coverfunc("build/aui-component/aui-component.js", "create", 337);
_yuitest_coverline("build/aui-component/aui-component.js", 338);
config = config || {};

	_yuitest_coverline("build/aui-component/aui-component.js", 340);
var extendsClass = config.EXTENDS || A.Component;

	_yuitest_coverline("build/aui-component/aui-component.js", 342);
var component = config.constructor;

	_yuitest_coverline("build/aui-component/aui-component.js", 344);
if (!A.Object.owns(config, 'constructor')){
		_yuitest_coverline("build/aui-component/aui-component.js", 345);
component = function(){
			_yuitest_coverfunc("build/aui-component/aui-component.js", "component", 345);
_yuitest_coverline("build/aui-component/aui-component.js", 346);
component.superclass.constructor.apply(this, arguments);
		};
	}

	_yuitest_coverline("build/aui-component/aui-component.js", 350);
var configProto = config.prototype;

	_yuitest_coverline("build/aui-component/aui-component.js", 352);
if (configProto) {
		_yuitest_coverline("build/aui-component/aui-component.js", 353);
if (config.UI_ATTRS || config.BIND_UI_ATTRS || config.SYNC_UI_ATTRS) {
			_yuitest_coverline("build/aui-component/aui-component.js", 354);
var BIND_UI_ATTRS = concat(config.BIND_UI_ATTRS, config.UI_ATTRS);
			_yuitest_coverline("build/aui-component/aui-component.js", 355);
var SYNC_UI_ATTRS = concat(config.SYNC_UI_ATTRS, config.UI_ATTRS);

			_yuitest_coverline("build/aui-component/aui-component.js", 357);
var extendsProto = extendsClass.prototype;
			_yuitest_coverline("build/aui-component/aui-component.js", 358);
var extendsUIAttrs = (extendsProto && extendsProto._UI_ATTRS) || DEFAULT_UI_ATTRS;

			_yuitest_coverline("build/aui-component/aui-component.js", 360);
BIND_UI_ATTRS = concat(extendsUIAttrs.BIND, BIND_UI_ATTRS);
			_yuitest_coverline("build/aui-component/aui-component.js", 361);
SYNC_UI_ATTRS = concat(extendsUIAttrs.SYNC, SYNC_UI_ATTRS);

			_yuitest_coverline("build/aui-component/aui-component.js", 363);
var configProtoUIAttrs = configProto._UI_ATTRS;

			_yuitest_coverline("build/aui-component/aui-component.js", 365);
if (!configProtoUIAttrs) {
				_yuitest_coverline("build/aui-component/aui-component.js", 366);
configProtoUIAttrs = configProto._UI_ATTRS = {};
			}

			_yuitest_coverline("build/aui-component/aui-component.js", 369);
if (BIND_UI_ATTRS.length) {
				_yuitest_coverline("build/aui-component/aui-component.js", 370);
configProtoUIAttrs.BIND = BIND_UI_ATTRS;
			}

			_yuitest_coverline("build/aui-component/aui-component.js", 373);
if (SYNC_UI_ATTRS.length) {
				_yuitest_coverline("build/aui-component/aui-component.js", 374);
configProtoUIAttrs.SYNC = SYNC_UI_ATTRS;
			}
		}
	}

	_yuitest_coverline("build/aui-component/aui-component.js", 379);
var augmentsClasses = config.AUGMENTS;

	_yuitest_coverline("build/aui-component/aui-component.js", 381);
if (augmentsClasses && !Lang.isArray(augmentsClasses)) {
		_yuitest_coverline("build/aui-component/aui-component.js", 382);
augmentsClasses = [augmentsClasses];
	}

	_yuitest_coverline("build/aui-component/aui-component.js", 385);
A.mix(component, config);

	_yuitest_coverline("build/aui-component/aui-component.js", 387);
delete component.prototype;

	_yuitest_coverline("build/aui-component/aui-component.js", 389);
A.extend(component, extendsClass, configProto);

	_yuitest_coverline("build/aui-component/aui-component.js", 391);
if (augmentsClasses) {
		_yuitest_coverline("build/aui-component/aui-component.js", 392);
component = A.Base.build(config.NAME, component, augmentsClasses, { dynamic: false });
	}

	_yuitest_coverline("build/aui-component/aui-component.js", 395);
Component._applyCssPrefix(component);

	_yuitest_coverline("build/aui-component/aui-component.js", 397);
return component;
};

_yuitest_coverline("build/aui-component/aui-component.js", 400);
Component.CSS_PREFIX = getClassName('component');

_yuitest_coverline("build/aui-component/aui-component.js", 402);
var Base = A.Base;

_yuitest_coverline("build/aui-component/aui-component.js", 404);
Component.build = function() {
	_yuitest_coverfunc("build/aui-component/aui-component.js", "build", 404);
_yuitest_coverline("build/aui-component/aui-component.js", 405);
var component = Base.build.apply(Base, arguments);

	_yuitest_coverline("build/aui-component/aui-component.js", 407);
Component._applyCssPrefix(component);

	_yuitest_coverline("build/aui-component/aui-component.js", 409);
return component;
};

_yuitest_coverline("build/aui-component/aui-component.js", 412);
A.Component = Component;

}, '2.0.0pr1', {"requires": ["aui-classnamemanager", "base-build", "widget-base"]});
