if (typeof _yuitest_coverage == "undefined"){
    _yuitest_coverage = {};
    _yuitest_coverline = function(src, line){
        var coverage = _yuitest_coverage[src];
        if (!coverage.lines[line]){
            coverage.calledLines++;
        }
        coverage.lines[line]++;
    };
    _yuitest_coverfunc = function(src, name, line){
        var coverage = _yuitest_coverage[src],
            funcId = name + ":" + line;
        if (!coverage.functions[funcId]){
            coverage.calledFunctions++;
        }
        coverage.functions[funcId]++;
    };
}
_yuitest_coverage["build/aui-datatype/aui-datatype.js"] = {
    lines: {},
    functions: {},
    coveredLines: 0,
    calledLines: 0,
    coveredFunctions: 0,
    calledFunctions: 0,
    path: "build/aui-datatype/aui-datatype.js",
    code: []
};
_yuitest_coverage["build/aui-datatype/aui-datatype.js"].code=["YUI.add('aui-datatype', function (A, NAME) {","","/**"," * The Datatype Utility"," *"," * @module aui-datatype"," */","","var L = A.Lang,","	FALSE = 'false',","	TRUE = 'true',","","	NUM_SIXTY = 60,","	NUM_THOUSAND = 1000,","	NUM_TWENTY_FOUR = 24,","","	/**","	 * DataType.Boolean provides a set of utility to parse <code>falsey</code>","     * value to <code>false</code> and <code>non-falsey</code> to","     * <code>true</code>.","	 *","	 * @class DataType.Boolean","	 * @static","	 */","	DB = A.namespace('DataType.Boolean'),","","	/**","	 * DataType.String provides a set of utility to provides a simple function","     * that evaluates a string to a primitive value (if possible). Supports","     * <code>true</code> and <code>false</code> also.","	 *","	 * @class DataType.String","	 * @static","	 */","	DS = A.namespace('DataType.String');","","/**"," * Parses any <code>falsey</code> value to <code>false</code> and"," * <code>non-falsey</code> to <code>true</code>."," *"," * @for DataType.Boolean"," * @method parse"," * @param {*} data falsey or non-falsey values (i.e., falsey values: null, false, undefined, NaN; non-falsey values: 1, true, 'abc')."," * @return {boolean} Parsed value"," */","DB.parse = function(data) {","	data = A.Lang.trim(data);","","	return (data == FALSE) ? false : !!data;","};","","/**"," * Evaluates a string to a primitive value (if possible). Supports"," * <code>true</code> and <code>false</code> also. Unrecognized strings are"," * returned without any modification."," *"," * @for DataType.String"," * @method evaluate"," * @param {*} data Input data to be evaluated."," * @return {boolean | null | number | String | undefined} Parsed value"," */","DS.evaluate = function(data) {","	var trimmedData = A.Lang.trim(data);","","	// booleans","	if (trimmedData == TRUE || trimmedData == FALSE) {","		return DB.parse(data);","	}","","	// Handle positive & negative numbers (integer or float)","	// Handle hexadecimal numbers: 0xFF -> 255","	// Handle exponential notation: 1e5 -> 100000","	if (trimmedData && L.isString(trimmedData)) {","		var number = +trimmedData;","","		if (!isNaN(number)) {","			return number;","		}","	}","","	return data;","};","","/**","* A.DataType.DateMath is used for simple date manipulation. The class is a static utility","* used for adding, subtracting, and comparing dates. Based on YAHOO.widget.DateMath.","*","* @class A.DataType.DateMath","*/","var L = A.Lang,","	S = A.Lang.String,","","	isDate = L.isDate,","	isValue = L.isValue,","","	COLON = ':',","	AM = 'am',","	PM = 'pm';","","A.namespace('DataType.DateMath');","","A.mix(A.DataType.DateMath, {","	/**","	* Constant field representing Day","	* @property DAY","	* @static","	* @final","	* @type String","	*/","	DAY : 'D',","","	/**","	* Constant field representing Week","	* @property WEEK","	* @static","	* @final","	* @type String","	*/","	WEEK : 'W',","","	/**","	* Constant field representing Year","	* @property YEAR","	* @static","	* @final","	* @type String","	*/","	YEAR : 'Y',","","	/**","	* Constant field representing Month","	* @property MONTH","	* @static","	* @final","	* @type String","	*/","	MONTH : 'M',","","	/**","	* Constant field representing Minutes","	* @property MINUTES","	* @static","	* @final","	* @type String","	*/","	MINUTES : 'MINUTES',","","	/**","	* Constant field representing Hour","	* @property HOUR","	* @static","	* @final","	* @type String","	*/","	HOUR : 'HOUR',","","	/**","	* Constant field representing Seconds","	* @property SECONDS","	* @static","	* @final","	* @type String","	*/","	SECONDS : 'SECONDS',","","	/**","	* Constant field representing the number of maximum days in a month","	* @property MAX_MONTH_LENGTH","	* @static","	* @final","	* @type Number","	*/","	MAX_MONTH_LENGTH: 31,","","	/**","	* Constant field representing the number of maximum days in a week","	* @property WEEK_LENGTH","	* @static","	* @final","	* @type Number","	*/","	WEEK_LENGTH: 7,","","	/**","	* Constant field representing one day, in milliseconds","	* @property ONE_DAY_MS","	* @static","	* @final","	* @type Number","	*/","	ONE_DAY_MS : NUM_THOUSAND * NUM_SIXTY * NUM_SIXTY * NUM_TWENTY_FOUR,","","	/**","	* Constant field representing one hour, in milliseconds","	* @property ONE_HOUR_MS","	* @static","	* @final","	* @type Number","	*/","	ONE_HOUR_MS : NUM_THOUSAND * NUM_SIXTY * NUM_SIXTY,","","	/**","	* Constant field representing one minute, in milliseconds","	* @property ONE_MINUTE_MS","	* @static","	* @final","	* @type Number","	*/","	ONE_MINUTE_MS : NUM_THOUSAND * NUM_SIXTY,","","	/**","	* Constant field representing one second, in milliseconds","	* @property ONE_SECOND_MS","	* @static","	* @final","	* @type Number","	*/","	ONE_SECOND_MS : NUM_THOUSAND,","","	/**","	 * Constant field representing the date in first week of January","	 * which identifies the first week of the year.","	 * <p>","	 * In the U.S, Jan 1st is normally used based on a Sunday start of week.","	 * ISO 8601, used widely throughout Europe, uses Jan 4th, based on a Monday start of week.","	 * </p>","	 * @property WEEK_ONE_JAN_DATE","	 * @static","	 * @type Number","	 */","	WEEK_ONE_JAN_DATE : 1,","","	/**","	* Adds the specified amount of time to the this instance.","	* @method add","	* @param {Date} date	The JavaScript Date object to perform addition on","	* @param {String} field	The field constant to be used for performing addition.","	* @param {Number} amount	The number of units (measured in the field constant) to add to the date.","	* @return {Date} The resulting Date object","	*/","	add: function(date, field, amount) {","		var d = new Date(date.getTime());","		switch (field) {","			case this.MONTH:","				var newMonth = date.getMonth() + amount;","				var years = 0;","","				if (newMonth < 0) {","					while (newMonth < 0) {","						newMonth += 12;","						years -= 1;","					}","				} else if (newMonth > 11) {","					while (newMonth > 11) {","						newMonth -= 12;","						years += 1;","					}","				}","","				d.setMonth(newMonth);","				d.setFullYear(date.getFullYear() + years);","				break;","			case this.DAY:","				this._addDays(d, amount);","				// d.setDate(date.getDate() + amount);","				break;","			case this.YEAR:","				d.setFullYear(date.getFullYear() + amount);","				break;","			case this.WEEK:","				this._addDays(d, (amount * 7));","				// d.setDate(date.getDate() + (amount * 7));","				break;","			case this.HOUR:","				var hours = d.getHours();","","				d.setHours(hours + amount);","				break;","			case this.MINUTES:","				var minutes = d.getMinutes();","","				d.setMinutes(minutes + amount);","				break;","			case this.SECONDS:","				var seconds = d.getSeconds();","","				d.setSeconds(seconds + amount);","				break;","		}","		return d;","	},","","	/**","	 * Private helper method to account for bug in Safari 2 (webkit < 420)","	 * when Date.setDate(n) is called with n less than -128 or greater than 127.","	 * <p>","	 * Fix approach and original findings are available here:","	 * http://brianary.blogspot.com/2006/03/safari-date-bug.html","	 * </p>","	 * @method _addDays","	 * @param {Date} d JavaScript date object","	 * @param {Number} nDays The number of days to add to the date object (can be negative)","	 * @private","	 */","	_addDays: function(d, nDays) {","		if (A.UA.webkit && A.UA.webkit < 420) {","			if (nDays < 0) {","				// Ensure we don't go below -128 (getDate() is always 1 to 31, so we won't go above 127)","				for(var min = -128; nDays < min; nDays -= min) {","					d.setDate(d.getDate() + min);","				}","			} else {","				// Ensure we don't go above 96 + 31 = 127","				for(var max = 96; nDays > max; nDays -= max) {","					d.setDate(d.getDate() + max);","				}","			}","			// nDays should be remainder between -128 and 96","		}","		d.setDate(d.getDate() + nDays);","	},","","	/**","	* Compare dates.","	* @method compare","	* @param {Date} d1	The JavaScript Date object to compare","	* @param {Date} d2	The JavaScript Date object to compare","	* @return {boolean}","	*/","	compare: function(d1, d2) {","		return ( d1 && d2 && (d1.getTime() == d2.getTime()) );","	},","","	copyHours: function(d1, d2) {","		var instance = this;","","		d1.setHours(d2.getHours());","		d1.setMinutes(d2.getMinutes());","		d1.setSeconds(d2.getSeconds());","		d1.setMilliseconds(d2.getMilliseconds());","	},","","	/**","	* Subtracts the specified amount of time from the this instance.","	* @method subtract","	* @param {Date} date	The JavaScript Date object to perform subtraction on","	* @param {Number} field	The this field constant to be used for performing subtraction.","	* @param {Number} amount	The number of units (measured in the field constant) to subtract from the date.","	* @return {Date} The resulting Date object","	*/","	subtract: function(date, field, amount) {","		return this.add(date, field, (amount*-1));","	},","","	/**","	* Determines whether a given date is before another date on the calendar.","	* @method before","	* @param {Date} date		The Date object to compare with the compare argument","	* @param {Date} compareTo	The Date object to use for the comparison","	* @return {Boolean} true if the date occurs before the compared date; false if not.","	*/","	before: function(date, compareTo) {","		var ms = compareTo.getTime();","		if (date.getTime() < ms) {","			return true;","		} else {","			return false;","		}","	},","","	/**","	* Determines whether a given date is after another date on the calendar.","	* @method after","	* @param {Date} date		The Date object to compare with the compare argument","	* @param {Date} compareTo	The Date object to use for the comparison","	* @return {Boolean} true if the date occurs after the compared date; false if not.","	*/","	after: function(date, compareTo) {","		var ms = compareTo.getTime();","		if (date.getTime() > ms) {","			return true;","		} else {","			return false;","		}","	},","","	/**","	* Determines whether a given date is between two other dates on the calendar.","	* @method between","	* @param {Date} date		The date to check for","	* @param {Date} dateBegin	The start of the range","	* @param {Date} dateEnd		The end of the range","	* @return {Boolean} true if the date occurs between the compared dates; false if not.","	*/","	between: function(date, dateBegin, dateEnd) {","		if (this.after(date, dateBegin) && this.before(date, dateEnd)) {","			return true;","		} else {","			return false;","		}","	},","","	/**","	* Retrieves a JavaScript Date object representing January 1 of any given year.","	* @method getJan1","	* @param {Number} calendarYear		The calendar year for which to retrieve January 1","	* @return {Date}	January 1 of the calendar year specified.","	*/","	getJan1: function(calendarYear) {","		return this.getDate(calendarYear,0,1);","	},","","	/**","	* Calculates the number of days the specified date is from January 1 of the specified calendar year.","	* Passing January 1 to this function would return an offset value of zero.","	* @method getDayOffset","	* @param {Date}	date	The JavaScript date for which to find the offset","	* @param {Number} calendarYear	The calendar year to use for determining the offset","	* @return {Number}	The number of days since January 1 of the given year","	*/","	getDayOffsetYear: function(date, calendarYear) {","		var beginYear = this.getJan1(calendarYear); // Find the start of the year. This will be in week 1.","","		// Find the number of days the passed in date is away from the calendar year start","		return this.getDayOffset(date, beginYear, calendarYear);","	},","","	/**","	* Calculates the number of days between the specified dates.","	* @method getDayOffset","	* @param {Date}	d1 Date 1","	* @param {Date}	d2 Date 2","	* @return {Number}	The number of days","	*/","	getDayOffset: function(d1, d2) {","		return this._absFloor(this.getOffset(d1, d2, this.ONE_DAY_MS));","	},","","	/**","	* Calculates the number of hours between the specified dates.","	* @method getHoursOffset","	* @param {Date}	d1 Date 1","	* @param {Date}	d2 Date 2","	* @return {Number}	The number of hours","	*/","	getHoursOffset: function(d1, d2) {","		return this._absFloor(this.getOffset(d1, d2, this.ONE_HOUR_MS));","	},","","	/**","	* Calculates the number of minutes between the specified dates.","	* @method getMinutesOffset","	* @param {Date}	d1 Date 1","	* @param {Date}	d2 Date 2","	* @return {Number}	The number of minutes","	*/","	getMinutesOffset: function(d1, d2) {","		return this._absFloor(this.getOffset(d1, d2, this.ONE_MINUTE_MS));","	},","","	/**","	* Calculates the number of seconds between the specified dates.","	* @method getSecondsOffset","	* @param {Date}	d1 Date 1","	* @param {Date}	d2 Date 2","	* @return {Number}	The number of seconds","	*/","	getSecondsOffset: function(d1, d2) {","		return this._absFloor(this.getOffset(d1, d2, this.ONE_SECOND_MS));","	},","","	getOffset: function(d1, d2, constantAmount) {","		var offset = (d1.getTime()-d2.getTime()) / (constantAmount || 0);","","		return offset;","	},","","    _absFloor: function(n) {","		var abs = Math.floor(Math.abs(n));","","		if (n < 0) {","			abs *= -1;","		}","","        return abs;","    },","","	/**","	* Calculates the week number for the given date. Can currently support standard","	* U.S. week numbers, based on Jan 1st defining the 1st week of the year, and","	* ISO8601 week numbers, based on Jan 4th defining the 1st week of the year.","	*","	* @method getWeekNumber","	* @param {Date}	date The JavaScript date for which to find the week number","	* @param {Number} firstDayOfWeek The index of the first day of the week (0 = Sun, 1 = Mon ... 6 = Sat).","	* Defaults to 0","	* @param {Number} janDate The date in the first week of January which defines week one for the year","	* Defaults to the value of YAHOO.widget.DateMath.WEEK_ONE_JAN_DATE, which is 1 (Jan 1st).","	* For the U.S, this is normally Jan 1st. ISO8601 uses Jan 4th to define the first week of the year.","	*","	* @return {Number} The number of the week containing the given date.","	*/","	getWeekNumber: function(date, firstDayOfWeek, janDate) {","","		// Setup Defaults","		firstDayOfWeek = firstDayOfWeek || 0;","		janDate = janDate || this.WEEK_ONE_JAN_DATE;","","		var targetDate = this.clearTime(date),","			startOfWeek,","			endOfWeek;","","		if (targetDate.getDay() === firstDayOfWeek) {","			startOfWeek = targetDate;","		} else {","			startOfWeek = this.getFirstDayOfWeek(targetDate, firstDayOfWeek);","		}","","		var startYear = startOfWeek.getFullYear(),","			startTime = startOfWeek.getTime();","","		// DST shouldn't be a problem here, math is quicker than setDate();","		endOfWeek = new Date(startOfWeek.getTime() + 6*this.ONE_DAY_MS);","","		var weekNum;","		if (startYear !== endOfWeek.getFullYear() && endOfWeek.getDate() >= janDate) {","			// If years don't match, endOfWeek is in Jan. and if the","			// week has WEEK_ONE_JAN_DATE in it, it's week one by definition.","			weekNum = 1;","		} else {","			// Get the 1st day of the 1st week, and","			// find how many days away we are from it.","			var weekOne = this.clearTime(this.getDate(startYear, 0, janDate)),","				weekOneDayOne = this.getFirstDayOfWeek(weekOne, firstDayOfWeek);","","			// Round days to smoothen out 1 hr DST diff","			var daysDiff  = Math.round((targetDate.getTime() - weekOneDayOne.getTime())/this.ONE_DAY_MS);","","			// Calc. Full Weeks","			var rem = daysDiff % 7;","			var weeksDiff = (daysDiff - rem)/7;","			weekNum = weeksDiff + 1;","		}","		return weekNum;","	},","","	/**","	 * Get the first day of the week, for the give date.","	 * @param {Date} dt The date in the week for which the first day is required.","	 * @param {Number} startOfWeek The index for the first day of the week, 0 = Sun, 1 = Mon ... 6 = Sat (defaults to 0)","	 * @return {Date} The first day of the week","	 */","	getFirstDayOfWeek: function (dt, startOfWeek) {","		startOfWeek = startOfWeek || 0;","		var dayOfWeekIndex = dt.getDay(),","			dayOfWeek = (dayOfWeekIndex - startOfWeek + 7) % 7;","","		return this.subtract(dt, this.DAY, dayOfWeek);","	},","","	/**","	 * Chechs if the passed date is a week day.","	 *","	 * @method isWeekDay","	 * @param {Date} date Date","	 * @return boolean","	 */","	isWeekDay: function(date) {","		var day = date.getDay();","","		return (day > 0) && (day < 6);","	},","","	/**","	 * Chechs if the passed date is a Tuesday or Thursday.","	 *","	 * @method isTueOrThu","	 * @param {Date} date Date","	 * @return boolean","	 */","	isTueOrThu: function(date) {","		return this.isWeekDay(date) && (date.getDay() % 2 === 0);","	},","","	/**","	 * Chechs if the passed date is a Monday, Wednesday or Friday.","	 *","	 * @method isMonWedOrFri","	 * @param {Date} date Date","	 * @return boolean","	 */","	isMonWedOrFri: function(date) {","		return this.isWeekDay(date) && !this.isTueOrThu(date);","	},","","	/**","	 * Chechs if the {date2} is the next day.","	 *","	 * @method isNextDay","	 * @param {Date} date1 Date","	 * @param {Date} date2 Date","	 * @return boolean","	 */","	isNextDay: function(date1, date2) {","		return this.getDayOffset(this.safeClearTime(date2), this.safeClearTime(date1)) === 1;","	},","","	/**","	 * Chechs if the {date2} is the next day at 00:00:00.","	 *","	 * @method isNextDayBoundary","	 * @param {Date} date1 Date","	 * @param {Date} date2 Date","	 * @return boolean","	 */","	isDayBoundary: function(date1, date2) {","		return this.isNextDay(date1, date2) && (date2.getHours() === 0) && (date2.getMinutes() === 0) && (date2.getSeconds() === 0);","	},","","	/**","	 * Chechs if the passed date is between two days.","	 *","	 * @method isDayOverlap","	 * @param {Date} date1 Date","	 * @param {Date} date2 Date","	 * @return boolean","	 */","	isDayOverlap : function(date1, date2) {","		return ((date1.getFullYear() !== date2.getFullYear()) || (date1.getMonth() !== date2.getMonth()) || (date1.getDate() !== date2.getDate()));;","	},","","	/**","	 * Chechs if the passed date is today.","	 *","	 * @method isToday","	 * @param {Date} date Date","	 * @return boolean","	 */","	isToday: function(date) {","		return !this.isDayOverlap(date, new Date());","	},","","	/**","	 * Chechs if the passed dates are in the same month.","	 *","	 * @method isSameMonth","	 * @param {Date} d1 Date","	 * @param {Date} d2 Date","	 * @return boolean","	 */","	isSameMonth : function(d1, d2) {","		return ((d1.getFullYear() === d2.getFullYear()) && (d1.getMonth() === d2.getMonth()));","	},","","	/**","	* Determines if a given week overlaps two different years.","	* @method isYearOverlapWeek","	* @param {Date}	weekBeginDate	The JavaScript Date representing the first day of the week.","	* @return {Boolean}	true if the date overlaps two different years.","	*/","	isYearOverlapWeek : function(weekBeginDate) {","		var overlaps = false;","		var nextWeek = this.add(weekBeginDate, this.DAY, 6);","		if (nextWeek.getFullYear() != weekBeginDate.getFullYear()) {","			overlaps = true;","		}","		return overlaps;","	},","","	/**","	* Determines if a given week overlaps two different months.","	* @method isMonthOverlapWeek","	* @param {Date}	weekBeginDate	The JavaScript Date representing the first day of the week.","	* @return {Boolean}	true if the date overlaps two different months.","	*/","	isMonthOverlapWeek : function(weekBeginDate) {","		var overlaps = false;","		var nextWeek = this.add(weekBeginDate, this.DAY, 6);","		if (nextWeek.getMonth() != weekBeginDate.getMonth()) {","			overlaps = true;","		}","		return overlaps;","	},","","	/**","	* Gets the first day of a month containing a given date.","	* @method findMonthStart","	* @param {Date}	date	The JavaScript Date used to calculate the month start","	* @return {Date}		The JavaScript Date representing the first day of the month","	*/","	findMonthStart : function(date) {","		var start = this.getDate(date.getFullYear(), date.getMonth(), 1);","		return start;","	},","","	/**","	* Gets the last day of a month containing a given date.","	* @method findMonthEnd","	* @param {Date}	date	The JavaScript Date used to calculate the month end","	* @return {Date}		The JavaScript Date representing the last day of the month","	*/","	findMonthEnd : function(date) {","		var start = this.findMonthStart(date);","		var nextMonth = this.add(start, this.MONTH, 1);","		var end = this.subtract(nextMonth, this.DAY, 1);","		end.setHours(23,59,59,999);","		return end;","	},","","	/**","	* Clears the time fields from a given date, effectively setting the time to 12 noon.","	* @method clearTime","	* @param {Date}	date	The JavaScript Date for which the time fields will be cleared","	* @return {Date}		The JavaScript Date cleared of all time fields","	*/","	clearTime : function(date) {","		date.setHours(12,0,0,0);","		return date;","	},","","	/**","	* Clears the time fields from a given date, effectively setting the time to","	* 12 noon. This is \"safe\" because clones the date before clear, not affecting","	* the passed reference.","	* @method safeClearTime","	* @param {Date}	date	The JavaScript Date for which the time fields will be cleared","	* @return {Date}		The JavaScript Date cleared of all time fields","	*/","	safeClearTime : function(date) {","		return this.clearTime(this.clone(date));","	},","","	/**","	* Set the time fields from a given date to the last possible hour.","	* @method toLastHour","	* @param {Date}	date	The JavaScript Date for which the time fields will be set to the last possible hour","	* @return {Date}		The JavaScript Date set to the last possible hour","	*/","	toLastHour: function(date) {","		date.setHours(23,59,59,999);","		return date;","	},","","	/**","	* Set the time fields from a given date to midnight.","	* @method toMidnight","	* @param {Date}	date	The JavaScript Date for which the time fields will be set to midnight","	* @return {Date}		The JavaScript Date set to midnight","	*/","	toMidnight: function(date) {","		date.setHours(0,0,0,0);","		return date;","	},","","	/**","	* Clone the passed date object.","	* @method clone","	* @param {Date}	date	The JavaScript Date to clone","	* @return {Date}		The JavaScript Date cloned","	*/","	clone : function(date) {","		return new Date(date.getTime());","	},","","	/**","	 * Returns a new JavaScript Date object, representing the given year, month and date. Time fields (hr, min, sec, ms) on the new Date object","	 * are set to 0. The method allows Date instances to be created with the a year less than 100. \"new Date(year, month, date)\" implementations","	 * set the year to 19xx if a year (xx) which is less than 100 is provided.","	 * <p>","	 * <em>NOTE:</em>Validation on argument values is not performed. It is the caller's responsibility to ensure","	 * arguments are valid as per the ECMAScript-262 Date object specification for the new Date(year, month[, date]) constructor.","	 * </p>","	 * @method getDate","	 * @param {Number} y Year.","	 * @param {Number} m Month index from 0 (Jan) to 11 (Dec).","	 * @param {Number} d (optional) Date from 1 to 31. If not provided, defaults to 1.","	 * @return {Date} The JavaScript date object with year, month, date set as provided.","	 */","	getDate : function(y, m, d) {","		var dt = null;","		if (!isValue(d)) {","			d = 1;","		}","		if (y >= 100) {","			dt = new Date(y, m, d);","		} else {","			dt = new Date();","			dt.setFullYear(y);","			dt.setMonth(m);","			dt.setDate(d);","			dt.setHours(0,0,0,0);","		}","		return dt;","	},","","	getDaysInMonth: function(year, month) {","		return this.findMonthEnd(this.getDate(year, month)).getDate();","    },","","	toUsTimeString: function(date, padHours, omitMinutes, hideAmPm) {","		date = isDate(date) ? date : new Date(0, 0, 0, date);","","		var hours = date.getHours();","		var minutes = date.getMinutes();","		var isPM = false;","","		if (hours >= 12) {","			isPM = true;","","			if (hours > 12) {","				hours -= 12;","			}","		}","		else if (hours === 0) {","			hours = 12;","		}","","		var time = padHours ? S.padNumber(hours, 2) : String(hours);","","		if (!omitMinutes) {","			time += COLON;","			time += S.padNumber(minutes, 2);","		}","","		if (!hideAmPm) {","			time += (isPM ? PM : AM);","		}","","		return time;","	},","","	toIsoTimeString: function(date, showSeconds) {","		date = isDate(date) ? date : new Date(0, 0, 0, date);","","		var hours = date.getHours();","		var minutes = date.getMinutes();","		var time = S.padNumber(hours, 2) + COLON + S.padNumber(minutes, 2);","","		if (showSeconds) {","			var seconds = date.getSeconds();","","			time += COLON;","			time += S.padNumber(seconds, 2);","		}","","		return time;","	}","});","","(function(Y) {","	// See http://yuilibrary.com/projects/yui3/ticket/2532862","","	/**","	 * @module datatype","	*/","","	/**","	 * The Date.Locale class is a container for all localised date strings","	 * used by Y.DataType.Date. It is used internally, but may be extended","	 * to provide new date localisations.","	 *","	 * To create your own Locale, follow these steps:","	 * <ol>","	 *  <li>Find an existing locale that matches closely with your needs</li>","	 *  <li>Use this as your base class.  Use Y.DataType.Date.Locale[\"en\"] if nothing","	 *   matches.</li>","	 *  <li>Create your own class as an extension of the base class using","	 *   Y.merge, and add your own localisations where needed.</li>","	 * </ol>","	 * See the Y.DataType.Date.Locale[\"en-US\"] and Y.DataType.Date.Locale[\"en-GB\"]","	 * classes which extend Y.DataType.Date.Locale[\"en\"].","	 *","	 * For example, to implement locales for French french and Canadian french,","	 * we would do the following:","	 * <ol>","	 *  <li>For French french, we have no existing similar locale, so use","	 *   Y.DataType.Date.Locale[\"en\"] as the base, and extend it:","	 *   <pre>","	 *      Y.DataType.Date.Locale[\"fr\"] = Y.merge(Y.DataType.Date.Locale[\"en\"], {","	 *          a: [\"dim\", \"lun\", \"mar\", \"mer\", \"jeu\", \"ven\", \"sam\"],","	 *          A: [\"dimanche\", \"lundi\", \"mardi\", \"mercredi\", \"jeudi\", \"vendredi\", \"samedi\"],","	 *          b: [\"jan\", \"f&eacute;v\", \"mar\", \"avr\", \"mai\", \"jun\", \"jui\", \"ao&ucirc;\", \"sep\", \"oct\", \"nov\", \"d&eacute;c\"],","	 *          B: [\"janvier\", \"f&eacute;vrier\", \"mars\", \"avril\", \"mai\", \"juin\", \"juillet\", \"ao&ucirc;t\", \"septembre\", \"octobre\", \"novembre\", \"d&eacute;cembre\"],","	 *          c: \"%a %d %b %Y %T %Z\",","	 *          p: [\"\", \"\"],","	 *          P: [\"\", \"\"],","	 *          x: \"%d.%m.%Y\",","	 *          X: \"%T\"","	 *      });","	 *   </pre>","	 *  </li>","	 *  <li>For Canadian french, we start with French french and change the meaning of \\%x:","	 *   <pre>","	 *      Y.DataType.Date.Locale[\"fr-CA\"] = Y.merge(Y.DataType.Date.Locale[\"fr\"], {","	 *          x: \"%Y-%m-%d\"","	 *      });","	 *   </pre>","	 *  </li>","	 * </ol>","	 *","	 * With that, you can use your new locales:","	 * <pre>","	 *    var d = new Date(\"2008/04/22\");","	 *    Y.DataType.Date.format(d, { format: \"%A, %d %B == %x\", locale: \"fr\" });","	 * </pre>","	 * will return:","	 * <pre>","	 *    mardi, 22 avril == 22.04.2008","	 * </pre>","	 * And","	 * <pre>","	 *    Y.DataType.Date.format(d, {format: \"%A, %d %B == %x\", locale: \"fr-CA\" });","	 * </pre>","	 * Will return:","	 * <pre>","	 *   mardi, 22 avril == 2008-04-22","	 * </pre>","	 * @requires oop","	 * @class DataType.Date.Locale","	 * @static","	 * @deprecated - use Y.config.lang to request one of many built-in languages instead.","	 */","	var YDateEn = {","		a: [\"Sun\", \"Mon\", \"Tue\", \"Wed\", \"Thu\", \"Fri\", \"Sat\"],","		A: [\"Sunday\", \"Monday\", \"Tuesday\", \"Wednesday\", \"Thursday\", \"Friday\", \"Saturday\"],","		b: [\"Jan\", \"Feb\", \"Mar\", \"Apr\", \"May\", \"Jun\", \"Jul\", \"Aug\", \"Sep\", \"Oct\", \"Nov\", \"Dec\"],","		B: [\"January\", \"February\", \"March\", \"April\", \"May\", \"June\", \"July\", \"August\", \"September\", \"October\", \"November\", \"December\"],","		c: \"%a %d %b %Y %T %Z\",","		p: [\"AM\", \"PM\"],","		P: [\"am\", \"pm\"],","		r: \"%I:%M:%S %p\",","		x: \"%d/%m/%y\",","		X: \"%T\"","	};","","	Y.namespace(\"DataType.Date.Locale\");","","	Y.DataType.Date.Locale[\"en\"] = YDateEn;","","	Y.DataType.Date.Locale[\"en-US\"] = Y.merge(YDateEn, {","		c: \"%a %d %b %Y %I:%M:%S %p %Z\",","		x: \"%m/%d/%Y\",","		X: \"%I:%M:%S %p\"","	});","","	Y.DataType.Date.Locale[\"en-GB\"] = Y.merge(YDateEn, {","		r: \"%l:%M:%S %P %Z\"","	});","	Y.DataType.Date.Locale[\"en-AU\"] = Y.merge(YDateEn);","}(A));","","","}, '2.0.0pr1', {\"requires\": [\"datatype\"]});"];
_yuitest_coverage["build/aui-datatype/aui-datatype.js"].lines = {"1":0,"9":0,"46":0,"47":0,"49":0,"62":0,"63":0,"66":0,"67":0,"73":0,"74":0,"76":0,"77":0,"81":0,"90":0,"100":0,"102":0,"242":0,"243":0,"245":0,"246":0,"248":0,"249":0,"250":0,"251":0,"253":0,"254":0,"255":0,"256":0,"260":0,"261":0,"262":0,"264":0,"266":0,"268":0,"269":0,"271":0,"273":0,"275":0,"277":0,"278":0,"280":0,"282":0,"283":0,"285":0,"287":0,"288":0,"290":0,"306":0,"307":0,"309":0,"310":0,"314":0,"315":0,"320":0,"331":0,"335":0,"337":0,"338":0,"339":0,"340":0,"352":0,"363":0,"364":0,"365":0,"367":0,"379":0,"380":0,"381":0,"383":0,"396":0,"397":0,"399":0,"410":0,"422":0,"425":0,"436":0,"447":0,"458":0,"469":0,"473":0,"475":0,"479":0,"481":0,"482":0,"485":0,"506":0,"507":0,"509":0,"513":0,"514":0,"516":0,"519":0,"523":0,"525":0,"526":0,"529":0,"533":0,"537":0,"540":0,"541":0,"542":0,"544":0,"554":0,"555":0,"558":0,"569":0,"571":0,"582":0,"593":0,"605":0,"617":0,"629":0,"640":0,"652":0,"662":0,"663":0,"664":0,"665":0,"667":0,"677":0,"678":0,"679":0,"680":0,"682":0,"692":0,"693":0,"703":0,"704":0,"705":0,"706":0,"707":0,"717":0,"718":0,"730":0,"740":0,"741":0,"751":0,"752":0,"762":0,"780":0,"781":0,"782":0,"784":0,"785":0,"787":0,"788":0,"789":0,"790":0,"791":0,"793":0,"797":0,"801":0,"803":0,"804":0,"805":0,"807":0,"808":0,"810":0,"811":0,"814":0,"815":0,"818":0,"820":0,"821":0,"822":0,"825":0,"826":0,"829":0,"833":0,"835":0,"836":0,"837":0,"839":0,"840":0,"842":0,"843":0,"846":0,"850":0,"923":0,"936":0,"938":0,"940":0,"946":0,"949":0};
_yuitest_coverage["build/aui-datatype/aui-datatype.js"].functions = {"parse:46":0,"evaluate:62":0,"add:241":0,"_addDays:305":0,"compare:330":0,"copyHours:334":0,"subtract:351":0,"before:362":0,"after:378":0,"between:395":0,"getJan1:409":0,"getDayOffsetYear:421":0,"getDayOffset:435":0,"getHoursOffset:446":0,"getMinutesOffset:457":0,"getSecondsOffset:468":0,"getOffset:472":0,"_absFloor:478":0,"getWeekNumber:503":0,"getFirstDayOfWeek:553":0,"isWeekDay:568":0,"isTueOrThu:581":0,"isMonWedOrFri:592":0,"isNextDay:604":0,"isDayBoundary:616":0,"isDayOverlap:628":0,"isToday:639":0,"isSameMonth:651":0,"isYearOverlapWeek:661":0,"isMonthOverlapWeek:676":0,"findMonthStart:691":0,"findMonthEnd:702":0,"clearTime:716":0,"safeClearTime:729":0,"toLastHour:739":0,"toMidnight:750":0,"clone:761":0,"getDate:779":0,"getDaysInMonth:796":0,"toUsTimeString:800":0,"toIsoTimeString:832":0,"(anonymous 2):850":0,"(anonymous 1):1":0};
_yuitest_coverage["build/aui-datatype/aui-datatype.js"].coveredLines = 185;
_yuitest_coverage["build/aui-datatype/aui-datatype.js"].coveredFunctions = 43;
_yuitest_coverline("build/aui-datatype/aui-datatype.js", 1);
YUI.add('aui-datatype', function (A, NAME) {

/**
 * The Datatype Utility
 *
 * @module aui-datatype
 */

_yuitest_coverfunc("build/aui-datatype/aui-datatype.js", "(anonymous 1)", 1);
_yuitest_coverline("build/aui-datatype/aui-datatype.js", 9);
var L = A.Lang,
	FALSE = 'false',
	TRUE = 'true',

	NUM_SIXTY = 60,
	NUM_THOUSAND = 1000,
	NUM_TWENTY_FOUR = 24,

	/**
	 * DataType.Boolean provides a set of utility to parse <code>falsey</code>
     * value to <code>false</code> and <code>non-falsey</code> to
     * <code>true</code>.
	 *
	 * @class DataType.Boolean
	 * @static
	 */
	DB = A.namespace('DataType.Boolean'),

	/**
	 * DataType.String provides a set of utility to provides a simple function
     * that evaluates a string to a primitive value (if possible). Supports
     * <code>true</code> and <code>false</code> also.
	 *
	 * @class DataType.String
	 * @static
	 */
	DS = A.namespace('DataType.String');

/**
 * Parses any <code>falsey</code> value to <code>false</code> and
 * <code>non-falsey</code> to <code>true</code>.
 *
 * @for DataType.Boolean
 * @method parse
 * @param {*} data falsey or non-falsey values (i.e., falsey values: null, false, undefined, NaN; non-falsey values: 1, true, 'abc').
 * @return {boolean} Parsed value
 */
_yuitest_coverline("build/aui-datatype/aui-datatype.js", 46);
DB.parse = function(data) {
	_yuitest_coverfunc("build/aui-datatype/aui-datatype.js", "parse", 46);
_yuitest_coverline("build/aui-datatype/aui-datatype.js", 47);
data = A.Lang.trim(data);

	_yuitest_coverline("build/aui-datatype/aui-datatype.js", 49);
return (data == FALSE) ? false : !!data;
};

/**
 * Evaluates a string to a primitive value (if possible). Supports
 * <code>true</code> and <code>false</code> also. Unrecognized strings are
 * returned without any modification.
 *
 * @for DataType.String
 * @method evaluate
 * @param {*} data Input data to be evaluated.
 * @return {boolean | null | number | String | undefined} Parsed value
 */
_yuitest_coverline("build/aui-datatype/aui-datatype.js", 62);
DS.evaluate = function(data) {
	_yuitest_coverfunc("build/aui-datatype/aui-datatype.js", "evaluate", 62);
_yuitest_coverline("build/aui-datatype/aui-datatype.js", 63);
var trimmedData = A.Lang.trim(data);

	// booleans
	_yuitest_coverline("build/aui-datatype/aui-datatype.js", 66);
if (trimmedData == TRUE || trimmedData == FALSE) {
		_yuitest_coverline("build/aui-datatype/aui-datatype.js", 67);
return DB.parse(data);
	}

	// Handle positive & negative numbers (integer or float)
	// Handle hexadecimal numbers: 0xFF -> 255
	// Handle exponential notation: 1e5 -> 100000
	_yuitest_coverline("build/aui-datatype/aui-datatype.js", 73);
if (trimmedData && L.isString(trimmedData)) {
		_yuitest_coverline("build/aui-datatype/aui-datatype.js", 74);
var number = +trimmedData;

		_yuitest_coverline("build/aui-datatype/aui-datatype.js", 76);
if (!isNaN(number)) {
			_yuitest_coverline("build/aui-datatype/aui-datatype.js", 77);
return number;
		}
	}

	_yuitest_coverline("build/aui-datatype/aui-datatype.js", 81);
return data;
};

/**
* A.DataType.DateMath is used for simple date manipulation. The class is a static utility
* used for adding, subtracting, and comparing dates. Based on YAHOO.widget.DateMath.
*
* @class A.DataType.DateMath
*/
_yuitest_coverline("build/aui-datatype/aui-datatype.js", 90);
var L = A.Lang,
	S = A.Lang.String,

	isDate = L.isDate,
	isValue = L.isValue,

	COLON = ':',
	AM = 'am',
	PM = 'pm';

_yuitest_coverline("build/aui-datatype/aui-datatype.js", 100);
A.namespace('DataType.DateMath');

_yuitest_coverline("build/aui-datatype/aui-datatype.js", 102);
A.mix(A.DataType.DateMath, {
	/**
	* Constant field representing Day
	* @property DAY
	* @static
	* @final
	* @type String
	*/
	DAY : 'D',

	/**
	* Constant field representing Week
	* @property WEEK
	* @static
	* @final
	* @type String
	*/
	WEEK : 'W',

	/**
	* Constant field representing Year
	* @property YEAR
	* @static
	* @final
	* @type String
	*/
	YEAR : 'Y',

	/**
	* Constant field representing Month
	* @property MONTH
	* @static
	* @final
	* @type String
	*/
	MONTH : 'M',

	/**
	* Constant field representing Minutes
	* @property MINUTES
	* @static
	* @final
	* @type String
	*/
	MINUTES : 'MINUTES',

	/**
	* Constant field representing Hour
	* @property HOUR
	* @static
	* @final
	* @type String
	*/
	HOUR : 'HOUR',

	/**
	* Constant field representing Seconds
	* @property SECONDS
	* @static
	* @final
	* @type String
	*/
	SECONDS : 'SECONDS',

	/**
	* Constant field representing the number of maximum days in a month
	* @property MAX_MONTH_LENGTH
	* @static
	* @final
	* @type Number
	*/
	MAX_MONTH_LENGTH: 31,

	/**
	* Constant field representing the number of maximum days in a week
	* @property WEEK_LENGTH
	* @static
	* @final
	* @type Number
	*/
	WEEK_LENGTH: 7,

	/**
	* Constant field representing one day, in milliseconds
	* @property ONE_DAY_MS
	* @static
	* @final
	* @type Number
	*/
	ONE_DAY_MS : NUM_THOUSAND * NUM_SIXTY * NUM_SIXTY * NUM_TWENTY_FOUR,

	/**
	* Constant field representing one hour, in milliseconds
	* @property ONE_HOUR_MS
	* @static
	* @final
	* @type Number
	*/
	ONE_HOUR_MS : NUM_THOUSAND * NUM_SIXTY * NUM_SIXTY,

	/**
	* Constant field representing one minute, in milliseconds
	* @property ONE_MINUTE_MS
	* @static
	* @final
	* @type Number
	*/
	ONE_MINUTE_MS : NUM_THOUSAND * NUM_SIXTY,

	/**
	* Constant field representing one second, in milliseconds
	* @property ONE_SECOND_MS
	* @static
	* @final
	* @type Number
	*/
	ONE_SECOND_MS : NUM_THOUSAND,

	/**
	 * Constant field representing the date in first week of January
	 * which identifies the first week of the year.
	 * <p>
	 * In the U.S, Jan 1st is normally used based on a Sunday start of week.
	 * ISO 8601, used widely throughout Europe, uses Jan 4th, based on a Monday start of week.
	 * </p>
	 * @property WEEK_ONE_JAN_DATE
	 * @static
	 * @type Number
	 */
	WEEK_ONE_JAN_DATE : 1,

	/**
	* Adds the specified amount of time to the this instance.
	* @method add
	* @param {Date} date	The JavaScript Date object to perform addition on
	* @param {String} field	The field constant to be used for performing addition.
	* @param {Number} amount	The number of units (measured in the field constant) to add to the date.
	* @return {Date} The resulting Date object
	*/
	add: function(date, field, amount) {
		_yuitest_coverfunc("build/aui-datatype/aui-datatype.js", "add", 241);
_yuitest_coverline("build/aui-datatype/aui-datatype.js", 242);
var d = new Date(date.getTime());
		_yuitest_coverline("build/aui-datatype/aui-datatype.js", 243);
switch (field) {
			case this.MONTH:
				_yuitest_coverline("build/aui-datatype/aui-datatype.js", 245);
var newMonth = date.getMonth() + amount;
				_yuitest_coverline("build/aui-datatype/aui-datatype.js", 246);
var years = 0;

				_yuitest_coverline("build/aui-datatype/aui-datatype.js", 248);
if (newMonth < 0) {
					_yuitest_coverline("build/aui-datatype/aui-datatype.js", 249);
while (newMonth < 0) {
						_yuitest_coverline("build/aui-datatype/aui-datatype.js", 250);
newMonth += 12;
						_yuitest_coverline("build/aui-datatype/aui-datatype.js", 251);
years -= 1;
					}
				} else {_yuitest_coverline("build/aui-datatype/aui-datatype.js", 253);
if (newMonth > 11) {
					_yuitest_coverline("build/aui-datatype/aui-datatype.js", 254);
while (newMonth > 11) {
						_yuitest_coverline("build/aui-datatype/aui-datatype.js", 255);
newMonth -= 12;
						_yuitest_coverline("build/aui-datatype/aui-datatype.js", 256);
years += 1;
					}
				}}

				_yuitest_coverline("build/aui-datatype/aui-datatype.js", 260);
d.setMonth(newMonth);
				_yuitest_coverline("build/aui-datatype/aui-datatype.js", 261);
d.setFullYear(date.getFullYear() + years);
				_yuitest_coverline("build/aui-datatype/aui-datatype.js", 262);
break;
			case this.DAY:
				_yuitest_coverline("build/aui-datatype/aui-datatype.js", 264);
this._addDays(d, amount);
				// d.setDate(date.getDate() + amount);
				_yuitest_coverline("build/aui-datatype/aui-datatype.js", 266);
break;
			case this.YEAR:
				_yuitest_coverline("build/aui-datatype/aui-datatype.js", 268);
d.setFullYear(date.getFullYear() + amount);
				_yuitest_coverline("build/aui-datatype/aui-datatype.js", 269);
break;
			case this.WEEK:
				_yuitest_coverline("build/aui-datatype/aui-datatype.js", 271);
this._addDays(d, (amount * 7));
				// d.setDate(date.getDate() + (amount * 7));
				_yuitest_coverline("build/aui-datatype/aui-datatype.js", 273);
break;
			case this.HOUR:
				_yuitest_coverline("build/aui-datatype/aui-datatype.js", 275);
var hours = d.getHours();

				_yuitest_coverline("build/aui-datatype/aui-datatype.js", 277);
d.setHours(hours + amount);
				_yuitest_coverline("build/aui-datatype/aui-datatype.js", 278);
break;
			case this.MINUTES:
				_yuitest_coverline("build/aui-datatype/aui-datatype.js", 280);
var minutes = d.getMinutes();

				_yuitest_coverline("build/aui-datatype/aui-datatype.js", 282);
d.setMinutes(minutes + amount);
				_yuitest_coverline("build/aui-datatype/aui-datatype.js", 283);
break;
			case this.SECONDS:
				_yuitest_coverline("build/aui-datatype/aui-datatype.js", 285);
var seconds = d.getSeconds();

				_yuitest_coverline("build/aui-datatype/aui-datatype.js", 287);
d.setSeconds(seconds + amount);
				_yuitest_coverline("build/aui-datatype/aui-datatype.js", 288);
break;
		}
		_yuitest_coverline("build/aui-datatype/aui-datatype.js", 290);
return d;
	},

	/**
	 * Private helper method to account for bug in Safari 2 (webkit < 420)
	 * when Date.setDate(n) is called with n less than -128 or greater than 127.
	 * <p>
	 * Fix approach and original findings are available here:
	 * http://brianary.blogspot.com/2006/03/safari-date-bug.html
	 * </p>
	 * @method _addDays
	 * @param {Date} d JavaScript date object
	 * @param {Number} nDays The number of days to add to the date object (can be negative)
	 * @private
	 */
	_addDays: function(d, nDays) {
		_yuitest_coverfunc("build/aui-datatype/aui-datatype.js", "_addDays", 305);
_yuitest_coverline("build/aui-datatype/aui-datatype.js", 306);
if (A.UA.webkit && A.UA.webkit < 420) {
			_yuitest_coverline("build/aui-datatype/aui-datatype.js", 307);
if (nDays < 0) {
				// Ensure we don't go below -128 (getDate() is always 1 to 31, so we won't go above 127)
				_yuitest_coverline("build/aui-datatype/aui-datatype.js", 309);
for(var min = -128; nDays < min; nDays -= min) {
					_yuitest_coverline("build/aui-datatype/aui-datatype.js", 310);
d.setDate(d.getDate() + min);
				}
			} else {
				// Ensure we don't go above 96 + 31 = 127
				_yuitest_coverline("build/aui-datatype/aui-datatype.js", 314);
for(var max = 96; nDays > max; nDays -= max) {
					_yuitest_coverline("build/aui-datatype/aui-datatype.js", 315);
d.setDate(d.getDate() + max);
				}
			}
			// nDays should be remainder between -128 and 96
		}
		_yuitest_coverline("build/aui-datatype/aui-datatype.js", 320);
d.setDate(d.getDate() + nDays);
	},

	/**
	* Compare dates.
	* @method compare
	* @param {Date} d1	The JavaScript Date object to compare
	* @param {Date} d2	The JavaScript Date object to compare
	* @return {boolean}
	*/
	compare: function(d1, d2) {
		_yuitest_coverfunc("build/aui-datatype/aui-datatype.js", "compare", 330);
_yuitest_coverline("build/aui-datatype/aui-datatype.js", 331);
return ( d1 && d2 && (d1.getTime() == d2.getTime()) );
	},

	copyHours: function(d1, d2) {
		_yuitest_coverfunc("build/aui-datatype/aui-datatype.js", "copyHours", 334);
_yuitest_coverline("build/aui-datatype/aui-datatype.js", 335);
var instance = this;

		_yuitest_coverline("build/aui-datatype/aui-datatype.js", 337);
d1.setHours(d2.getHours());
		_yuitest_coverline("build/aui-datatype/aui-datatype.js", 338);
d1.setMinutes(d2.getMinutes());
		_yuitest_coverline("build/aui-datatype/aui-datatype.js", 339);
d1.setSeconds(d2.getSeconds());
		_yuitest_coverline("build/aui-datatype/aui-datatype.js", 340);
d1.setMilliseconds(d2.getMilliseconds());
	},

	/**
	* Subtracts the specified amount of time from the this instance.
	* @method subtract
	* @param {Date} date	The JavaScript Date object to perform subtraction on
	* @param {Number} field	The this field constant to be used for performing subtraction.
	* @param {Number} amount	The number of units (measured in the field constant) to subtract from the date.
	* @return {Date} The resulting Date object
	*/
	subtract: function(date, field, amount) {
		_yuitest_coverfunc("build/aui-datatype/aui-datatype.js", "subtract", 351);
_yuitest_coverline("build/aui-datatype/aui-datatype.js", 352);
return this.add(date, field, (amount*-1));
	},

	/**
	* Determines whether a given date is before another date on the calendar.
	* @method before
	* @param {Date} date		The Date object to compare with the compare argument
	* @param {Date} compareTo	The Date object to use for the comparison
	* @return {Boolean} true if the date occurs before the compared date; false if not.
	*/
	before: function(date, compareTo) {
		_yuitest_coverfunc("build/aui-datatype/aui-datatype.js", "before", 362);
_yuitest_coverline("build/aui-datatype/aui-datatype.js", 363);
var ms = compareTo.getTime();
		_yuitest_coverline("build/aui-datatype/aui-datatype.js", 364);
if (date.getTime() < ms) {
			_yuitest_coverline("build/aui-datatype/aui-datatype.js", 365);
return true;
		} else {
			_yuitest_coverline("build/aui-datatype/aui-datatype.js", 367);
return false;
		}
	},

	/**
	* Determines whether a given date is after another date on the calendar.
	* @method after
	* @param {Date} date		The Date object to compare with the compare argument
	* @param {Date} compareTo	The Date object to use for the comparison
	* @return {Boolean} true if the date occurs after the compared date; false if not.
	*/
	after: function(date, compareTo) {
		_yuitest_coverfunc("build/aui-datatype/aui-datatype.js", "after", 378);
_yuitest_coverline("build/aui-datatype/aui-datatype.js", 379);
var ms = compareTo.getTime();
		_yuitest_coverline("build/aui-datatype/aui-datatype.js", 380);
if (date.getTime() > ms) {
			_yuitest_coverline("build/aui-datatype/aui-datatype.js", 381);
return true;
		} else {
			_yuitest_coverline("build/aui-datatype/aui-datatype.js", 383);
return false;
		}
	},

	/**
	* Determines whether a given date is between two other dates on the calendar.
	* @method between
	* @param {Date} date		The date to check for
	* @param {Date} dateBegin	The start of the range
	* @param {Date} dateEnd		The end of the range
	* @return {Boolean} true if the date occurs between the compared dates; false if not.
	*/
	between: function(date, dateBegin, dateEnd) {
		_yuitest_coverfunc("build/aui-datatype/aui-datatype.js", "between", 395);
_yuitest_coverline("build/aui-datatype/aui-datatype.js", 396);
if (this.after(date, dateBegin) && this.before(date, dateEnd)) {
			_yuitest_coverline("build/aui-datatype/aui-datatype.js", 397);
return true;
		} else {
			_yuitest_coverline("build/aui-datatype/aui-datatype.js", 399);
return false;
		}
	},

	/**
	* Retrieves a JavaScript Date object representing January 1 of any given year.
	* @method getJan1
	* @param {Number} calendarYear		The calendar year for which to retrieve January 1
	* @return {Date}	January 1 of the calendar year specified.
	*/
	getJan1: function(calendarYear) {
		_yuitest_coverfunc("build/aui-datatype/aui-datatype.js", "getJan1", 409);
_yuitest_coverline("build/aui-datatype/aui-datatype.js", 410);
return this.getDate(calendarYear,0,1);
	},

	/**
	* Calculates the number of days the specified date is from January 1 of the specified calendar year.
	* Passing January 1 to this function would return an offset value of zero.
	* @method getDayOffset
	* @param {Date}	date	The JavaScript date for which to find the offset
	* @param {Number} calendarYear	The calendar year to use for determining the offset
	* @return {Number}	The number of days since January 1 of the given year
	*/
	getDayOffsetYear: function(date, calendarYear) {
		_yuitest_coverfunc("build/aui-datatype/aui-datatype.js", "getDayOffsetYear", 421);
_yuitest_coverline("build/aui-datatype/aui-datatype.js", 422);
var beginYear = this.getJan1(calendarYear); // Find the start of the year. This will be in week 1.

		// Find the number of days the passed in date is away from the calendar year start
		_yuitest_coverline("build/aui-datatype/aui-datatype.js", 425);
return this.getDayOffset(date, beginYear, calendarYear);
	},

	/**
	* Calculates the number of days between the specified dates.
	* @method getDayOffset
	* @param {Date}	d1 Date 1
	* @param {Date}	d2 Date 2
	* @return {Number}	The number of days
	*/
	getDayOffset: function(d1, d2) {
		_yuitest_coverfunc("build/aui-datatype/aui-datatype.js", "getDayOffset", 435);
_yuitest_coverline("build/aui-datatype/aui-datatype.js", 436);
return this._absFloor(this.getOffset(d1, d2, this.ONE_DAY_MS));
	},

	/**
	* Calculates the number of hours between the specified dates.
	* @method getHoursOffset
	* @param {Date}	d1 Date 1
	* @param {Date}	d2 Date 2
	* @return {Number}	The number of hours
	*/
	getHoursOffset: function(d1, d2) {
		_yuitest_coverfunc("build/aui-datatype/aui-datatype.js", "getHoursOffset", 446);
_yuitest_coverline("build/aui-datatype/aui-datatype.js", 447);
return this._absFloor(this.getOffset(d1, d2, this.ONE_HOUR_MS));
	},

	/**
	* Calculates the number of minutes between the specified dates.
	* @method getMinutesOffset
	* @param {Date}	d1 Date 1
	* @param {Date}	d2 Date 2
	* @return {Number}	The number of minutes
	*/
	getMinutesOffset: function(d1, d2) {
		_yuitest_coverfunc("build/aui-datatype/aui-datatype.js", "getMinutesOffset", 457);
_yuitest_coverline("build/aui-datatype/aui-datatype.js", 458);
return this._absFloor(this.getOffset(d1, d2, this.ONE_MINUTE_MS));
	},

	/**
	* Calculates the number of seconds between the specified dates.
	* @method getSecondsOffset
	* @param {Date}	d1 Date 1
	* @param {Date}	d2 Date 2
	* @return {Number}	The number of seconds
	*/
	getSecondsOffset: function(d1, d2) {
		_yuitest_coverfunc("build/aui-datatype/aui-datatype.js", "getSecondsOffset", 468);
_yuitest_coverline("build/aui-datatype/aui-datatype.js", 469);
return this._absFloor(this.getOffset(d1, d2, this.ONE_SECOND_MS));
	},

	getOffset: function(d1, d2, constantAmount) {
		_yuitest_coverfunc("build/aui-datatype/aui-datatype.js", "getOffset", 472);
_yuitest_coverline("build/aui-datatype/aui-datatype.js", 473);
var offset = (d1.getTime()-d2.getTime()) / (constantAmount || 0);

		_yuitest_coverline("build/aui-datatype/aui-datatype.js", 475);
return offset;
	},

    _absFloor: function(n) {
		_yuitest_coverfunc("build/aui-datatype/aui-datatype.js", "_absFloor", 478);
_yuitest_coverline("build/aui-datatype/aui-datatype.js", 479);
var abs = Math.floor(Math.abs(n));

		_yuitest_coverline("build/aui-datatype/aui-datatype.js", 481);
if (n < 0) {
			_yuitest_coverline("build/aui-datatype/aui-datatype.js", 482);
abs *= -1;
		}

        _yuitest_coverline("build/aui-datatype/aui-datatype.js", 485);
return abs;
    },

	/**
	* Calculates the week number for the given date. Can currently support standard
	* U.S. week numbers, based on Jan 1st defining the 1st week of the year, and
	* ISO8601 week numbers, based on Jan 4th defining the 1st week of the year.
	*
	* @method getWeekNumber
	* @param {Date}	date The JavaScript date for which to find the week number
	* @param {Number} firstDayOfWeek The index of the first day of the week (0 = Sun, 1 = Mon ... 6 = Sat).
	* Defaults to 0
	* @param {Number} janDate The date in the first week of January which defines week one for the year
	* Defaults to the value of YAHOO.widget.DateMath.WEEK_ONE_JAN_DATE, which is 1 (Jan 1st).
	* For the U.S, this is normally Jan 1st. ISO8601 uses Jan 4th to define the first week of the year.
	*
	* @return {Number} The number of the week containing the given date.
	*/
	getWeekNumber: function(date, firstDayOfWeek, janDate) {

		// Setup Defaults
		_yuitest_coverfunc("build/aui-datatype/aui-datatype.js", "getWeekNumber", 503);
_yuitest_coverline("build/aui-datatype/aui-datatype.js", 506);
firstDayOfWeek = firstDayOfWeek || 0;
		_yuitest_coverline("build/aui-datatype/aui-datatype.js", 507);
janDate = janDate || this.WEEK_ONE_JAN_DATE;

		_yuitest_coverline("build/aui-datatype/aui-datatype.js", 509);
var targetDate = this.clearTime(date),
			startOfWeek,
			endOfWeek;

		_yuitest_coverline("build/aui-datatype/aui-datatype.js", 513);
if (targetDate.getDay() === firstDayOfWeek) {
			_yuitest_coverline("build/aui-datatype/aui-datatype.js", 514);
startOfWeek = targetDate;
		} else {
			_yuitest_coverline("build/aui-datatype/aui-datatype.js", 516);
startOfWeek = this.getFirstDayOfWeek(targetDate, firstDayOfWeek);
		}

		_yuitest_coverline("build/aui-datatype/aui-datatype.js", 519);
var startYear = startOfWeek.getFullYear(),
			startTime = startOfWeek.getTime();

		// DST shouldn't be a problem here, math is quicker than setDate();
		_yuitest_coverline("build/aui-datatype/aui-datatype.js", 523);
endOfWeek = new Date(startOfWeek.getTime() + 6*this.ONE_DAY_MS);

		_yuitest_coverline("build/aui-datatype/aui-datatype.js", 525);
var weekNum;
		_yuitest_coverline("build/aui-datatype/aui-datatype.js", 526);
if (startYear !== endOfWeek.getFullYear() && endOfWeek.getDate() >= janDate) {
			// If years don't match, endOfWeek is in Jan. and if the
			// week has WEEK_ONE_JAN_DATE in it, it's week one by definition.
			_yuitest_coverline("build/aui-datatype/aui-datatype.js", 529);
weekNum = 1;
		} else {
			// Get the 1st day of the 1st week, and
			// find how many days away we are from it.
			_yuitest_coverline("build/aui-datatype/aui-datatype.js", 533);
var weekOne = this.clearTime(this.getDate(startYear, 0, janDate)),
				weekOneDayOne = this.getFirstDayOfWeek(weekOne, firstDayOfWeek);

			// Round days to smoothen out 1 hr DST diff
			_yuitest_coverline("build/aui-datatype/aui-datatype.js", 537);
var daysDiff  = Math.round((targetDate.getTime() - weekOneDayOne.getTime())/this.ONE_DAY_MS);

			// Calc. Full Weeks
			_yuitest_coverline("build/aui-datatype/aui-datatype.js", 540);
var rem = daysDiff % 7;
			_yuitest_coverline("build/aui-datatype/aui-datatype.js", 541);
var weeksDiff = (daysDiff - rem)/7;
			_yuitest_coverline("build/aui-datatype/aui-datatype.js", 542);
weekNum = weeksDiff + 1;
		}
		_yuitest_coverline("build/aui-datatype/aui-datatype.js", 544);
return weekNum;
	},

	/**
	 * Get the first day of the week, for the give date.
	 * @param {Date} dt The date in the week for which the first day is required.
	 * @param {Number} startOfWeek The index for the first day of the week, 0 = Sun, 1 = Mon ... 6 = Sat (defaults to 0)
	 * @return {Date} The first day of the week
	 */
	getFirstDayOfWeek: function (dt, startOfWeek) {
		_yuitest_coverfunc("build/aui-datatype/aui-datatype.js", "getFirstDayOfWeek", 553);
_yuitest_coverline("build/aui-datatype/aui-datatype.js", 554);
startOfWeek = startOfWeek || 0;
		_yuitest_coverline("build/aui-datatype/aui-datatype.js", 555);
var dayOfWeekIndex = dt.getDay(),
			dayOfWeek = (dayOfWeekIndex - startOfWeek + 7) % 7;

		_yuitest_coverline("build/aui-datatype/aui-datatype.js", 558);
return this.subtract(dt, this.DAY, dayOfWeek);
	},

	/**
	 * Chechs if the passed date is a week day.
	 *
	 * @method isWeekDay
	 * @param {Date} date Date
	 * @return boolean
	 */
	isWeekDay: function(date) {
		_yuitest_coverfunc("build/aui-datatype/aui-datatype.js", "isWeekDay", 568);
_yuitest_coverline("build/aui-datatype/aui-datatype.js", 569);
var day = date.getDay();

		_yuitest_coverline("build/aui-datatype/aui-datatype.js", 571);
return (day > 0) && (day < 6);
	},

	/**
	 * Chechs if the passed date is a Tuesday or Thursday.
	 *
	 * @method isTueOrThu
	 * @param {Date} date Date
	 * @return boolean
	 */
	isTueOrThu: function(date) {
		_yuitest_coverfunc("build/aui-datatype/aui-datatype.js", "isTueOrThu", 581);
_yuitest_coverline("build/aui-datatype/aui-datatype.js", 582);
return this.isWeekDay(date) && (date.getDay() % 2 === 0);
	},

	/**
	 * Chechs if the passed date is a Monday, Wednesday or Friday.
	 *
	 * @method isMonWedOrFri
	 * @param {Date} date Date
	 * @return boolean
	 */
	isMonWedOrFri: function(date) {
		_yuitest_coverfunc("build/aui-datatype/aui-datatype.js", "isMonWedOrFri", 592);
_yuitest_coverline("build/aui-datatype/aui-datatype.js", 593);
return this.isWeekDay(date) && !this.isTueOrThu(date);
	},

	/**
	 * Chechs if the {date2} is the next day.
	 *
	 * @method isNextDay
	 * @param {Date} date1 Date
	 * @param {Date} date2 Date
	 * @return boolean
	 */
	isNextDay: function(date1, date2) {
		_yuitest_coverfunc("build/aui-datatype/aui-datatype.js", "isNextDay", 604);
_yuitest_coverline("build/aui-datatype/aui-datatype.js", 605);
return this.getDayOffset(this.safeClearTime(date2), this.safeClearTime(date1)) === 1;
	},

	/**
	 * Chechs if the {date2} is the next day at 00:00:00.
	 *
	 * @method isNextDayBoundary
	 * @param {Date} date1 Date
	 * @param {Date} date2 Date
	 * @return boolean
	 */
	isDayBoundary: function(date1, date2) {
		_yuitest_coverfunc("build/aui-datatype/aui-datatype.js", "isDayBoundary", 616);
_yuitest_coverline("build/aui-datatype/aui-datatype.js", 617);
return this.isNextDay(date1, date2) && (date2.getHours() === 0) && (date2.getMinutes() === 0) && (date2.getSeconds() === 0);
	},

	/**
	 * Chechs if the passed date is between two days.
	 *
	 * @method isDayOverlap
	 * @param {Date} date1 Date
	 * @param {Date} date2 Date
	 * @return boolean
	 */
	isDayOverlap : function(date1, date2) {
		_yuitest_coverfunc("build/aui-datatype/aui-datatype.js", "isDayOverlap", 628);
_yuitest_coverline("build/aui-datatype/aui-datatype.js", 629);
return ((date1.getFullYear() !== date2.getFullYear()) || (date1.getMonth() !== date2.getMonth()) || (date1.getDate() !== date2.getDate()));;
	},

	/**
	 * Chechs if the passed date is today.
	 *
	 * @method isToday
	 * @param {Date} date Date
	 * @return boolean
	 */
	isToday: function(date) {
		_yuitest_coverfunc("build/aui-datatype/aui-datatype.js", "isToday", 639);
_yuitest_coverline("build/aui-datatype/aui-datatype.js", 640);
return !this.isDayOverlap(date, new Date());
	},

	/**
	 * Chechs if the passed dates are in the same month.
	 *
	 * @method isSameMonth
	 * @param {Date} d1 Date
	 * @param {Date} d2 Date
	 * @return boolean
	 */
	isSameMonth : function(d1, d2) {
		_yuitest_coverfunc("build/aui-datatype/aui-datatype.js", "isSameMonth", 651);
_yuitest_coverline("build/aui-datatype/aui-datatype.js", 652);
return ((d1.getFullYear() === d2.getFullYear()) && (d1.getMonth() === d2.getMonth()));
	},

	/**
	* Determines if a given week overlaps two different years.
	* @method isYearOverlapWeek
	* @param {Date}	weekBeginDate	The JavaScript Date representing the first day of the week.
	* @return {Boolean}	true if the date overlaps two different years.
	*/
	isYearOverlapWeek : function(weekBeginDate) {
		_yuitest_coverfunc("build/aui-datatype/aui-datatype.js", "isYearOverlapWeek", 661);
_yuitest_coverline("build/aui-datatype/aui-datatype.js", 662);
var overlaps = false;
		_yuitest_coverline("build/aui-datatype/aui-datatype.js", 663);
var nextWeek = this.add(weekBeginDate, this.DAY, 6);
		_yuitest_coverline("build/aui-datatype/aui-datatype.js", 664);
if (nextWeek.getFullYear() != weekBeginDate.getFullYear()) {
			_yuitest_coverline("build/aui-datatype/aui-datatype.js", 665);
overlaps = true;
		}
		_yuitest_coverline("build/aui-datatype/aui-datatype.js", 667);
return overlaps;
	},

	/**
	* Determines if a given week overlaps two different months.
	* @method isMonthOverlapWeek
	* @param {Date}	weekBeginDate	The JavaScript Date representing the first day of the week.
	* @return {Boolean}	true if the date overlaps two different months.
	*/
	isMonthOverlapWeek : function(weekBeginDate) {
		_yuitest_coverfunc("build/aui-datatype/aui-datatype.js", "isMonthOverlapWeek", 676);
_yuitest_coverline("build/aui-datatype/aui-datatype.js", 677);
var overlaps = false;
		_yuitest_coverline("build/aui-datatype/aui-datatype.js", 678);
var nextWeek = this.add(weekBeginDate, this.DAY, 6);
		_yuitest_coverline("build/aui-datatype/aui-datatype.js", 679);
if (nextWeek.getMonth() != weekBeginDate.getMonth()) {
			_yuitest_coverline("build/aui-datatype/aui-datatype.js", 680);
overlaps = true;
		}
		_yuitest_coverline("build/aui-datatype/aui-datatype.js", 682);
return overlaps;
	},

	/**
	* Gets the first day of a month containing a given date.
	* @method findMonthStart
	* @param {Date}	date	The JavaScript Date used to calculate the month start
	* @return {Date}		The JavaScript Date representing the first day of the month
	*/
	findMonthStart : function(date) {
		_yuitest_coverfunc("build/aui-datatype/aui-datatype.js", "findMonthStart", 691);
_yuitest_coverline("build/aui-datatype/aui-datatype.js", 692);
var start = this.getDate(date.getFullYear(), date.getMonth(), 1);
		_yuitest_coverline("build/aui-datatype/aui-datatype.js", 693);
return start;
	},

	/**
	* Gets the last day of a month containing a given date.
	* @method findMonthEnd
	* @param {Date}	date	The JavaScript Date used to calculate the month end
	* @return {Date}		The JavaScript Date representing the last day of the month
	*/
	findMonthEnd : function(date) {
		_yuitest_coverfunc("build/aui-datatype/aui-datatype.js", "findMonthEnd", 702);
_yuitest_coverline("build/aui-datatype/aui-datatype.js", 703);
var start = this.findMonthStart(date);
		_yuitest_coverline("build/aui-datatype/aui-datatype.js", 704);
var nextMonth = this.add(start, this.MONTH, 1);
		_yuitest_coverline("build/aui-datatype/aui-datatype.js", 705);
var end = this.subtract(nextMonth, this.DAY, 1);
		_yuitest_coverline("build/aui-datatype/aui-datatype.js", 706);
end.setHours(23,59,59,999);
		_yuitest_coverline("build/aui-datatype/aui-datatype.js", 707);
return end;
	},

	/**
	* Clears the time fields from a given date, effectively setting the time to 12 noon.
	* @method clearTime
	* @param {Date}	date	The JavaScript Date for which the time fields will be cleared
	* @return {Date}		The JavaScript Date cleared of all time fields
	*/
	clearTime : function(date) {
		_yuitest_coverfunc("build/aui-datatype/aui-datatype.js", "clearTime", 716);
_yuitest_coverline("build/aui-datatype/aui-datatype.js", 717);
date.setHours(12,0,0,0);
		_yuitest_coverline("build/aui-datatype/aui-datatype.js", 718);
return date;
	},

	/**
	* Clears the time fields from a given date, effectively setting the time to
	* 12 noon. This is "safe" because clones the date before clear, not affecting
	* the passed reference.
	* @method safeClearTime
	* @param {Date}	date	The JavaScript Date for which the time fields will be cleared
	* @return {Date}		The JavaScript Date cleared of all time fields
	*/
	safeClearTime : function(date) {
		_yuitest_coverfunc("build/aui-datatype/aui-datatype.js", "safeClearTime", 729);
_yuitest_coverline("build/aui-datatype/aui-datatype.js", 730);
return this.clearTime(this.clone(date));
	},

	/**
	* Set the time fields from a given date to the last possible hour.
	* @method toLastHour
	* @param {Date}	date	The JavaScript Date for which the time fields will be set to the last possible hour
	* @return {Date}		The JavaScript Date set to the last possible hour
	*/
	toLastHour: function(date) {
		_yuitest_coverfunc("build/aui-datatype/aui-datatype.js", "toLastHour", 739);
_yuitest_coverline("build/aui-datatype/aui-datatype.js", 740);
date.setHours(23,59,59,999);
		_yuitest_coverline("build/aui-datatype/aui-datatype.js", 741);
return date;
	},

	/**
	* Set the time fields from a given date to midnight.
	* @method toMidnight
	* @param {Date}	date	The JavaScript Date for which the time fields will be set to midnight
	* @return {Date}		The JavaScript Date set to midnight
	*/
	toMidnight: function(date) {
		_yuitest_coverfunc("build/aui-datatype/aui-datatype.js", "toMidnight", 750);
_yuitest_coverline("build/aui-datatype/aui-datatype.js", 751);
date.setHours(0,0,0,0);
		_yuitest_coverline("build/aui-datatype/aui-datatype.js", 752);
return date;
	},

	/**
	* Clone the passed date object.
	* @method clone
	* @param {Date}	date	The JavaScript Date to clone
	* @return {Date}		The JavaScript Date cloned
	*/
	clone : function(date) {
		_yuitest_coverfunc("build/aui-datatype/aui-datatype.js", "clone", 761);
_yuitest_coverline("build/aui-datatype/aui-datatype.js", 762);
return new Date(date.getTime());
	},

	/**
	 * Returns a new JavaScript Date object, representing the given year, month and date. Time fields (hr, min, sec, ms) on the new Date object
	 * are set to 0. The method allows Date instances to be created with the a year less than 100. "new Date(year, month, date)" implementations
	 * set the year to 19xx if a year (xx) which is less than 100 is provided.
	 * <p>
	 * <em>NOTE:</em>Validation on argument values is not performed. It is the caller's responsibility to ensure
	 * arguments are valid as per the ECMAScript-262 Date object specification for the new Date(year, month[, date]) constructor.
	 * </p>
	 * @method getDate
	 * @param {Number} y Year.
	 * @param {Number} m Month index from 0 (Jan) to 11 (Dec).
	 * @param {Number} d (optional) Date from 1 to 31. If not provided, defaults to 1.
	 * @return {Date} The JavaScript date object with year, month, date set as provided.
	 */
	getDate : function(y, m, d) {
		_yuitest_coverfunc("build/aui-datatype/aui-datatype.js", "getDate", 779);
_yuitest_coverline("build/aui-datatype/aui-datatype.js", 780);
var dt = null;
		_yuitest_coverline("build/aui-datatype/aui-datatype.js", 781);
if (!isValue(d)) {
			_yuitest_coverline("build/aui-datatype/aui-datatype.js", 782);
d = 1;
		}
		_yuitest_coverline("build/aui-datatype/aui-datatype.js", 784);
if (y >= 100) {
			_yuitest_coverline("build/aui-datatype/aui-datatype.js", 785);
dt = new Date(y, m, d);
		} else {
			_yuitest_coverline("build/aui-datatype/aui-datatype.js", 787);
dt = new Date();
			_yuitest_coverline("build/aui-datatype/aui-datatype.js", 788);
dt.setFullYear(y);
			_yuitest_coverline("build/aui-datatype/aui-datatype.js", 789);
dt.setMonth(m);
			_yuitest_coverline("build/aui-datatype/aui-datatype.js", 790);
dt.setDate(d);
			_yuitest_coverline("build/aui-datatype/aui-datatype.js", 791);
dt.setHours(0,0,0,0);
		}
		_yuitest_coverline("build/aui-datatype/aui-datatype.js", 793);
return dt;
	},

	getDaysInMonth: function(year, month) {
		_yuitest_coverfunc("build/aui-datatype/aui-datatype.js", "getDaysInMonth", 796);
_yuitest_coverline("build/aui-datatype/aui-datatype.js", 797);
return this.findMonthEnd(this.getDate(year, month)).getDate();
    },

	toUsTimeString: function(date, padHours, omitMinutes, hideAmPm) {
		_yuitest_coverfunc("build/aui-datatype/aui-datatype.js", "toUsTimeString", 800);
_yuitest_coverline("build/aui-datatype/aui-datatype.js", 801);
date = isDate(date) ? date : new Date(0, 0, 0, date);

		_yuitest_coverline("build/aui-datatype/aui-datatype.js", 803);
var hours = date.getHours();
		_yuitest_coverline("build/aui-datatype/aui-datatype.js", 804);
var minutes = date.getMinutes();
		_yuitest_coverline("build/aui-datatype/aui-datatype.js", 805);
var isPM = false;

		_yuitest_coverline("build/aui-datatype/aui-datatype.js", 807);
if (hours >= 12) {
			_yuitest_coverline("build/aui-datatype/aui-datatype.js", 808);
isPM = true;

			_yuitest_coverline("build/aui-datatype/aui-datatype.js", 810);
if (hours > 12) {
				_yuitest_coverline("build/aui-datatype/aui-datatype.js", 811);
hours -= 12;
			}
		}
		else {_yuitest_coverline("build/aui-datatype/aui-datatype.js", 814);
if (hours === 0) {
			_yuitest_coverline("build/aui-datatype/aui-datatype.js", 815);
hours = 12;
		}}

		_yuitest_coverline("build/aui-datatype/aui-datatype.js", 818);
var time = padHours ? S.padNumber(hours, 2) : String(hours);

		_yuitest_coverline("build/aui-datatype/aui-datatype.js", 820);
if (!omitMinutes) {
			_yuitest_coverline("build/aui-datatype/aui-datatype.js", 821);
time += COLON;
			_yuitest_coverline("build/aui-datatype/aui-datatype.js", 822);
time += S.padNumber(minutes, 2);
		}

		_yuitest_coverline("build/aui-datatype/aui-datatype.js", 825);
if (!hideAmPm) {
			_yuitest_coverline("build/aui-datatype/aui-datatype.js", 826);
time += (isPM ? PM : AM);
		}

		_yuitest_coverline("build/aui-datatype/aui-datatype.js", 829);
return time;
	},

	toIsoTimeString: function(date, showSeconds) {
		_yuitest_coverfunc("build/aui-datatype/aui-datatype.js", "toIsoTimeString", 832);
_yuitest_coverline("build/aui-datatype/aui-datatype.js", 833);
date = isDate(date) ? date : new Date(0, 0, 0, date);

		_yuitest_coverline("build/aui-datatype/aui-datatype.js", 835);
var hours = date.getHours();
		_yuitest_coverline("build/aui-datatype/aui-datatype.js", 836);
var minutes = date.getMinutes();
		_yuitest_coverline("build/aui-datatype/aui-datatype.js", 837);
var time = S.padNumber(hours, 2) + COLON + S.padNumber(minutes, 2);

		_yuitest_coverline("build/aui-datatype/aui-datatype.js", 839);
if (showSeconds) {
			_yuitest_coverline("build/aui-datatype/aui-datatype.js", 840);
var seconds = date.getSeconds();

			_yuitest_coverline("build/aui-datatype/aui-datatype.js", 842);
time += COLON;
			_yuitest_coverline("build/aui-datatype/aui-datatype.js", 843);
time += S.padNumber(seconds, 2);
		}

		_yuitest_coverline("build/aui-datatype/aui-datatype.js", 846);
return time;
	}
});

_yuitest_coverline("build/aui-datatype/aui-datatype.js", 850);
(function(Y) {
	// See http://yuilibrary.com/projects/yui3/ticket/2532862

	/**
	 * @module datatype
	*/

	/**
	 * The Date.Locale class is a container for all localised date strings
	 * used by Y.DataType.Date. It is used internally, but may be extended
	 * to provide new date localisations.
	 *
	 * To create your own Locale, follow these steps:
	 * <ol>
	 *  <li>Find an existing locale that matches closely with your needs</li>
	 *  <li>Use this as your base class.  Use Y.DataType.Date.Locale["en"] if nothing
	 *   matches.</li>
	 *  <li>Create your own class as an extension of the base class using
	 *   Y.merge, and add your own localisations where needed.</li>
	 * </ol>
	 * See the Y.DataType.Date.Locale["en-US"] and Y.DataType.Date.Locale["en-GB"]
	 * classes which extend Y.DataType.Date.Locale["en"].
	 *
	 * For example, to implement locales for French french and Canadian french,
	 * we would do the following:
	 * <ol>
	 *  <li>For French french, we have no existing similar locale, so use
	 *   Y.DataType.Date.Locale["en"] as the base, and extend it:
	 *   <pre>
	 *      Y.DataType.Date.Locale["fr"] = Y.merge(Y.DataType.Date.Locale["en"], {
	 *          a: ["dim", "lun", "mar", "mer", "jeu", "ven", "sam"],
	 *          A: ["dimanche", "lundi", "mardi", "mercredi", "jeudi", "vendredi", "samedi"],
	 *          b: ["jan", "f&eacute;v", "mar", "avr", "mai", "jun", "jui", "ao&ucirc;", "sep", "oct", "nov", "d&eacute;c"],
	 *          B: ["janvier", "f&eacute;vrier", "mars", "avril", "mai", "juin", "juillet", "ao&ucirc;t", "septembre", "octobre", "novembre", "d&eacute;cembre"],
	 *          c: "%a %d %b %Y %T %Z",
	 *          p: ["", ""],
	 *          P: ["", ""],
	 *          x: "%d.%m.%Y",
	 *          X: "%T"
	 *      });
	 *   </pre>
	 *  </li>
	 *  <li>For Canadian french, we start with French french and change the meaning of \%x:
	 *   <pre>
	 *      Y.DataType.Date.Locale["fr-CA"] = Y.merge(Y.DataType.Date.Locale["fr"], {
	 *          x: "%Y-%m-%d"
	 *      });
	 *   </pre>
	 *  </li>
	 * </ol>
	 *
	 * With that, you can use your new locales:
	 * <pre>
	 *    var d = new Date("2008/04/22");
	 *    Y.DataType.Date.format(d, { format: "%A, %d %B == %x", locale: "fr" });
	 * </pre>
	 * will return:
	 * <pre>
	 *    mardi, 22 avril == 22.04.2008
	 * </pre>
	 * And
	 * <pre>
	 *    Y.DataType.Date.format(d, {format: "%A, %d %B == %x", locale: "fr-CA" });
	 * </pre>
	 * Will return:
	 * <pre>
	 *   mardi, 22 avril == 2008-04-22
	 * </pre>
	 * @requires oop
	 * @class DataType.Date.Locale
	 * @static
	 * @deprecated - use Y.config.lang to request one of many built-in languages instead.
	 */
	_yuitest_coverfunc("build/aui-datatype/aui-datatype.js", "(anonymous 2)", 850);
_yuitest_coverline("build/aui-datatype/aui-datatype.js", 923);
var YDateEn = {
		a: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"],
		A: ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"],
		b: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"],
		B: ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"],
		c: "%a %d %b %Y %T %Z",
		p: ["AM", "PM"],
		P: ["am", "pm"],
		r: "%I:%M:%S %p",
		x: "%d/%m/%y",
		X: "%T"
	};

	_yuitest_coverline("build/aui-datatype/aui-datatype.js", 936);
Y.namespace("DataType.Date.Locale");

	_yuitest_coverline("build/aui-datatype/aui-datatype.js", 938);
Y.DataType.Date.Locale["en"] = YDateEn;

	_yuitest_coverline("build/aui-datatype/aui-datatype.js", 940);
Y.DataType.Date.Locale["en-US"] = Y.merge(YDateEn, {
		c: "%a %d %b %Y %I:%M:%S %p %Z",
		x: "%m/%d/%Y",
		X: "%I:%M:%S %p"
	});

	_yuitest_coverline("build/aui-datatype/aui-datatype.js", 946);
Y.DataType.Date.Locale["en-GB"] = Y.merge(YDateEn, {
		r: "%l:%M:%S %P %Z"
	});
	_yuitest_coverline("build/aui-datatype/aui-datatype.js", 949);
Y.DataType.Date.Locale["en-AU"] = Y.merge(YDateEn);
}(A));


}, '2.0.0pr1', {"requires": ["datatype"]});
