if (typeof _yuitest_coverage == "undefined"){
    _yuitest_coverage = {};
    _yuitest_coverline = function(src, line){
        var coverage = _yuitest_coverage[src];
        if (!coverage.lines[line]){
            coverage.calledLines++;
        }
        coverage.lines[line]++;
    };
    _yuitest_coverfunc = function(src, name, line){
        var coverage = _yuitest_coverage[src],
            funcId = name + ":" + line;
        if (!coverage.functions[funcId]){
            coverage.calledFunctions++;
        }
        coverage.functions[funcId]++;
    };
}
_yuitest_coverage["build/aui-io-request/aui-io-request.js"] = {
    lines: {},
    functions: {},
    coveredLines: 0,
    calledLines: 0,
    coveredFunctions: 0,
    calledFunctions: 0,
    path: "build/aui-io-request/aui-io-request.js",
    code: []
};
_yuitest_coverage["build/aui-io-request/aui-io-request.js"].code=["YUI.add('aui-io-request', function (A, NAME) {","","/**"," * The IORequest Utility - Provides response data normalization for XML, JSON,"," * JavaScript and cache option."," *"," * @module aui-io"," * @submodule aui-io-request"," */","","var L = A.Lang,","	isBoolean = L.isBoolean,","	isFunction = L.isFunction,","	isString = L.isString,","","	defaults = YUI.namespace('defaults.io'),","","	getDefault = function(attr) {","		return function() {","			return defaults[attr];","		};","	},","","	ACTIVE = 'active',","	ARGUMENTS = 'arguments',","	AUTO_LOAD = 'autoLoad',","	CACHE = 'cache',","	CFG = 'cfg',","	COMPLETE = 'complete',","	CONTENT_TYPE = 'content-type',","	CONTEXT = 'context',","	DATA = 'data',","	DATA_TYPE = 'dataType',","	EMPTY_STRING = '',","	END = 'end',","	FAILURE = 'failure',","	FORM = 'form',","	GET = 'get',","	HEADERS = 'headers',","	IO_REQUEST = 'IORequest',","	JSON = 'json',","	METHOD = 'method',","	RESPONSE_DATA = 'responseData',","	START = 'start',","	SUCCESS = 'success',","	SYNC = 'sync',","	TIMEOUT = 'timeout',","	TRANSACTION = 'transaction',","	URI = 'uri',","	XDR = 'xdr',","	XML = 'xml',","","	PARSE_ERROR = 'Parser error: IO dataType is not correctly parsing',","","	ACCEPTS = {","		all: '*/*',","		html: 'text/html',","		json: 'application/json, text/javascript',","		text: 'text/plain',","		xml: 'application/xml, text/xml'","	};","","/**"," * A base class for IORequest, providing:"," * <ul>"," *    <li>Response data normalization for XML, JSON, JavaScript</li>"," *    <li>Cache options</li>"," * </ul>"," *"," * Quick Example:<br/>"," *"," * <pre><code>A.io.request(uri, config);</code></pre>"," *"," * Check the list of <a href=\"IORequest.html#configattributes\">Configuration Attributes</a> available for"," * IORequest."," *"," * @param config {Object} Object literal specifying widget configuration properties."," *"," * @class IORequest"," * @constructor"," * @extends Plugin.Base"," * @uses io"," */","var IORequest = A.Component.create(","	{","		/**","		 * Static property provides a string to identify the class.","		 *","		 * @property IORequest.NAME","		 * @type String","		 * @static","		 */","		NAME: IO_REQUEST,","","		/**","		 * Static property used to define the default attribute","		 * configuration for the IORequest.","		 *","		 * @property IORequest.ATTRS","		 * @type Object","		 * @static","		 */","		ATTRS: {","			/**","			 * If <code>true</code> invoke the","	         * <a href=\"IORequest.html#method_start\">start</a> method automatically,","	         * initializing the IO transaction.","			 *","			 * @attribute autoLoad","			 * @default true","			 * @type boolean","			 */","			autoLoad: {","				value: true,","				validator: isBoolean","			},","","			/**","			 * If <code>false</code> the current timestamp will be appended to the","	         * url, avoiding the url to be cached.","			 *","			 * @attribute cache","			 * @default true","			 * @type boolean","			 */","			cache: {","				value: true,","				validator: isBoolean","			},","","			/**","			 * The type of the request (i.e., could be xml, json, javascript, text).","			 *","			 * @attribute dataType","			 * @default null","			 * @type String","			 */","			dataType: {","				setter: function(v) {","					return (v || EMPTY_STRING).toLowerCase();","				},","				value: null,","				validator: isString","			},","","			/**","			 * This is a normalized attribute for the response data. It's useful","	         * to retrieve the correct type for the","	         * <a href=\"IORequest.html#config_dataType\">dataType</a> (i.e., in json","	         * requests the <code>responseData</code>) is a JSONObject.","			 *","			 * @attribute responseData","			 * @default null","			 * @type String | JSONObject | XMLDocument","			 */","			responseData: {","				setter: function(v) {","					return this._setResponseData(v);","				},","				value: null","			},","","			/**","			 * URI to be requested using AJAX.","			 *","			 * @attribute uri","			 * @default null","			 * @type String","			 */","			uri: {","				setter: function(v) {","					return this._parseURL(v);","				},","				value: null,","				validator: isString","			},","","			// User readOnly variables","","			/**","			 * Whether the transaction is active or not.","			 *","			 * @attribute active","			 * @default false","			 * @type boolean","			 */","			active: {","				value: false,","				validator: isBoolean","			},","","			/**","			 * Object containing all the","	         * <a href=\"io.html#configattributes\">IO Configuration Attributes</a>.","	         * This Object is passed to the <code>A.io</code> internally.","			 *","			 * @attribute cfg","			 * @default Object containing all the","	         * <a href=\"io.html#configattributes\">IO Configuration Attributes</a>.","	         * @readOnly","			 * @type String","			 */","			cfg: {","				getter: function() {","					var instance = this;","","					// keep the current cfg object always synchronized with the mapped public attributes","					// when the user call .start() it always retrieve the last set values for each mapped attr","					return {","						arguments: instance.get(ARGUMENTS),","						context: instance.get(CONTEXT),","						data: instance.getFormattedData(),","						form: instance.get(FORM),","						headers: instance.get(HEADERS),","						method: instance.get(METHOD),","						on: {","							complete: A.bind(instance.fire, instance, COMPLETE),","							end: A.bind(instance._end, instance),","							failure: A.bind(instance.fire, instance, FAILURE),","							start: A.bind(instance.fire, instance, START),","							success: A.bind(instance._success, instance)","						},","						sync: instance.get(SYNC),","						timeout: instance.get(TIMEOUT),","						xdr: instance.get(XDR)","					};","				},","				readOnly: true","			},","","			/**","			 * Stores the IO Object of the current transaction.","			 *","			 * @attribute transaction","			 * @default null","			 * @type Object","			 */","			transaction: {","				value: null","			},","","			// Configuration Object mapping","			// To take advantages of the Attribute listeners of A.Base","			// See: http://developer.yahoo.com/yui/3/io/","","			/**","			 * See <a href=\"http://developer.yahoo.com/yui/3/io/#configuration\">IO","	        * Configuration</a>.","			 *","			 * @attribute arguments","			 * @default Value mapped on YUI.AUI.defaults.io.","			 * @type Object","			 */","			arguments: {","				valueFn: getDefault(ARGUMENTS)","			},","","			/**","			 * See <a href=\"http://developer.yahoo.com/yui/3/io/#configuration\">IO","	        * Configuration</a>.","			 *","			 * @attribute context","			 * @default Value mapped on YUI.AUI.defaults.io.","			 * @type Object","			 */","			context: {","				valueFn: getDefault(CONTEXT)","			},","","			/**","			 * See <a href=\"http://developer.yahoo.com/yui/3/io/#configuration\">IO","	        * Configuration</a>.","			 *","			 * @attribute data","			 * @default Value mapped on YUI.AUI.defaults.io.","			 * @type Object","			 */","			data: {","				valueFn: getDefault(DATA)","			},","","			/**","			 * See <a href=\"http://developer.yahoo.com/yui/3/io/#configuration\">IO","	        * Configuration</a>.","			 *","			 * @attribute form","			 * @default Value mapped on YUI.AUI.defaults.io.","			 * @type Object","			 */","			form: {","				valueFn: getDefault(FORM)","			},","","			/**","			 * Set the correct ACCEPT header based on the dataType.","			 *","			 * @attribute headers","			 * @default Object","			 * @type Object","			 */","			headers: {","				getter: function(value) {","					var header = [];","					var instance = this;","					var dataType = instance.get(DATA_TYPE);","","					if (dataType) {","						header.push(","							ACCEPTS[dataType]","						);","					}","","					// always add *.* to the accept header","					header.push(","						ACCEPTS.all","					);","","					return A.merge(","						value,","						{","							Accept: header.join(', ')","						}","					);","				},","				valueFn: getDefault(HEADERS)","			},","","			/**","			 * See <a href=\"http://developer.yahoo.com/yui/3/io/#configuration\">IO","	        * Configuration</a>.","			 *","			 * @attribute method","			 * @default Value mapped on YUI.AUI.defaults.io.","			 * @type String","			 */","			method: {","				valueFn: getDefault(METHOD)","			},","","			/**","			 * A selector to be used to query against the response of the","			 * request. Only works if the response is XML or HTML.","			 *","			 * @attribute selector","			 * @type string","			 */","			selector: {","				value: null","			},","","			/**","			 * See <a href=\"http://developer.yahoo.com/yui/3/io/#configuration\">IO","	        * Configuration</a>.","			 *","			 * @attribute sync","			 * @default Value mapped on YUI.AUI.defaults.io.","			 * @type boolean","			 */","			sync: {","				valueFn: getDefault(SYNC)","			},","","			/**","			 * See <a href=\"http://developer.yahoo.com/yui/3/io/#configuration\">IO","	        * Configuration</a>.","			 *","			 * @attribute timeout","			 * @default Value mapped on YUI.AUI.defaults.io.","			 * @type Number","			 */","			timeout: {","				valueFn: getDefault(TIMEOUT)","			},","","			/**","			 * See <a href=\"http://developer.yahoo.com/yui/3/io/#configuration\">IO","	         * Configuration</a>.","			 *","			 * @attribute xdr","			 * @default Value mapped on YUI.AUI.defaults.io.","			 * @type Object","			 */","			xdr: {","				valueFn: getDefault(XDR)","			}","		},","","		EXTENDS: A.Plugin.Base,","","		prototype: {","			/**","			 * Construction logic executed during IORequest instantiation. Lifecycle.","			 *","			 * @method initializer","			 * @protected","			 */","			init: function(config) {","				var instance = this;","","				IORequest.superclass.init.apply(this, arguments);","","				instance._autoStart();","			},","","			/**","			 * Descructor lifecycle implementation for the IORequest class.","			 * Purges events attached to the node (and all child nodes).","			 *","			 * @method destructor","			 * @protected","			 */","			destructor: function() {","				var instance = this;","","				instance.stop();","","				instance.set(TRANSACTION, null);","			},","","			/**","			 * Applies the <code>YUI.AUI.defaults.io.dataFormatter</code> if defined and return the formatted data.","			 *","			 * @method getFormattedData","			 * @protected","			 * @return {String}","			 */","			getFormattedData: function() {","				var instance = this;","				var value = instance.get(DATA);","				var dataFormatter = defaults.dataFormatter;","","				if (isFunction(dataFormatter)) {","					value = dataFormatter.call(instance, value);","				}","","				return value;","			},","","			/**","			 * Starts the IO transaction. Used to refresh the content also.","			 *","			 * @method start","			 */","			start: function() {","				var instance = this;","","				instance.destructor();","","				instance.set(ACTIVE, true);","","				var ioObj = instance._yuiIOObj;","","				if (!ioObj) {","					ioObj = new A.IO();","","					instance._yuiIOObj = ioObj;","				}","","				var transaction = ioObj.send(","					instance.get(URI),","					instance.get(CFG)","				);","","				instance.set(TRANSACTION, transaction);","			},","","			/**","			 * Stops the IO transaction.","			 *","			 * @method stop","			 */","			stop: function() {","				var instance = this;","				var transaction = instance.get(TRANSACTION);","","				if (transaction) {","					transaction.abort();","				}","			},","","			/**","			 * Invoke the <code>start</code> method (autoLoad attribute).","			 *","			 * @method _autoStart","			 * @protected","			 */","			_autoStart: function() {","				var instance = this;","","				if (instance.get(AUTO_LOAD)) {","					instance.start();","				}","			},","","			/**","			 * Parse the <a href=\"IORequest.html#config_uri\">uri</a> to add a","		     * timestamp if <a href=\"IORequest.html#config_cache\">cache</a> is","		     * <code>true</code>. Also applies the","		     * <code>YUI.AUI.defaults.io.uriFormatter</code>.","			 *","			 * @method _parseURL","			 * @param {String} url","			 * @protected","			 * @return {String}","			 */","			_parseURL: function(url) {","				var instance = this;","				var cache = instance.get(CACHE);","				var method = instance.get(METHOD);","","				// reusing logic to add a timestamp on the url from jQuery 1.3.2","				if ( (cache === false) && (method == GET) ) {","					var ts = +new Date;","					// try replacing _= if it is there","					var ret = url.replace(/(\\?|&)_=.*?(&|$)/, '$1_=' + ts + '$2');","					// if nothing was replaced, add timestamp to the end","					url = ret + ((ret == url) ? (url.match(/\\?/) ? '&' : '?') + '_=' + ts : '');","				}","","				// formatting the URL with the default uriFormatter after the cache timestamp was added","				var uriFormatter = defaults.uriFormatter;","","				if (isFunction(uriFormatter)) {","					url = uriFormatter.apply(instance, [url]);","				}","","				return url;","			},","","			/**","			 * Internal end callback for the IO transaction.","			 *","			 * @method _end","			 * @param {Number} id ID of the IO transaction.","			 * @param {Object} args Custom arguments, passed to the event handler. See <a href=\"http://developer.yahoo.com/yui/3/io/#configuration\">IO","			 * @protected","			 */","			_end: function(id, args) {","				var instance = this;","","				instance.set(ACTIVE, false);","				instance.set(TRANSACTION, null);","","				instance.fire(END, id, args);","			},","","			/**","			 * Internal success callback for the IO transaction.","			 *","			 * @method _success","			 * @param {Number} id ID of the IO transaction.","			 * @param {Object} obj IO transaction Object.","			 * @param {Object} args Custom arguments, passed to the event handler. See <a href=\"http://developer.yahoo.com/yui/3/io/#configuration\">IO","			 * @protected","			 */","			_success: function(id, obj, args) {","				var instance = this;","","				// update the responseData attribute with the new data from xhr","				instance.set(RESPONSE_DATA, obj);","","				instance.fire(SUCCESS, id, obj, args);","			},","","			/**","			 * Setter for <a href=\"IORequest.html#config_responseData\">responseData</a>.","			 *","			 * @method _setResponseData","			 * @protected","			 * @param {Object} xhr XHR Object.","			 * @return {Object}","			 */","			_setResponseData: function(xhr) {","				var data = null;","				var instance = this;","","				if (xhr) {","					var dataType = instance.get(DATA_TYPE);","					var contentType = xhr.getResponseHeader(CONTENT_TYPE) || '';","","					// if the dataType or the content-type is XML...","					if ((dataType == XML) ||","						(!dataType && contentType.indexOf(XML) >= 0)) {","","						// use responseXML","						data = xhr.responseXML;","","						// check if the XML was parsed correctly","						if (data.documentElement.tagName == 'parsererror') {","							throw PARSE_ERROR;","						}","					}","					else {","						// otherwise use the responseText","						data = xhr.responseText;","					}","","					// empty string is not a valid JSON, convert it to null","					if (data === EMPTY_STRING) {","						data = null;","					}","","					// trying to parse to JSON if dataType is a valid json","					if (dataType == JSON) {","						try {","							data = A.JSON.parse(data);","						}","						catch(e) {","							// throw PARSE_ERROR;","						}","					}","					else {","						var selector = instance.get('selector');","","						if (data && selector) {","							var tempRoot;","","							if (data.documentElement) {","								tempRoot = A.one(data);","							}","							else {","								tempRoot = A.Node.create(data);","							}","","							data = tempRoot.all(selector);","						}","					}","				}","","				return data;","			}","		}","	}",");","","A.IORequest = IORequest;","","/**"," * Alloy IO extension"," *"," * @class A.io"," * @static"," */","","/**"," * Static method to invoke the <a href=\"IORequest.html\">IORequest</a>. Likewise <a href=\"io.html#method_io\">io</a>."," *"," * @method A.io.request"," * @for A.io"," * @param {String} uri URI to be requested."," * @param {Object} config Configuration Object for the <a href=\"io.html\">IO</a>."," * @return {IORequest}"," */","A.io.request = function(uri, config) {","	return new A.IORequest(","		A.merge(config, {","			uri: uri","		})","	);","};","","}, '2.0.0pr1', {\"requires\": [\"io-base\", \"json\", \"plugin\", \"querystring-stringify\", \"aui-component\"]});"];
_yuitest_coverage["build/aui-io-request/aui-io-request.js"].lines = {"1":0,"11":0,"19":0,"20":0,"84":0,"140":0,"158":0,"172":0,"205":0,"209":0,"303":0,"304":0,"305":0,"307":0,"308":0,"314":0,"318":0,"398":0,"400":0,"402":0,"413":0,"415":0,"417":0,"428":0,"429":0,"430":0,"432":0,"433":0,"436":0,"445":0,"447":0,"449":0,"451":0,"453":0,"454":0,"456":0,"459":0,"464":0,"473":0,"474":0,"476":0,"477":0,"488":0,"490":0,"491":0,"507":0,"508":0,"509":0,"512":0,"513":0,"515":0,"517":0,"521":0,"523":0,"524":0,"527":0,"539":0,"541":0,"542":0,"544":0,"557":0,"560":0,"562":0,"574":0,"575":0,"577":0,"578":0,"579":0,"582":0,"586":0,"589":0,"590":0,"595":0,"599":0,"600":0,"604":0,"605":0,"606":0,"613":0,"615":0,"616":0,"618":0,"619":0,"622":0,"625":0,"630":0,"636":0,"654":0,"655":0};
_yuitest_coverage["build/aui-io-request/aui-io-request.js"].functions = {"(anonymous 2):19":0,"getDefault:18":0,"setter:139":0,"setter:157":0,"setter:171":0,"getter:204":0,"getter:302":0,"init:397":0,"destructor:412":0,"getFormattedData:427":0,"start:444":0,"stop:472":0,"_autoStart:487":0,"_parseURL:506":0,"_end:538":0,"_success:556":0,"_setResponseData:573":0,"request:654":0,"(anonymous 1):1":0};
_yuitest_coverage["build/aui-io-request/aui-io-request.js"].coveredLines = 89;
_yuitest_coverage["build/aui-io-request/aui-io-request.js"].coveredFunctions = 19;
_yuitest_coverline("build/aui-io-request/aui-io-request.js", 1);
YUI.add('aui-io-request', function (A, NAME) {

/**
 * The IORequest Utility - Provides response data normalization for XML, JSON,
 * JavaScript and cache option.
 *
 * @module aui-io
 * @submodule aui-io-request
 */

_yuitest_coverfunc("build/aui-io-request/aui-io-request.js", "(anonymous 1)", 1);
_yuitest_coverline("build/aui-io-request/aui-io-request.js", 11);
var L = A.Lang,
	isBoolean = L.isBoolean,
	isFunction = L.isFunction,
	isString = L.isString,

	defaults = YUI.namespace('defaults.io'),

	getDefault = function(attr) {
		_yuitest_coverfunc("build/aui-io-request/aui-io-request.js", "getDefault", 18);
_yuitest_coverline("build/aui-io-request/aui-io-request.js", 19);
return function() {
			_yuitest_coverfunc("build/aui-io-request/aui-io-request.js", "(anonymous 2)", 19);
_yuitest_coverline("build/aui-io-request/aui-io-request.js", 20);
return defaults[attr];
		};
	},

	ACTIVE = 'active',
	ARGUMENTS = 'arguments',
	AUTO_LOAD = 'autoLoad',
	CACHE = 'cache',
	CFG = 'cfg',
	COMPLETE = 'complete',
	CONTENT_TYPE = 'content-type',
	CONTEXT = 'context',
	DATA = 'data',
	DATA_TYPE = 'dataType',
	EMPTY_STRING = '',
	END = 'end',
	FAILURE = 'failure',
	FORM = 'form',
	GET = 'get',
	HEADERS = 'headers',
	IO_REQUEST = 'IORequest',
	JSON = 'json',
	METHOD = 'method',
	RESPONSE_DATA = 'responseData',
	START = 'start',
	SUCCESS = 'success',
	SYNC = 'sync',
	TIMEOUT = 'timeout',
	TRANSACTION = 'transaction',
	URI = 'uri',
	XDR = 'xdr',
	XML = 'xml',

	PARSE_ERROR = 'Parser error: IO dataType is not correctly parsing',

	ACCEPTS = {
		all: '*/*',
		html: 'text/html',
		json: 'application/json, text/javascript',
		text: 'text/plain',
		xml: 'application/xml, text/xml'
	};

/**
 * A base class for IORequest, providing:
 * <ul>
 *    <li>Response data normalization for XML, JSON, JavaScript</li>
 *    <li>Cache options</li>
 * </ul>
 *
 * Quick Example:<br/>
 *
 * <pre><code>A.io.request(uri, config);</code></pre>
 *
 * Check the list of <a href="IORequest.html#configattributes">Configuration Attributes</a> available for
 * IORequest.
 *
 * @param config {Object} Object literal specifying widget configuration properties.
 *
 * @class IORequest
 * @constructor
 * @extends Plugin.Base
 * @uses io
 */
_yuitest_coverline("build/aui-io-request/aui-io-request.js", 84);
var IORequest = A.Component.create(
	{
		/**
		 * Static property provides a string to identify the class.
		 *
		 * @property IORequest.NAME
		 * @type String
		 * @static
		 */
		NAME: IO_REQUEST,

		/**
		 * Static property used to define the default attribute
		 * configuration for the IORequest.
		 *
		 * @property IORequest.ATTRS
		 * @type Object
		 * @static
		 */
		ATTRS: {
			/**
			 * If <code>true</code> invoke the
	         * <a href="IORequest.html#method_start">start</a> method automatically,
	         * initializing the IO transaction.
			 *
			 * @attribute autoLoad
			 * @default true
			 * @type boolean
			 */
			autoLoad: {
				value: true,
				validator: isBoolean
			},

			/**
			 * If <code>false</code> the current timestamp will be appended to the
	         * url, avoiding the url to be cached.
			 *
			 * @attribute cache
			 * @default true
			 * @type boolean
			 */
			cache: {
				value: true,
				validator: isBoolean
			},

			/**
			 * The type of the request (i.e., could be xml, json, javascript, text).
			 *
			 * @attribute dataType
			 * @default null
			 * @type String
			 */
			dataType: {
				setter: function(v) {
					_yuitest_coverfunc("build/aui-io-request/aui-io-request.js", "setter", 139);
_yuitest_coverline("build/aui-io-request/aui-io-request.js", 140);
return (v || EMPTY_STRING).toLowerCase();
				},
				value: null,
				validator: isString
			},

			/**
			 * This is a normalized attribute for the response data. It's useful
	         * to retrieve the correct type for the
	         * <a href="IORequest.html#config_dataType">dataType</a> (i.e., in json
	         * requests the <code>responseData</code>) is a JSONObject.
			 *
			 * @attribute responseData
			 * @default null
			 * @type String | JSONObject | XMLDocument
			 */
			responseData: {
				setter: function(v) {
					_yuitest_coverfunc("build/aui-io-request/aui-io-request.js", "setter", 157);
_yuitest_coverline("build/aui-io-request/aui-io-request.js", 158);
return this._setResponseData(v);
				},
				value: null
			},

			/**
			 * URI to be requested using AJAX.
			 *
			 * @attribute uri
			 * @default null
			 * @type String
			 */
			uri: {
				setter: function(v) {
					_yuitest_coverfunc("build/aui-io-request/aui-io-request.js", "setter", 171);
_yuitest_coverline("build/aui-io-request/aui-io-request.js", 172);
return this._parseURL(v);
				},
				value: null,
				validator: isString
			},

			// User readOnly variables

			/**
			 * Whether the transaction is active or not.
			 *
			 * @attribute active
			 * @default false
			 * @type boolean
			 */
			active: {
				value: false,
				validator: isBoolean
			},

			/**
			 * Object containing all the
	         * <a href="io.html#configattributes">IO Configuration Attributes</a>.
	         * This Object is passed to the <code>A.io</code> internally.
			 *
			 * @attribute cfg
			 * @default Object containing all the
	         * <a href="io.html#configattributes">IO Configuration Attributes</a>.
	         * @readOnly
			 * @type String
			 */
			cfg: {
				getter: function() {
					_yuitest_coverfunc("build/aui-io-request/aui-io-request.js", "getter", 204);
_yuitest_coverline("build/aui-io-request/aui-io-request.js", 205);
var instance = this;

					// keep the current cfg object always synchronized with the mapped public attributes
					// when the user call .start() it always retrieve the last set values for each mapped attr
					_yuitest_coverline("build/aui-io-request/aui-io-request.js", 209);
return {
						arguments: instance.get(ARGUMENTS),
						context: instance.get(CONTEXT),
						data: instance.getFormattedData(),
						form: instance.get(FORM),
						headers: instance.get(HEADERS),
						method: instance.get(METHOD),
						on: {
							complete: A.bind(instance.fire, instance, COMPLETE),
							end: A.bind(instance._end, instance),
							failure: A.bind(instance.fire, instance, FAILURE),
							start: A.bind(instance.fire, instance, START),
							success: A.bind(instance._success, instance)
						},
						sync: instance.get(SYNC),
						timeout: instance.get(TIMEOUT),
						xdr: instance.get(XDR)
					};
				},
				readOnly: true
			},

			/**
			 * Stores the IO Object of the current transaction.
			 *
			 * @attribute transaction
			 * @default null
			 * @type Object
			 */
			transaction: {
				value: null
			},

			// Configuration Object mapping
			// To take advantages of the Attribute listeners of A.Base
			// See: http://developer.yahoo.com/yui/3/io/

			/**
			 * See <a href="http://developer.yahoo.com/yui/3/io/#configuration">IO
	        * Configuration</a>.
			 *
			 * @attribute arguments
			 * @default Value mapped on YUI.AUI.defaults.io.
			 * @type Object
			 */
			arguments: {
				valueFn: getDefault(ARGUMENTS)
			},

			/**
			 * See <a href="http://developer.yahoo.com/yui/3/io/#configuration">IO
	        * Configuration</a>.
			 *
			 * @attribute context
			 * @default Value mapped on YUI.AUI.defaults.io.
			 * @type Object
			 */
			context: {
				valueFn: getDefault(CONTEXT)
			},

			/**
			 * See <a href="http://developer.yahoo.com/yui/3/io/#configuration">IO
	        * Configuration</a>.
			 *
			 * @attribute data
			 * @default Value mapped on YUI.AUI.defaults.io.
			 * @type Object
			 */
			data: {
				valueFn: getDefault(DATA)
			},

			/**
			 * See <a href="http://developer.yahoo.com/yui/3/io/#configuration">IO
	        * Configuration</a>.
			 *
			 * @attribute form
			 * @default Value mapped on YUI.AUI.defaults.io.
			 * @type Object
			 */
			form: {
				valueFn: getDefault(FORM)
			},

			/**
			 * Set the correct ACCEPT header based on the dataType.
			 *
			 * @attribute headers
			 * @default Object
			 * @type Object
			 */
			headers: {
				getter: function(value) {
					_yuitest_coverfunc("build/aui-io-request/aui-io-request.js", "getter", 302);
_yuitest_coverline("build/aui-io-request/aui-io-request.js", 303);
var header = [];
					_yuitest_coverline("build/aui-io-request/aui-io-request.js", 304);
var instance = this;
					_yuitest_coverline("build/aui-io-request/aui-io-request.js", 305);
var dataType = instance.get(DATA_TYPE);

					_yuitest_coverline("build/aui-io-request/aui-io-request.js", 307);
if (dataType) {
						_yuitest_coverline("build/aui-io-request/aui-io-request.js", 308);
header.push(
							ACCEPTS[dataType]
						);
					}

					// always add *.* to the accept header
					_yuitest_coverline("build/aui-io-request/aui-io-request.js", 314);
header.push(
						ACCEPTS.all
					);

					_yuitest_coverline("build/aui-io-request/aui-io-request.js", 318);
return A.merge(
						value,
						{
							Accept: header.join(', ')
						}
					);
				},
				valueFn: getDefault(HEADERS)
			},

			/**
			 * See <a href="http://developer.yahoo.com/yui/3/io/#configuration">IO
	        * Configuration</a>.
			 *
			 * @attribute method
			 * @default Value mapped on YUI.AUI.defaults.io.
			 * @type String
			 */
			method: {
				valueFn: getDefault(METHOD)
			},

			/**
			 * A selector to be used to query against the response of the
			 * request. Only works if the response is XML or HTML.
			 *
			 * @attribute selector
			 * @type string
			 */
			selector: {
				value: null
			},

			/**
			 * See <a href="http://developer.yahoo.com/yui/3/io/#configuration">IO
	        * Configuration</a>.
			 *
			 * @attribute sync
			 * @default Value mapped on YUI.AUI.defaults.io.
			 * @type boolean
			 */
			sync: {
				valueFn: getDefault(SYNC)
			},

			/**
			 * See <a href="http://developer.yahoo.com/yui/3/io/#configuration">IO
	        * Configuration</a>.
			 *
			 * @attribute timeout
			 * @default Value mapped on YUI.AUI.defaults.io.
			 * @type Number
			 */
			timeout: {
				valueFn: getDefault(TIMEOUT)
			},

			/**
			 * See <a href="http://developer.yahoo.com/yui/3/io/#configuration">IO
	         * Configuration</a>.
			 *
			 * @attribute xdr
			 * @default Value mapped on YUI.AUI.defaults.io.
			 * @type Object
			 */
			xdr: {
				valueFn: getDefault(XDR)
			}
		},

		EXTENDS: A.Plugin.Base,

		prototype: {
			/**
			 * Construction logic executed during IORequest instantiation. Lifecycle.
			 *
			 * @method initializer
			 * @protected
			 */
			init: function(config) {
				_yuitest_coverfunc("build/aui-io-request/aui-io-request.js", "init", 397);
_yuitest_coverline("build/aui-io-request/aui-io-request.js", 398);
var instance = this;

				_yuitest_coverline("build/aui-io-request/aui-io-request.js", 400);
IORequest.superclass.init.apply(this, arguments);

				_yuitest_coverline("build/aui-io-request/aui-io-request.js", 402);
instance._autoStart();
			},

			/**
			 * Descructor lifecycle implementation for the IORequest class.
			 * Purges events attached to the node (and all child nodes).
			 *
			 * @method destructor
			 * @protected
			 */
			destructor: function() {
				_yuitest_coverfunc("build/aui-io-request/aui-io-request.js", "destructor", 412);
_yuitest_coverline("build/aui-io-request/aui-io-request.js", 413);
var instance = this;

				_yuitest_coverline("build/aui-io-request/aui-io-request.js", 415);
instance.stop();

				_yuitest_coverline("build/aui-io-request/aui-io-request.js", 417);
instance.set(TRANSACTION, null);
			},

			/**
			 * Applies the <code>YUI.AUI.defaults.io.dataFormatter</code> if defined and return the formatted data.
			 *
			 * @method getFormattedData
			 * @protected
			 * @return {String}
			 */
			getFormattedData: function() {
				_yuitest_coverfunc("build/aui-io-request/aui-io-request.js", "getFormattedData", 427);
_yuitest_coverline("build/aui-io-request/aui-io-request.js", 428);
var instance = this;
				_yuitest_coverline("build/aui-io-request/aui-io-request.js", 429);
var value = instance.get(DATA);
				_yuitest_coverline("build/aui-io-request/aui-io-request.js", 430);
var dataFormatter = defaults.dataFormatter;

				_yuitest_coverline("build/aui-io-request/aui-io-request.js", 432);
if (isFunction(dataFormatter)) {
					_yuitest_coverline("build/aui-io-request/aui-io-request.js", 433);
value = dataFormatter.call(instance, value);
				}

				_yuitest_coverline("build/aui-io-request/aui-io-request.js", 436);
return value;
			},

			/**
			 * Starts the IO transaction. Used to refresh the content also.
			 *
			 * @method start
			 */
			start: function() {
				_yuitest_coverfunc("build/aui-io-request/aui-io-request.js", "start", 444);
_yuitest_coverline("build/aui-io-request/aui-io-request.js", 445);
var instance = this;

				_yuitest_coverline("build/aui-io-request/aui-io-request.js", 447);
instance.destructor();

				_yuitest_coverline("build/aui-io-request/aui-io-request.js", 449);
instance.set(ACTIVE, true);

				_yuitest_coverline("build/aui-io-request/aui-io-request.js", 451);
var ioObj = instance._yuiIOObj;

				_yuitest_coverline("build/aui-io-request/aui-io-request.js", 453);
if (!ioObj) {
					_yuitest_coverline("build/aui-io-request/aui-io-request.js", 454);
ioObj = new A.IO();

					_yuitest_coverline("build/aui-io-request/aui-io-request.js", 456);
instance._yuiIOObj = ioObj;
				}

				_yuitest_coverline("build/aui-io-request/aui-io-request.js", 459);
var transaction = ioObj.send(
					instance.get(URI),
					instance.get(CFG)
				);

				_yuitest_coverline("build/aui-io-request/aui-io-request.js", 464);
instance.set(TRANSACTION, transaction);
			},

			/**
			 * Stops the IO transaction.
			 *
			 * @method stop
			 */
			stop: function() {
				_yuitest_coverfunc("build/aui-io-request/aui-io-request.js", "stop", 472);
_yuitest_coverline("build/aui-io-request/aui-io-request.js", 473);
var instance = this;
				_yuitest_coverline("build/aui-io-request/aui-io-request.js", 474);
var transaction = instance.get(TRANSACTION);

				_yuitest_coverline("build/aui-io-request/aui-io-request.js", 476);
if (transaction) {
					_yuitest_coverline("build/aui-io-request/aui-io-request.js", 477);
transaction.abort();
				}
			},

			/**
			 * Invoke the <code>start</code> method (autoLoad attribute).
			 *
			 * @method _autoStart
			 * @protected
			 */
			_autoStart: function() {
				_yuitest_coverfunc("build/aui-io-request/aui-io-request.js", "_autoStart", 487);
_yuitest_coverline("build/aui-io-request/aui-io-request.js", 488);
var instance = this;

				_yuitest_coverline("build/aui-io-request/aui-io-request.js", 490);
if (instance.get(AUTO_LOAD)) {
					_yuitest_coverline("build/aui-io-request/aui-io-request.js", 491);
instance.start();
				}
			},

			/**
			 * Parse the <a href="IORequest.html#config_uri">uri</a> to add a
		     * timestamp if <a href="IORequest.html#config_cache">cache</a> is
		     * <code>true</code>. Also applies the
		     * <code>YUI.AUI.defaults.io.uriFormatter</code>.
			 *
			 * @method _parseURL
			 * @param {String} url
			 * @protected
			 * @return {String}
			 */
			_parseURL: function(url) {
				_yuitest_coverfunc("build/aui-io-request/aui-io-request.js", "_parseURL", 506);
_yuitest_coverline("build/aui-io-request/aui-io-request.js", 507);
var instance = this;
				_yuitest_coverline("build/aui-io-request/aui-io-request.js", 508);
var cache = instance.get(CACHE);
				_yuitest_coverline("build/aui-io-request/aui-io-request.js", 509);
var method = instance.get(METHOD);

				// reusing logic to add a timestamp on the url from jQuery 1.3.2
				_yuitest_coverline("build/aui-io-request/aui-io-request.js", 512);
if ( (cache === false) && (method == GET) ) {
					_yuitest_coverline("build/aui-io-request/aui-io-request.js", 513);
var ts = +new Date;
					// try replacing _= if it is there
					_yuitest_coverline("build/aui-io-request/aui-io-request.js", 515);
var ret = url.replace(/(\?|&)_=.*?(&|$)/, '$1_=' + ts + '$2');
					// if nothing was replaced, add timestamp to the end
					_yuitest_coverline("build/aui-io-request/aui-io-request.js", 517);
url = ret + ((ret == url) ? (url.match(/\?/) ? '&' : '?') + '_=' + ts : '');
				}

				// formatting the URL with the default uriFormatter after the cache timestamp was added
				_yuitest_coverline("build/aui-io-request/aui-io-request.js", 521);
var uriFormatter = defaults.uriFormatter;

				_yuitest_coverline("build/aui-io-request/aui-io-request.js", 523);
if (isFunction(uriFormatter)) {
					_yuitest_coverline("build/aui-io-request/aui-io-request.js", 524);
url = uriFormatter.apply(instance, [url]);
				}

				_yuitest_coverline("build/aui-io-request/aui-io-request.js", 527);
return url;
			},

			/**
			 * Internal end callback for the IO transaction.
			 *
			 * @method _end
			 * @param {Number} id ID of the IO transaction.
			 * @param {Object} args Custom arguments, passed to the event handler. See <a href="http://developer.yahoo.com/yui/3/io/#configuration">IO
			 * @protected
			 */
			_end: function(id, args) {
				_yuitest_coverfunc("build/aui-io-request/aui-io-request.js", "_end", 538);
_yuitest_coverline("build/aui-io-request/aui-io-request.js", 539);
var instance = this;

				_yuitest_coverline("build/aui-io-request/aui-io-request.js", 541);
instance.set(ACTIVE, false);
				_yuitest_coverline("build/aui-io-request/aui-io-request.js", 542);
instance.set(TRANSACTION, null);

				_yuitest_coverline("build/aui-io-request/aui-io-request.js", 544);
instance.fire(END, id, args);
			},

			/**
			 * Internal success callback for the IO transaction.
			 *
			 * @method _success
			 * @param {Number} id ID of the IO transaction.
			 * @param {Object} obj IO transaction Object.
			 * @param {Object} args Custom arguments, passed to the event handler. See <a href="http://developer.yahoo.com/yui/3/io/#configuration">IO
			 * @protected
			 */
			_success: function(id, obj, args) {
				_yuitest_coverfunc("build/aui-io-request/aui-io-request.js", "_success", 556);
_yuitest_coverline("build/aui-io-request/aui-io-request.js", 557);
var instance = this;

				// update the responseData attribute with the new data from xhr
				_yuitest_coverline("build/aui-io-request/aui-io-request.js", 560);
instance.set(RESPONSE_DATA, obj);

				_yuitest_coverline("build/aui-io-request/aui-io-request.js", 562);
instance.fire(SUCCESS, id, obj, args);
			},

			/**
			 * Setter for <a href="IORequest.html#config_responseData">responseData</a>.
			 *
			 * @method _setResponseData
			 * @protected
			 * @param {Object} xhr XHR Object.
			 * @return {Object}
			 */
			_setResponseData: function(xhr) {
				_yuitest_coverfunc("build/aui-io-request/aui-io-request.js", "_setResponseData", 573);
_yuitest_coverline("build/aui-io-request/aui-io-request.js", 574);
var data = null;
				_yuitest_coverline("build/aui-io-request/aui-io-request.js", 575);
var instance = this;

				_yuitest_coverline("build/aui-io-request/aui-io-request.js", 577);
if (xhr) {
					_yuitest_coverline("build/aui-io-request/aui-io-request.js", 578);
var dataType = instance.get(DATA_TYPE);
					_yuitest_coverline("build/aui-io-request/aui-io-request.js", 579);
var contentType = xhr.getResponseHeader(CONTENT_TYPE) || '';

					// if the dataType or the content-type is XML...
					_yuitest_coverline("build/aui-io-request/aui-io-request.js", 582);
if ((dataType == XML) ||
						(!dataType && contentType.indexOf(XML) >= 0)) {

						// use responseXML
						_yuitest_coverline("build/aui-io-request/aui-io-request.js", 586);
data = xhr.responseXML;

						// check if the XML was parsed correctly
						_yuitest_coverline("build/aui-io-request/aui-io-request.js", 589);
if (data.documentElement.tagName == 'parsererror') {
							_yuitest_coverline("build/aui-io-request/aui-io-request.js", 590);
throw PARSE_ERROR;
						}
					}
					else {
						// otherwise use the responseText
						_yuitest_coverline("build/aui-io-request/aui-io-request.js", 595);
data = xhr.responseText;
					}

					// empty string is not a valid JSON, convert it to null
					_yuitest_coverline("build/aui-io-request/aui-io-request.js", 599);
if (data === EMPTY_STRING) {
						_yuitest_coverline("build/aui-io-request/aui-io-request.js", 600);
data = null;
					}

					// trying to parse to JSON if dataType is a valid json
					_yuitest_coverline("build/aui-io-request/aui-io-request.js", 604);
if (dataType == JSON) {
						_yuitest_coverline("build/aui-io-request/aui-io-request.js", 605);
try {
							_yuitest_coverline("build/aui-io-request/aui-io-request.js", 606);
data = A.JSON.parse(data);
						}
						catch(e) {
							// throw PARSE_ERROR;
						}
					}
					else {
						_yuitest_coverline("build/aui-io-request/aui-io-request.js", 613);
var selector = instance.get('selector');

						_yuitest_coverline("build/aui-io-request/aui-io-request.js", 615);
if (data && selector) {
							_yuitest_coverline("build/aui-io-request/aui-io-request.js", 616);
var tempRoot;

							_yuitest_coverline("build/aui-io-request/aui-io-request.js", 618);
if (data.documentElement) {
								_yuitest_coverline("build/aui-io-request/aui-io-request.js", 619);
tempRoot = A.one(data);
							}
							else {
								_yuitest_coverline("build/aui-io-request/aui-io-request.js", 622);
tempRoot = A.Node.create(data);
							}

							_yuitest_coverline("build/aui-io-request/aui-io-request.js", 625);
data = tempRoot.all(selector);
						}
					}
				}

				_yuitest_coverline("build/aui-io-request/aui-io-request.js", 630);
return data;
			}
		}
	}
);

_yuitest_coverline("build/aui-io-request/aui-io-request.js", 636);
A.IORequest = IORequest;

/**
 * Alloy IO extension
 *
 * @class A.io
 * @static
 */

/**
 * Static method to invoke the <a href="IORequest.html">IORequest</a>. Likewise <a href="io.html#method_io">io</a>.
 *
 * @method A.io.request
 * @for A.io
 * @param {String} uri URI to be requested.
 * @param {Object} config Configuration Object for the <a href="io.html">IO</a>.
 * @return {IORequest}
 */
_yuitest_coverline("build/aui-io-request/aui-io-request.js", 654);
A.io.request = function(uri, config) {
	_yuitest_coverfunc("build/aui-io-request/aui-io-request.js", "request", 654);
_yuitest_coverline("build/aui-io-request/aui-io-request.js", 655);
return new A.IORequest(
		A.merge(config, {
			uri: uri
		})
	);
};

}, '2.0.0pr1', {"requires": ["io-base", "json", "plugin", "querystring-stringify", "aui-component"]});
