if (typeof _yuitest_coverage == "undefined"){
    _yuitest_coverage = {};
    _yuitest_coverline = function(src, line){
        var coverage = _yuitest_coverage[src];
        if (!coverage.lines[line]){
            coverage.calledLines++;
        }
        coverage.lines[line]++;
    };
    _yuitest_coverfunc = function(src, name, line){
        var coverage = _yuitest_coverage[src],
            funcId = name + ":" + line;
        if (!coverage.functions[funcId]){
            coverage.calledFunctions++;
        }
        coverage.functions[funcId]++;
    };
}
_yuitest_coverage["build/aui-pagination/aui-pagination.js"] = {
    lines: {},
    functions: {},
    coveredLines: 0,
    calledLines: 0,
    coveredFunctions: 0,
    calledFunctions: 0,
    path: "build/aui-pagination/aui-pagination.js",
    code: []
};
_yuitest_coverage["build/aui-pagination/aui-pagination.js"].code=["YUI.add('aui-pagination', function (A, NAME) {","","/**"," * The Pagination Utility - The Pagination widget provides a set of controls to navigate through paged data."," *"," * @module aui-pagination"," */","","var Lang = A.Lang,","    isBoolean = Lang.isBoolean,","    isNumber = Lang.isNumber,","","    ACTIVE = 'active',","    BOUNDING_BOX = 'boundingBox',","    CHANGE_REQUEST = 'changeRequest',","    CIRCULAR = 'circular',","    CLICK = 'click',","    CONTENT_BOX = 'contentBox',","    DISABLED = 'disabled',","    ITEMS = 'items',","    LI = 'li',","    NEXT = 'next',","    OFFSET = 'offset',","    PAGE = 'page',","    PAGINATION = 'pagination',","    PREV = 'prev',","    RENDERED = 'rendered',","    TOTAL = 'total',","","    getCN = A.getClassName,","","    CSS_ACTIVE = getCN(ACTIVE),","    CSS_DISABLED = getCN(DISABLED);","","    /**","     * A base class for Pagination, providing:","     * <ul>","     *    <li>Widget Lifecycle (initializer, renderUI, bindUI, syncUI, destructor)</li>","     *    <li>Set of controls to navigate through paged data</li>","     * </ul>","     *","     * Quick Example:<br/>","     *","     * <pre><code>var instance = new A.Pagination({","     *  boundingBox: '#pagination',","     *  circular: true,","     *  total: 10","     * }).render();","     * </code></pre>","     *","     * Check the list of <a href=\"Pagination.html#configattributes\">Configuration Attributes</a> available for","     * Pagination.","     *","     * @param config {Object} Object literal specifying widget configuration properties.","     *","     * @class Pagination","     * @constructor","     * @extends Widget","     */","var Pagination = A.Component.create(","    {","        /**","         * Static property provides a string to identify the class.","         *","         * @property Paginator.NAME","         * @type String","         * @static","         */","        NAME: PAGINATION,","","        /**","         * Static property used to define the default attribute","         * configuration for the Paginator.","         *","         * @property Paginator.ATTRS","         * @type Object","         * @static","         */","        ATTRS: {","            /**","             * When enabled this property allows the navigation to go back to","             * the beggining when it reaches the last page, the opposite behavior","             * is also true. Incremental page navigation could happen clicking the","             * control arrows or invoking <code>.next()</code> and","             * <code>.prev()</code> methods.","             *","             * @attribute circular","             * @default true","             * @type boolean","             */","            circular: {","                validator: isBoolean,","                value: true","            },","","            /**","             * Holds the page items as a NodeList. The list could be queried","             * from the DOM trough Widget HTML_PARSER or generated if","             * <a href=\"Paginator.html#config_total\">total</a> is specified.","             *","             * @attribute items","             * @default undefined","             * @type NodeList","             */","            items: {","            },","","            /**","             * Initial page offset.","             *","             * @attribute offset","             * @default 0","             * @type Number","             */","            offset: {","                setter: '_setInt',","                value: 1","            },","","            /**","             * Page to display on initial paint.","             *","             * @attribute page","             * @default 0","             * @type Number","             */","            page: {","                setter: '_setInt',","                value: 0","            },","","            /**","             * Total number of page links available. If set, the new","             * <a href=\"Paginator.html#config_items\">items</a> node list will","             * be rendered.","             *","             * @attribute total","             * @default 0","             * @type Number","             */","            total: {","                setter: '_setInt',","                value: 0","            },","","            strings: {","                value: {","                    next: 'Next',","                    prev: 'Prev'","                }","            }","        },","","        HTML_PARSER: {","            items: function(srcNode) {","                return this._queryItemsIfNotSet(srcNode);","            },","            total: function() {","                return this._countItemsInDoc();","            }","        },","","        UI_ATTRS: [OFFSET, PAGE, TOTAL],","","        prototype: {","            CONTENT_TEMPLATE: '<ul></ul>',","            ITEM_TEMPLATE: '<li><a href=\"#\">{content}</a></li>',","            TOTAL_CONTROLS: 2,","","            items: null,","            lastState: null,","","            syncUI: function() {","                var instance = this,","                    page = instance.get(PAGE);","","                if (page > 0) {","                    instance._dispatchRequest({page:page});","                }","            },","","            bindUI: function() {","                var instance = this,","                    boundingBox = instance.get(BOUNDING_BOX);","","                instance.on('pageChange', instance._onPageChange);","                instance.publish(CHANGE_REQUEST, {","                    defaultFn: instance._defChangeRequest","                });","                boundingBox.delegate(CLICK, instance._onClickItem, LI, instance);","            },","","            renderUI: function() {","                var instance = this;","","                instance._renderItemsUI(instance.get(TOTAL));","            },","","            /**","             * Retrieve the item node from the passesed item index parameter.","             * If passed item is a node instead of the index returns itself.","             *","             * @method getItem","             * @param {Node | Number} i Index or Node reference.","             * @return {Node}","             */","            getItem: function(i) {","                var instance = this;","","                if (isNumber(i)) {","                    var items = instance.get(ITEMS);","                    if (items) {","                        i = items.item(i);","                    }","                }","","                return i;","            },","","            /**","             * Retrieve page number inclusing offset e.g., if offset","             * is 100 and active page is 5, this method returns 105.","             *","             * @method getOffsetPageNumber","             * @return {Number}","             */","            getOffsetPageNumber: function() {","                var instance = this;","","                return instance.get(OFFSET) + instance.get(PAGE);","            },","","            /**","             * Retrieve total number of pages including offset e.g., if offset","             * is 100 and total 10, this method returns 110.","             *","             * @method getOffsetTotalPages","             * @return {Number}","             */","            getOffsetTotalPages: function() {","                var instance = this;","","                return instance.get(OFFSET) + instance.get(TOTAL);","            },","","            /**","             * Retrieve total number of dom items representing the links,","             * including the arrow control items. Do not include the offset.","             *","             * @method getTotalItems","             * @return {Number}","             */","            getTotalItems: function() {","                var instance = this;","","                return instance.get(TOTAL) + instance.TOTAL_CONTROLS;","            },","","            /**","             * Navigate to the next page.","             *","             * @method next","             */","            next: function() {","                var instance = this,","                    total = instance.get(TOTAL);","","                if (total === 0) {","                    return;","                }","","                var page = instance.get(PAGE);","","                instance._dispatchRequest({","                    page: (instance.get(CIRCULAR) && (page === total)) ?","                            1 :","                            Math.min(total, ++page)","                });","","                return instance;","            },","","            /**","             * Navigate to the previous page.","             *","             * @method prev","             */","            prev: function() {","                var instance = this,","                    total = instance.get(TOTAL);","","                if (total === 0) {","                    return;","                }","","                var page = instance.get(PAGE);","","                instance._dispatchRequest({","                    page: (instance.get(CIRCULAR) && (page === 1)) ?","                            total :","                            Math.max(1, --page)","                });","","                return instance;","            },","","            /**","             * Set the new pagination state. The state is a payload object","             * containing the page number, e.g. <code>{page:1}</code>.","             *","             * @method setState","             */","            setState: function(state) {","                var instance = this;","","                instance.set(PAGE, state.page);","                instance.lastState = state;","            },","","            _countItemsInDoc: function() {","                var instance = this,","                    srcNode = instance.get('srcNode');","","                return Math.max(0, instance._queryItemsIfNotSet(srcNode).size() - instance.TOTAL_CONTROLS);","            },","","            _defChangeRequest: function(event) {","                var instance = this;","","                instance.setState(event.state);","            },","","            _dispatchRequest: function(state) {","                var instance = this;","","                instance.fire(CHANGE_REQUEST, {","                    lastState: instance.lastState,","                    state: state","                });","            },","","            _queryItemsIfNotSet: function(srcNode) {","                var instance = this;","","                if (!instance.items) {","                    instance.items = srcNode.all(LI);","                }","                return instance.items;","            },","","            _onClickItem: function(event) {","                var instance = this,","                    item = event.currentTarget;","","                event.preventDefault();","","                if (item.hasClass(CSS_DISABLED) || item.hasClass(CSS_ACTIVE)) {","                    return;","                }","","                var items = instance.get(ITEMS),","                    index = items.indexOf(item),","                    lastIndex = items.size() - 1;","","                switch(index) {","                    case 0:","                        instance.prev();","                        break;","                    case lastIndex:","                        instance.next();","                        break;","                    default:","                        instance._dispatchRequest({page:index});","                        break;","                }","            },","","            _onPageChange: function(event) {","                var instance = this;","","                if (event.prevVal !== event.newVal) {","                    var item = instance.getItem(event.prevVal);","                    if (item) {","                        item.removeClass(CSS_ACTIVE);","                    }","                }","            },","","            _renderItemsUI: function(total) {","                var instance = this;","","                // Do not render anything if the number of markup items matches","                // with the passed total attributes.","                if ((total > 0) && (total === instance._countItemsInDoc())) {","                    return;","                }","","                var tpl = instance.ITEM_TEMPLATE,","                    offset = instance.get(OFFSET),","                    i,","                    buffer = '';","","                buffer += Lang.sub(tpl, {","                    content: instance.getString(PREV)","                });","","                for (i = offset + 1; i <= (offset + total); i++) {","                    buffer += Lang.sub(tpl, { content: i });","                }","","                buffer += Lang.sub(tpl, {","                    content: instance.getString(NEXT)","                });","","                var items = A.NodeList.create(buffer);","                instance.set(ITEMS, items);","                instance.get(CONTENT_BOX).setContent(items);","            },","","            _setInt: function(val) {","                return Lang.toInt(val);","            },","","            _syncNavigationUI: function() {","                var instance = this,","                    items = instance.get(ITEMS);","","                items.first().toggleClass(","                    CSS_DISABLED, instance.get(PAGE) === 1);","","                items.last().toggleClass(","                    CSS_DISABLED, instance.get(PAGE) === instance.get(TOTAL));","            },","","            _uiSetOffset: function(val) {","                var instance = this;","","                if (instance.get(RENDERED)) {","                    instance._renderItemsUI(instance.get(TOTAL));","                }","            },","","            _uiSetPage: function(val) {","                var instance = this;","","                if (!instance.get(CIRCULAR)) {","                    instance._syncNavigationUI();","                }","","                // Do not activate first and last items, they are used for controls.","                if (val === 0 || val === instance.getTotalItems()) {","                    return;","                }","","                var item = instance.getItem(val);","","                if (item) {","                    item.addClass(CSS_ACTIVE);","                }","            },","","            _uiSetTotal: function(val) {","                var instance = this;","","                if (instance.get(RENDERED)) {","                    instance._renderItemsUI(val);","                }","            }","        }","    }",");","","A.Pagination = Pagination;","","}, '2.0.0pr1', {\"requires\": [\"node-event-delegate\", \"aui-node\", \"aui-component\", \"widget-htmlparser\"]});"];
_yuitest_coverage["build/aui-pagination/aui-pagination.js"].lines = {"1":0,"9":0,"60":0,"156":0,"159":0,"174":0,"177":0,"178":0,"183":0,"186":0,"187":0,"190":0,"194":0,"196":0,"208":0,"210":0,"211":0,"212":0,"213":0,"217":0,"228":0,"230":0,"241":0,"243":0,"254":0,"256":0,"265":0,"268":0,"269":0,"272":0,"274":0,"280":0,"289":0,"292":0,"293":0,"296":0,"298":0,"304":0,"314":0,"316":0,"317":0,"321":0,"324":0,"328":0,"330":0,"334":0,"336":0,"343":0,"345":0,"346":0,"348":0,"352":0,"355":0,"357":0,"358":0,"361":0,"365":0,"367":0,"368":0,"370":0,"371":0,"373":0,"374":0,"379":0,"381":0,"382":0,"383":0,"384":0,"390":0,"394":0,"395":0,"398":0,"403":0,"407":0,"408":0,"411":0,"415":0,"416":0,"417":0,"421":0,"425":0,"428":0,"431":0,"436":0,"438":0,"439":0,"444":0,"446":0,"447":0,"451":0,"452":0,"455":0,"457":0,"458":0,"463":0,"465":0,"466":0,"473":0};
_yuitest_coverage["build/aui-pagination/aui-pagination.js"].functions = {"items:155":0,"total:158":0,"syncUI:173":0,"bindUI:182":0,"renderUI:193":0,"getItem:207":0,"getOffsetPageNumber:227":0,"getOffsetTotalPages:240":0,"getTotalItems:253":0,"next:264":0,"prev:288":0,"setState:313":0,"_countItemsInDoc:320":0,"_defChangeRequest:327":0,"_dispatchRequest:333":0,"_queryItemsIfNotSet:342":0,"_onClickItem:351":0,"_onPageChange:378":0,"_renderItemsUI:389":0,"_setInt:420":0,"_syncNavigationUI:424":0,"_uiSetOffset:435":0,"_uiSetPage:443":0,"_uiSetTotal:462":0,"(anonymous 1):1":0};
_yuitest_coverage["build/aui-pagination/aui-pagination.js"].coveredLines = 98;
_yuitest_coverage["build/aui-pagination/aui-pagination.js"].coveredFunctions = 25;
_yuitest_coverline("build/aui-pagination/aui-pagination.js", 1);
YUI.add('aui-pagination', function (A, NAME) {

/**
 * The Pagination Utility - The Pagination widget provides a set of controls to navigate through paged data.
 *
 * @module aui-pagination
 */

_yuitest_coverfunc("build/aui-pagination/aui-pagination.js", "(anonymous 1)", 1);
_yuitest_coverline("build/aui-pagination/aui-pagination.js", 9);
var Lang = A.Lang,
    isBoolean = Lang.isBoolean,
    isNumber = Lang.isNumber,

    ACTIVE = 'active',
    BOUNDING_BOX = 'boundingBox',
    CHANGE_REQUEST = 'changeRequest',
    CIRCULAR = 'circular',
    CLICK = 'click',
    CONTENT_BOX = 'contentBox',
    DISABLED = 'disabled',
    ITEMS = 'items',
    LI = 'li',
    NEXT = 'next',
    OFFSET = 'offset',
    PAGE = 'page',
    PAGINATION = 'pagination',
    PREV = 'prev',
    RENDERED = 'rendered',
    TOTAL = 'total',

    getCN = A.getClassName,

    CSS_ACTIVE = getCN(ACTIVE),
    CSS_DISABLED = getCN(DISABLED);

    /**
     * A base class for Pagination, providing:
     * <ul>
     *    <li>Widget Lifecycle (initializer, renderUI, bindUI, syncUI, destructor)</li>
     *    <li>Set of controls to navigate through paged data</li>
     * </ul>
     *
     * Quick Example:<br/>
     *
     * <pre><code>var instance = new A.Pagination({
     *  boundingBox: '#pagination',
     *  circular: true,
     *  total: 10
     * }).render();
     * </code></pre>
     *
     * Check the list of <a href="Pagination.html#configattributes">Configuration Attributes</a> available for
     * Pagination.
     *
     * @param config {Object} Object literal specifying widget configuration properties.
     *
     * @class Pagination
     * @constructor
     * @extends Widget
     */
_yuitest_coverline("build/aui-pagination/aui-pagination.js", 60);
var Pagination = A.Component.create(
    {
        /**
         * Static property provides a string to identify the class.
         *
         * @property Paginator.NAME
         * @type String
         * @static
         */
        NAME: PAGINATION,

        /**
         * Static property used to define the default attribute
         * configuration for the Paginator.
         *
         * @property Paginator.ATTRS
         * @type Object
         * @static
         */
        ATTRS: {
            /**
             * When enabled this property allows the navigation to go back to
             * the beggining when it reaches the last page, the opposite behavior
             * is also true. Incremental page navigation could happen clicking the
             * control arrows or invoking <code>.next()</code> and
             * <code>.prev()</code> methods.
             *
             * @attribute circular
             * @default true
             * @type boolean
             */
            circular: {
                validator: isBoolean,
                value: true
            },

            /**
             * Holds the page items as a NodeList. The list could be queried
             * from the DOM trough Widget HTML_PARSER or generated if
             * <a href="Paginator.html#config_total">total</a> is specified.
             *
             * @attribute items
             * @default undefined
             * @type NodeList
             */
            items: {
            },

            /**
             * Initial page offset.
             *
             * @attribute offset
             * @default 0
             * @type Number
             */
            offset: {
                setter: '_setInt',
                value: 1
            },

            /**
             * Page to display on initial paint.
             *
             * @attribute page
             * @default 0
             * @type Number
             */
            page: {
                setter: '_setInt',
                value: 0
            },

            /**
             * Total number of page links available. If set, the new
             * <a href="Paginator.html#config_items">items</a> node list will
             * be rendered.
             *
             * @attribute total
             * @default 0
             * @type Number
             */
            total: {
                setter: '_setInt',
                value: 0
            },

            strings: {
                value: {
                    next: 'Next',
                    prev: 'Prev'
                }
            }
        },

        HTML_PARSER: {
            items: function(srcNode) {
                _yuitest_coverfunc("build/aui-pagination/aui-pagination.js", "items", 155);
_yuitest_coverline("build/aui-pagination/aui-pagination.js", 156);
return this._queryItemsIfNotSet(srcNode);
            },
            total: function() {
                _yuitest_coverfunc("build/aui-pagination/aui-pagination.js", "total", 158);
_yuitest_coverline("build/aui-pagination/aui-pagination.js", 159);
return this._countItemsInDoc();
            }
        },

        UI_ATTRS: [OFFSET, PAGE, TOTAL],

        prototype: {
            CONTENT_TEMPLATE: '<ul></ul>',
            ITEM_TEMPLATE: '<li><a href="#">{content}</a></li>',
            TOTAL_CONTROLS: 2,

            items: null,
            lastState: null,

            syncUI: function() {
                _yuitest_coverfunc("build/aui-pagination/aui-pagination.js", "syncUI", 173);
_yuitest_coverline("build/aui-pagination/aui-pagination.js", 174);
var instance = this,
                    page = instance.get(PAGE);

                _yuitest_coverline("build/aui-pagination/aui-pagination.js", 177);
if (page > 0) {
                    _yuitest_coverline("build/aui-pagination/aui-pagination.js", 178);
instance._dispatchRequest({page:page});
                }
            },

            bindUI: function() {
                _yuitest_coverfunc("build/aui-pagination/aui-pagination.js", "bindUI", 182);
_yuitest_coverline("build/aui-pagination/aui-pagination.js", 183);
var instance = this,
                    boundingBox = instance.get(BOUNDING_BOX);

                _yuitest_coverline("build/aui-pagination/aui-pagination.js", 186);
instance.on('pageChange', instance._onPageChange);
                _yuitest_coverline("build/aui-pagination/aui-pagination.js", 187);
instance.publish(CHANGE_REQUEST, {
                    defaultFn: instance._defChangeRequest
                });
                _yuitest_coverline("build/aui-pagination/aui-pagination.js", 190);
boundingBox.delegate(CLICK, instance._onClickItem, LI, instance);
            },

            renderUI: function() {
                _yuitest_coverfunc("build/aui-pagination/aui-pagination.js", "renderUI", 193);
_yuitest_coverline("build/aui-pagination/aui-pagination.js", 194);
var instance = this;

                _yuitest_coverline("build/aui-pagination/aui-pagination.js", 196);
instance._renderItemsUI(instance.get(TOTAL));
            },

            /**
             * Retrieve the item node from the passesed item index parameter.
             * If passed item is a node instead of the index returns itself.
             *
             * @method getItem
             * @param {Node | Number} i Index or Node reference.
             * @return {Node}
             */
            getItem: function(i) {
                _yuitest_coverfunc("build/aui-pagination/aui-pagination.js", "getItem", 207);
_yuitest_coverline("build/aui-pagination/aui-pagination.js", 208);
var instance = this;

                _yuitest_coverline("build/aui-pagination/aui-pagination.js", 210);
if (isNumber(i)) {
                    _yuitest_coverline("build/aui-pagination/aui-pagination.js", 211);
var items = instance.get(ITEMS);
                    _yuitest_coverline("build/aui-pagination/aui-pagination.js", 212);
if (items) {
                        _yuitest_coverline("build/aui-pagination/aui-pagination.js", 213);
i = items.item(i);
                    }
                }

                _yuitest_coverline("build/aui-pagination/aui-pagination.js", 217);
return i;
            },

            /**
             * Retrieve page number inclusing offset e.g., if offset
             * is 100 and active page is 5, this method returns 105.
             *
             * @method getOffsetPageNumber
             * @return {Number}
             */
            getOffsetPageNumber: function() {
                _yuitest_coverfunc("build/aui-pagination/aui-pagination.js", "getOffsetPageNumber", 227);
_yuitest_coverline("build/aui-pagination/aui-pagination.js", 228);
var instance = this;

                _yuitest_coverline("build/aui-pagination/aui-pagination.js", 230);
return instance.get(OFFSET) + instance.get(PAGE);
            },

            /**
             * Retrieve total number of pages including offset e.g., if offset
             * is 100 and total 10, this method returns 110.
             *
             * @method getOffsetTotalPages
             * @return {Number}
             */
            getOffsetTotalPages: function() {
                _yuitest_coverfunc("build/aui-pagination/aui-pagination.js", "getOffsetTotalPages", 240);
_yuitest_coverline("build/aui-pagination/aui-pagination.js", 241);
var instance = this;

                _yuitest_coverline("build/aui-pagination/aui-pagination.js", 243);
return instance.get(OFFSET) + instance.get(TOTAL);
            },

            /**
             * Retrieve total number of dom items representing the links,
             * including the arrow control items. Do not include the offset.
             *
             * @method getTotalItems
             * @return {Number}
             */
            getTotalItems: function() {
                _yuitest_coverfunc("build/aui-pagination/aui-pagination.js", "getTotalItems", 253);
_yuitest_coverline("build/aui-pagination/aui-pagination.js", 254);
var instance = this;

                _yuitest_coverline("build/aui-pagination/aui-pagination.js", 256);
return instance.get(TOTAL) + instance.TOTAL_CONTROLS;
            },

            /**
             * Navigate to the next page.
             *
             * @method next
             */
            next: function() {
                _yuitest_coverfunc("build/aui-pagination/aui-pagination.js", "next", 264);
_yuitest_coverline("build/aui-pagination/aui-pagination.js", 265);
var instance = this,
                    total = instance.get(TOTAL);

                _yuitest_coverline("build/aui-pagination/aui-pagination.js", 268);
if (total === 0) {
                    _yuitest_coverline("build/aui-pagination/aui-pagination.js", 269);
return;
                }

                _yuitest_coverline("build/aui-pagination/aui-pagination.js", 272);
var page = instance.get(PAGE);

                _yuitest_coverline("build/aui-pagination/aui-pagination.js", 274);
instance._dispatchRequest({
                    page: (instance.get(CIRCULAR) && (page === total)) ?
                            1 :
                            Math.min(total, ++page)
                });

                _yuitest_coverline("build/aui-pagination/aui-pagination.js", 280);
return instance;
            },

            /**
             * Navigate to the previous page.
             *
             * @method prev
             */
            prev: function() {
                _yuitest_coverfunc("build/aui-pagination/aui-pagination.js", "prev", 288);
_yuitest_coverline("build/aui-pagination/aui-pagination.js", 289);
var instance = this,
                    total = instance.get(TOTAL);

                _yuitest_coverline("build/aui-pagination/aui-pagination.js", 292);
if (total === 0) {
                    _yuitest_coverline("build/aui-pagination/aui-pagination.js", 293);
return;
                }

                _yuitest_coverline("build/aui-pagination/aui-pagination.js", 296);
var page = instance.get(PAGE);

                _yuitest_coverline("build/aui-pagination/aui-pagination.js", 298);
instance._dispatchRequest({
                    page: (instance.get(CIRCULAR) && (page === 1)) ?
                            total :
                            Math.max(1, --page)
                });

                _yuitest_coverline("build/aui-pagination/aui-pagination.js", 304);
return instance;
            },

            /**
             * Set the new pagination state. The state is a payload object
             * containing the page number, e.g. <code>{page:1}</code>.
             *
             * @method setState
             */
            setState: function(state) {
                _yuitest_coverfunc("build/aui-pagination/aui-pagination.js", "setState", 313);
_yuitest_coverline("build/aui-pagination/aui-pagination.js", 314);
var instance = this;

                _yuitest_coverline("build/aui-pagination/aui-pagination.js", 316);
instance.set(PAGE, state.page);
                _yuitest_coverline("build/aui-pagination/aui-pagination.js", 317);
instance.lastState = state;
            },

            _countItemsInDoc: function() {
                _yuitest_coverfunc("build/aui-pagination/aui-pagination.js", "_countItemsInDoc", 320);
_yuitest_coverline("build/aui-pagination/aui-pagination.js", 321);
var instance = this,
                    srcNode = instance.get('srcNode');

                _yuitest_coverline("build/aui-pagination/aui-pagination.js", 324);
return Math.max(0, instance._queryItemsIfNotSet(srcNode).size() - instance.TOTAL_CONTROLS);
            },

            _defChangeRequest: function(event) {
                _yuitest_coverfunc("build/aui-pagination/aui-pagination.js", "_defChangeRequest", 327);
_yuitest_coverline("build/aui-pagination/aui-pagination.js", 328);
var instance = this;

                _yuitest_coverline("build/aui-pagination/aui-pagination.js", 330);
instance.setState(event.state);
            },

            _dispatchRequest: function(state) {
                _yuitest_coverfunc("build/aui-pagination/aui-pagination.js", "_dispatchRequest", 333);
_yuitest_coverline("build/aui-pagination/aui-pagination.js", 334);
var instance = this;

                _yuitest_coverline("build/aui-pagination/aui-pagination.js", 336);
instance.fire(CHANGE_REQUEST, {
                    lastState: instance.lastState,
                    state: state
                });
            },

            _queryItemsIfNotSet: function(srcNode) {
                _yuitest_coverfunc("build/aui-pagination/aui-pagination.js", "_queryItemsIfNotSet", 342);
_yuitest_coverline("build/aui-pagination/aui-pagination.js", 343);
var instance = this;

                _yuitest_coverline("build/aui-pagination/aui-pagination.js", 345);
if (!instance.items) {
                    _yuitest_coverline("build/aui-pagination/aui-pagination.js", 346);
instance.items = srcNode.all(LI);
                }
                _yuitest_coverline("build/aui-pagination/aui-pagination.js", 348);
return instance.items;
            },

            _onClickItem: function(event) {
                _yuitest_coverfunc("build/aui-pagination/aui-pagination.js", "_onClickItem", 351);
_yuitest_coverline("build/aui-pagination/aui-pagination.js", 352);
var instance = this,
                    item = event.currentTarget;

                _yuitest_coverline("build/aui-pagination/aui-pagination.js", 355);
event.preventDefault();

                _yuitest_coverline("build/aui-pagination/aui-pagination.js", 357);
if (item.hasClass(CSS_DISABLED) || item.hasClass(CSS_ACTIVE)) {
                    _yuitest_coverline("build/aui-pagination/aui-pagination.js", 358);
return;
                }

                _yuitest_coverline("build/aui-pagination/aui-pagination.js", 361);
var items = instance.get(ITEMS),
                    index = items.indexOf(item),
                    lastIndex = items.size() - 1;

                _yuitest_coverline("build/aui-pagination/aui-pagination.js", 365);
switch(index) {
                    case 0:
                        _yuitest_coverline("build/aui-pagination/aui-pagination.js", 367);
instance.prev();
                        _yuitest_coverline("build/aui-pagination/aui-pagination.js", 368);
break;
                    case lastIndex:
                        _yuitest_coverline("build/aui-pagination/aui-pagination.js", 370);
instance.next();
                        _yuitest_coverline("build/aui-pagination/aui-pagination.js", 371);
break;
                    default:
                        _yuitest_coverline("build/aui-pagination/aui-pagination.js", 373);
instance._dispatchRequest({page:index});
                        _yuitest_coverline("build/aui-pagination/aui-pagination.js", 374);
break;
                }
            },

            _onPageChange: function(event) {
                _yuitest_coverfunc("build/aui-pagination/aui-pagination.js", "_onPageChange", 378);
_yuitest_coverline("build/aui-pagination/aui-pagination.js", 379);
var instance = this;

                _yuitest_coverline("build/aui-pagination/aui-pagination.js", 381);
if (event.prevVal !== event.newVal) {
                    _yuitest_coverline("build/aui-pagination/aui-pagination.js", 382);
var item = instance.getItem(event.prevVal);
                    _yuitest_coverline("build/aui-pagination/aui-pagination.js", 383);
if (item) {
                        _yuitest_coverline("build/aui-pagination/aui-pagination.js", 384);
item.removeClass(CSS_ACTIVE);
                    }
                }
            },

            _renderItemsUI: function(total) {
                _yuitest_coverfunc("build/aui-pagination/aui-pagination.js", "_renderItemsUI", 389);
_yuitest_coverline("build/aui-pagination/aui-pagination.js", 390);
var instance = this;

                // Do not render anything if the number of markup items matches
                // with the passed total attributes.
                _yuitest_coverline("build/aui-pagination/aui-pagination.js", 394);
if ((total > 0) && (total === instance._countItemsInDoc())) {
                    _yuitest_coverline("build/aui-pagination/aui-pagination.js", 395);
return;
                }

                _yuitest_coverline("build/aui-pagination/aui-pagination.js", 398);
var tpl = instance.ITEM_TEMPLATE,
                    offset = instance.get(OFFSET),
                    i,
                    buffer = '';

                _yuitest_coverline("build/aui-pagination/aui-pagination.js", 403);
buffer += Lang.sub(tpl, {
                    content: instance.getString(PREV)
                });

                _yuitest_coverline("build/aui-pagination/aui-pagination.js", 407);
for (i = offset + 1; i <= (offset + total); i++) {
                    _yuitest_coverline("build/aui-pagination/aui-pagination.js", 408);
buffer += Lang.sub(tpl, { content: i });
                }

                _yuitest_coverline("build/aui-pagination/aui-pagination.js", 411);
buffer += Lang.sub(tpl, {
                    content: instance.getString(NEXT)
                });

                _yuitest_coverline("build/aui-pagination/aui-pagination.js", 415);
var items = A.NodeList.create(buffer);
                _yuitest_coverline("build/aui-pagination/aui-pagination.js", 416);
instance.set(ITEMS, items);
                _yuitest_coverline("build/aui-pagination/aui-pagination.js", 417);
instance.get(CONTENT_BOX).setContent(items);
            },

            _setInt: function(val) {
                _yuitest_coverfunc("build/aui-pagination/aui-pagination.js", "_setInt", 420);
_yuitest_coverline("build/aui-pagination/aui-pagination.js", 421);
return Lang.toInt(val);
            },

            _syncNavigationUI: function() {
                _yuitest_coverfunc("build/aui-pagination/aui-pagination.js", "_syncNavigationUI", 424);
_yuitest_coverline("build/aui-pagination/aui-pagination.js", 425);
var instance = this,
                    items = instance.get(ITEMS);

                _yuitest_coverline("build/aui-pagination/aui-pagination.js", 428);
items.first().toggleClass(
                    CSS_DISABLED, instance.get(PAGE) === 1);

                _yuitest_coverline("build/aui-pagination/aui-pagination.js", 431);
items.last().toggleClass(
                    CSS_DISABLED, instance.get(PAGE) === instance.get(TOTAL));
            },

            _uiSetOffset: function(val) {
                _yuitest_coverfunc("build/aui-pagination/aui-pagination.js", "_uiSetOffset", 435);
_yuitest_coverline("build/aui-pagination/aui-pagination.js", 436);
var instance = this;

                _yuitest_coverline("build/aui-pagination/aui-pagination.js", 438);
if (instance.get(RENDERED)) {
                    _yuitest_coverline("build/aui-pagination/aui-pagination.js", 439);
instance._renderItemsUI(instance.get(TOTAL));
                }
            },

            _uiSetPage: function(val) {
                _yuitest_coverfunc("build/aui-pagination/aui-pagination.js", "_uiSetPage", 443);
_yuitest_coverline("build/aui-pagination/aui-pagination.js", 444);
var instance = this;

                _yuitest_coverline("build/aui-pagination/aui-pagination.js", 446);
if (!instance.get(CIRCULAR)) {
                    _yuitest_coverline("build/aui-pagination/aui-pagination.js", 447);
instance._syncNavigationUI();
                }

                // Do not activate first and last items, they are used for controls.
                _yuitest_coverline("build/aui-pagination/aui-pagination.js", 451);
if (val === 0 || val === instance.getTotalItems()) {
                    _yuitest_coverline("build/aui-pagination/aui-pagination.js", 452);
return;
                }

                _yuitest_coverline("build/aui-pagination/aui-pagination.js", 455);
var item = instance.getItem(val);

                _yuitest_coverline("build/aui-pagination/aui-pagination.js", 457);
if (item) {
                    _yuitest_coverline("build/aui-pagination/aui-pagination.js", 458);
item.addClass(CSS_ACTIVE);
                }
            },

            _uiSetTotal: function(val) {
                _yuitest_coverfunc("build/aui-pagination/aui-pagination.js", "_uiSetTotal", 462);
_yuitest_coverline("build/aui-pagination/aui-pagination.js", 463);
var instance = this;

                _yuitest_coverline("build/aui-pagination/aui-pagination.js", 465);
if (instance.get(RENDERED)) {
                    _yuitest_coverline("build/aui-pagination/aui-pagination.js", 466);
instance._renderItemsUI(val);
                }
            }
        }
    }
);

_yuitest_coverline("build/aui-pagination/aui-pagination.js", 473);
A.Pagination = Pagination;

}, '2.0.0pr1', {"requires": ["node-event-delegate", "aui-node", "aui-component", "widget-htmlparser"]});
