if (typeof _yuitest_coverage == "undefined"){
    _yuitest_coverage = {};
    _yuitest_coverline = function(src, line){
        var coverage = _yuitest_coverage[src];
        if (!coverage.lines[line]){
            coverage.calledLines++;
        }
        coverage.lines[line]++;
    };
    _yuitest_coverfunc = function(src, name, line){
        var coverage = _yuitest_coverage[src],
            funcId = name + ":" + line;
        if (!coverage.functions[funcId]){
            coverage.calledFunctions++;
        }
        coverage.functions[funcId]++;
    };
}
_yuitest_coverage["build/aui-tree-node/aui-tree-node.js"] = {
    lines: {},
    functions: {},
    coveredLines: 0,
    calledLines: 0,
    coveredFunctions: 0,
    calledFunctions: 0,
    path: "build/aui-tree-node/aui-tree-node.js",
    code: []
};
_yuitest_coverage["build/aui-tree-node/aui-tree-node.js"].code=["YUI.add('aui-tree-node', function (A, NAME) {","","/**"," * The TreeNode Utility"," *"," * @module aui-tree"," * @submodule aui-tree-node"," */","","var Lang = A.Lang,","	isString = Lang.isString,","	isBoolean = Lang.isBoolean,","	isFunction = Lang.isFunction,","","	CACHE = 'cache',","	IO = 'io',","	LOADED = 'loaded',","	LOADING = 'loading',","	PAGINATOR = 'paginator',","	ALWAYS_SHOW_HITAREA = 'alwaysShowHitArea',","	BLANK = '',","	BOUNDING_BOX = 'boundingBox',","	CHILDREN = 'children',","	COLLAPSED = 'collapsed',","	CONTAINER = 'container',","	CONTENT = 'content',","	CONTENT_BOX = 'contentBox',","	DRAGGABLE = 'draggable',","	EXPANDED = 'expanded',","	HIDDEN = 'hidden',","	HIT_AREA_EL = 'hitAreaEl',","	HITAREA = 'hitarea',","	ICON = 'icon',","	ICON_EL = 'iconEl',","	INVALID = 'invalid',","	HIDE = 'hide',","	ID = 'id',","	LABEL = 'label',","	LABEL_EL = 'labelEl',","	LAST_SELECTED = 'lastSelected',","	LEAF = 'leaf',","	NODE = 'node',","	OVER = 'over',","	OWNER_TREE = 'ownerTree',","	PARENT_NODE = 'parentNode',","	RADIO = 'radio',","	RENDERED = 'rendered',","	SELECTED = 'selected',","	SPACE = ' ',","	TREE = 'tree',","	TREE_NODE = 'tree-node',","	OK = 'ok',","	REFRESH = 'refresh',","	MINUS = 'minus',","	PLUS = 'plus',","	FILE = 'file',","	CLOSE = 'close',","	FOLDER = 'folder',","	SIGN = 'sign',","	OPEN = 'open',","	CHECK = 'check',","","	isTreeNode = function(v) {","		return ( v instanceof A.TreeNode );","	},","","	isTreeView = function(v) {","		return ( v instanceof A.TreeView );","	},","","	getCN = A.getClassName,","","	CSS_TREE_COLLAPSED = getCN(TREE, COLLAPSED),","	CSS_TREE_CONTAINER = getCN(TREE, CONTAINER),","	CSS_TREE_EXPANDED = getCN(TREE, EXPANDED),","	CSS_HIDE = getCN(HIDE),","	CSS_TREE_HITAREA = getCN(TREE, HITAREA),","	CSS_TREE_ICON = getCN(TREE, ICON),","	CSS_TREE_LABEL = getCN(TREE, LABEL),","	CSS_TREE_NODE = getCN(TREE, NODE),","	CSS_TREE_NODE_CONTENT = getCN(TREE, NODE, CONTENT),","	CSS_TREE_NODE_CONTENT_INVALID = getCN(TREE, NODE, CONTENT, INVALID),","	CSS_TREE_NODE_HIDDEN_HITAREA = getCN(TREE, NODE, HIDDEN, HITAREA),","	CSS_TREE_NODE_LEAF = getCN(TREE, NODE, LEAF),","	CSS_TREE_NODE_OVER = getCN(TREE, NODE, OVER),","	CSS_TREE_NODE_SELECTED = getCN(TREE, NODE, SELECTED),","	CSS_ICON_FOLDER_CLOSE = getCN(ICON, FOLDER, CLOSE),","	CSS_ICON_FOLDER_OPEN = getCN(ICON, FOLDER, OPEN),","	CSS_ICON_ICON_PLUS = getCN(ICON, PLUS),","	CSS_ICON_ICON_MINUS = getCN(ICON, MINUS),","	CSS_ICON_ICON_FILE = getCN(ICON, FILE),","	CSS_ICON_ICON_REFRESH = getCN(ICON, REFRESH),","	CSS_ICON_OK_SIGN = getCN(ICON, OK, SIGN),","	CSS_ICON_CHECK = getCN(ICON, CHECK),","","	HIT_AREA_TPL = '<i class=\"'+CSS_TREE_HITAREA+'\"></i>',","	ICON_TPL = '<i class=\"'+CSS_TREE_ICON+'\"></i>',","	LABEL_TPL = '<span class=\"'+CSS_TREE_LABEL+'\"></span>',","	NODE_CONTAINER_TPL = '<ul></ul>',","","	NODE_BOUNDING_TEMPLATE = '<li class=\"'+CSS_TREE_NODE+'\"></li>',","	NODE_CONTENT_TEMPLATE = '<div class=\"'+CSS_TREE_NODE_CONTENT+'\"></div>';","","/**"," * A base class for TreeNode, providing:"," * <ul>"," *	<li>Widget Lifecycle (initializer, renderUI, bindUI, syncUI, destructor)</li>"," *	<li>The node for the TreeView component</li>"," * </ul>"," *"," * Quick Example:<br/>"," *"," * <pre><code>var instance = new A.TreeNode({","	boundingBox: ''","}).render();"," * </code></pre>"," *"," * Check the list of <a href=\"TreeNode.html#configattributes\">Configuration Attributes</a> available for"," * TreeNode."," *"," * @param config {Object} Object literal specifying widget configuration properties."," *"," * @class TreeNode"," * @constructor"," * @extends TreeData"," */","var TreeNode = A.Component.create(","	{","		/**","		 * Static property provides a string to identify the class.","		 *","		 * @property TreeNode.NAME","		 * @type String","		 * @static","		 */","		NAME: TREE_NODE,","","		/**","		 * Static property used to define the default attribute","		 * configuration for the TreeNode.","		 *","		 * @property TreeNode.ATTRS","		 * @type Object","		 * @static","		 */","		ATTRS: {","","			boundingBox: {","				valueFn: function() {","					return A.Node.create(NODE_BOUNDING_TEMPLATE);","				}","			},","","			contentBox: {","				valueFn: function() {","					return A.Node.create(NODE_CONTENT_TEMPLATE);","				}","			},","","			cssClasses: {","				value: {","					file: {","						iconCheck: CSS_ICON_CHECK,","						iconCollapsed: CSS_ICON_FOLDER_CLOSE,","						iconExpanded: CSS_ICON_FOLDER_OPEN,","						iconHitAreaCollapsed: [ CSS_TREE_HITAREA, CSS_ICON_ICON_PLUS ].join(SPACE),","						iconHitAreaExpanded: [ CSS_TREE_HITAREA, CSS_ICON_ICON_MINUS ].join(SPACE),","						iconLeaf: CSS_ICON_ICON_FILE,","						iconLoading: CSS_ICON_ICON_REFRESH,","						iconUncheck: CSS_ICON_CHECK","					},","					normal: {","						iconCheck: CSS_ICON_CHECK,","						iconHitAreaCollapsed: [ CSS_TREE_HITAREA, CSS_ICON_ICON_PLUS ].join(SPACE),","						iconHitAreaExpanded: [ CSS_TREE_HITAREA, CSS_ICON_ICON_MINUS ].join(SPACE),","						iconLoading: CSS_ICON_ICON_REFRESH,","						iconUncheck: CSS_ICON_CHECK","					}","				}","			},","","			/**","			 * If true the TreeNode is draggable.","			 *","			 * @attribute draggable","			 * @default true","			 * @type boolean","			 */","			draggable: {","				value: true,","				validator: isBoolean","			},","","			/**","			 * TreeView which contains the current TreeNode.","			 *","			 * @attribute ownerTree","			 * @default null","			 * @type TreeView","			 */","			ownerTree: {","				value: null","			},","","			/**","			 * Label of the TreeNode.","			 *","			 * @attribute label","			 * @default ''","			 * @type String","			 */","			label: {","				value: BLANK,","				validator: isString","			},","","			/**","			 * Whether the TreeNode is expanded by default.","			 *","			 * @attribute expanded","			 * @default false","			 * @type boolean","			 */","			expanded: {","				value: false,","				validator: isBoolean","			},","","			/**","			 * Id of the TreeNode.","			 *","			 * @attribute id","			 * @default null","			 * @type String","			 */","			id: {","				validator: isString,","				valueFn: function() {","					return A.guid();","				}","			},","","			/**","			 * Whether the TreeNode could have children or not (i.e. if any","			 * children is present the TreeNode is a leaf).","			 *","			 * @attribute leaf","			 * @default true","			 * @type boolean","			 */","			leaf: {","				value: true,","				setter: function(v) {","					// if has children it's not a leaf","					if (v && this.get(CHILDREN).length) {","						return false;","					}","","					return v;","				},","				validator: isBoolean","			},","","			/**","			 * Next sibling of the current TreeNode.","			 *","			 * @attribute nextSibling","			 * @default null","			 * @type TreeNode","			 */","			nextSibling: {","				getter: '_getSibling',","				value: null,","				validator: isTreeNode","			},","","			/**","			 * Previous sibling of the current TreeNode.","			 *","			 * @attribute prevSibling","			 * @default null","			 * @type TreeNode","			 */","			prevSibling: {","				getter: '_getSibling',","				value: null,","				validator: isTreeNode","			},","","			/**","			 * Parent node of the current TreeNode.","			 *","			 * @attribute parentNode","			 * @default null","			 * @type TreeNode","			 */","			parentNode: {","				value: null,","				validator: function(val) {","					return isTreeNode(val) || isTreeView(val);","				}","			},","","			/**","			 * Label element to house the <code>label</code> attribute.","			 *","			 * @attribute labelEl","			 * @default Generated DOM element.","			 * @type Node | String","			 */","			labelEl: {","				setter: A.one,","				valueFn: function() {","					var label = this.get(LABEL);","","					return A.Node.create(LABEL_TPL).html(label).unselectable();","				}","			},","","			/**","			 * Hitarea element.","			 *","			 * @attribute hitAreaEl","			 * @default Generated DOM element.","			 * @type Node | String","			 */","			hitAreaEl: {","				setter: A.one,","				valueFn: function() {","					return A.Node.create(HIT_AREA_TPL);","				}","			},","","			/**","			 * Always show the hitarea icon.","			 *","			 * @attribute alwaysShowHitArea","			 * @default true","			 * @type boolean","			 */","			alwaysShowHitArea: {","				value: true,","				validator: isBoolean","			},","","			/**","			 * Icon element.","			 *","			 * @attribute iconEl","			 * @type Node | String","			 */","			iconEl: {","				setter: A.one,","				valueFn: function() {","					return A.Node.create(ICON_TPL);","				}","			},","","			tabIndex: {","				value: null","			},","","			rendered: {","				validator: isBoolean,","				value: false","			}","		},","","		AUGMENTS: [A.TreeData],","","		EXTENDS: A.Base,","","		prototype: {","			/**","			 * Replaced BOUNDING_TEMPLATE with NODE_BOUNDING_TEMPLATE.","			 *","			 * @property BOUNDING_TEMPLATE","			 * @type String","			 * @protected","			 */","			BOUNDING_TEMPLATE: NODE_BOUNDING_TEMPLATE,","			/**","			 * Replaced CONTENT_TEMPLATE with NODE_CONTENT_TEMPLATE.","			 *","			 * @property CONTENT_TEMPLATE","			 * @type String","			 * @protected","			 */","			CONTENT_TEMPLATE: NODE_CONTENT_TEMPLATE,","","			/**","			 * Construction logic executed during TreeNode instantiation. Lifecycle.","			 *","			 * @method initializer","			 * @protected","			 */","			initializer: function() {","				var instance = this;","","				var boundingBox = instance.get(BOUNDING_BOX);","","				boundingBox.setData(TREE_NODE, instance);","","				// Sync the Widget TreeNode id with the BOUNDING_BOX id","				instance._syncTreeNodeBBId();","","				instance._uiSetDraggable(instance.get(DRAGGABLE));","				instance._uiSetExpanded(instance.get(EXPANDED));","				instance._uiSetLeaf(instance.get(LEAF));","			},","","			/**","			 * Bind the events on the TreeNode UI. Lifecycle.","			 *","			 * @method bindUI","			 * @protected","			 */","			bindUI: function() {","				var instance = this;","","				instance.after({","					childrenChange: instance._afterSetChildren,","					draggableChange: instance._afterDraggableChange,","					expandedChange: instance._afterExpandedChange,","					idChange: instance._afterSetId,","					leafChange: instance._afterLeafChange,","					loadingChange: instance._afterLoadingChange","				});","			},","","			render: function(container) {","				var instance = this;","","				if (!instance.get(RENDERED)) {","					instance.renderUI();","					instance.bindUI();","					instance.syncUI();","","					instance.set(RENDERED, true);","				}","","				if (container) {","					var boundingBox = instance.get(BOUNDING_BOX);","					var paginator = instance.get(PAGINATOR);","","					boundingBox.appendTo(container);","","					if (paginator) {","						boundingBox.insertBefore(paginator.element);","					}","				}","			},","","			/**","			 * Create the DOM structure for the TreeNode. Lifecycle.","			 *","			 * @method renderUI","			 * @protected","			 */","			renderUI: function() {","				var instance = this;","","				instance._renderBoundingBox();","				instance._renderContentBox();","			},","","			/**","			 * Sync the TreeNode UI. Lifecycle.","			 *","			 * @method syncUI","			 * @protected","			 */","			syncUI: function() {","				var instance = this;","","				instance._syncHitArea( instance.get( CHILDREN ) );","				instance._syncIconUI();","			},","","			_afterDraggableChange: function(event) {","				var instance = this;","","				instance._uiSetDraggable(event.newVal);","				instance._syncIconUI();","			},","","			_afterExpandedChange: function(event) {","				var instance = this;","","				instance._uiSetExpanded(event.newVal);","				instance._syncIconUI();","			},","","			_afterLeafChange: function(event) {","				var instance = this;","","				instance._uiSetLeaf(event.newVal);","				instance._syncIconUI();","			},","","			_afterLoadingChange: function(event) {","				var instance = this;","","				instance._syncIconUI();","			},","","			/**","			 * Fires after set children.","			 *","			 * @method _afterSetChildren","			 * @param {EventFacade} event","			 * @protected","			 */","			_afterSetChildren: function(event) {","				var instance = this;","","				instance._syncHitArea(event.newVal);","				instance._syncIconUI();","			},","","			/**","			 * Render the <code>contentBox</code> node.","			 *","			 * @method _renderContentBox","			 * @protected","			 * @return {Node}","			 */","			_renderContentBox: function(v) {","				var instance = this;","","				var contentBox = instance.get(CONTENT_BOX);","","				if (!instance.isLeaf()) {","					var expanded = instance.get(EXPANDED);","","					// add folder css classes state","					contentBox.addClass(","						expanded ? CSS_TREE_EXPANDED : CSS_TREE_COLLAPSED","					);","","					if (expanded) {","						instance.expand();","					}","				}","","				return contentBox;","			},","","			/**","			 * Render the <code>boundingBox</code> node.","			 *","			 * @method _renderBoundingBox","			 * @protected","			 * @return {Node}","			 */","			_renderBoundingBox: function() {","				var instance = this;","","				var boundingBox = instance.get(BOUNDING_BOX);","				var contentBox = instance.get(CONTENT_BOX);","","				contentBox.append( instance.get(ICON_EL) );","				contentBox.append( instance.get(LABEL_EL) );","				boundingBox.append(contentBox);","","				var nodeContainer = instance.get(CONTAINER);","","				if (nodeContainer) {","					if (!instance.get(EXPANDED)) {","						nodeContainer.addClass(CSS_HIDE);","					}","","					boundingBox.append(nodeContainer);","				}","","				return boundingBox;","			},","","			/**","			 * Render the node container.","			 *","			 * @method _createNodeContainer","			 * @protected","			 * @return {Node}","			 */","			_createNodeContainer: function() {","				var instance = this;","","				// creating <ul class=\"aui-tree-container\">","				var nodeContainer = instance.get(CONTAINER) || A.Node.create(NODE_CONTAINER_TPL);","","				nodeContainer.addClass(CSS_TREE_CONTAINER);","","				// when it's not a leaf it has a <ul> container","				instance.set(CONTAINER, nodeContainer);","","				return nodeContainer;","			},","","			/**","			 * Sync the hitarea UI.","			 *","			 * @method _syncHitArea","			 * @param {Array} children","			 * @protected","			 */","			_syncHitArea: function(children) {","				var instance = this;","","				if (instance.get(ALWAYS_SHOW_HITAREA) || children.length) {","					instance.showHitArea();","				}","				else {","					instance.hideHitArea();","","					instance.collapse();","				}","			},","","			/**","			 * Sync the hitarea UI.","			 *","			 * @method _syncIconUI","			 * @param {Array} children","			 * @protected","			 */","			_syncIconUI: function() {","				var instance = this,","					ownerTree = instance.get(OWNER_TREE);","","				if (ownerTree) {","					var type = ownerTree.get('type'),","						cssClasses = instance.get('cssClasses.' + type);","","					if (!cssClasses) {","						return;","					}","","					var expanded = instance.get(EXPANDED),","						iconEl = instance.get(ICON_EL),","						hitAreaEl = instance.get(HIT_AREA_EL),","						icon = instance.isLeaf() ?","								cssClasses.iconLeaf :","								(expanded ? cssClasses.iconExpanded : cssClasses.iconCollapsed),","						iconHitArea = expanded ?","										cssClasses.iconHitAreaExpanded :","										cssClasses.iconHitAreaCollapsed;","","					if (instance.get(LOADING)) {","						icon = cssClasses.iconLoading;","					}","","					iconEl.setAttribute('className', icon || BLANK);","					hitAreaEl.setAttribute('className', iconHitArea || BLANK);","				}","			},","","			/*","			* Methods","			*/","			appendChild: function() {","				var instance = this;","","				if (!instance.isLeaf()) {","					A.TreeNode.superclass.appendChild.apply(instance, arguments);","				}","			},","","			/**","			 * Collapse the current TreeNode.","			 *","			 * @method collapse","			 */","			collapse: function() {","				var instance = this;","","				instance.set(EXPANDED, false);","			},","","			collapseAll: function() {","				var instance = this;","","				A.TreeNode.superclass.collapseAll.apply(instance, arguments);","","				// instance is also a node, so collapse itself","				instance.collapse();","			},","","			/**","			 * Check if the current TreeNode contains the passed <code>node</code>.","			 *","			 * @method contains","			 * @param {TreeNode} node","			 * @return {boolean}","			 */","			contains: function(node) {","				return node.isAncestor(this);","			},","","			/**","			 * Expand the current TreeNode.","			 *","			 * @method expand","			 */","			expand: function() {","				var instance = this;","","				instance.set(EXPANDED, true);","			},","","			expandAll: function() {","				var instance = this;","","				A.TreeNode.superclass.expandAll.apply(instance, arguments);","","				// instance is also a node, so expand itself","				instance.expand();","			},","","			/**","			 * Get the depth of the current TreeNode.","			 *","			 * @method getDepth","			 * @return {Number}","			 */","			getDepth: function() {","				var instance = this;","","				var depth = 0;","","				var parentNode = instance.get(PARENT_NODE);","","				while (parentNode) {","					++depth;","					parentNode = parentNode.get(PARENT_NODE);","				}","","				return depth;","			},","","			hasChildNodes: function() {","				var instance = this;","","				return (!instance.isLeaf() &&","						A.TreeNode.superclass.hasChildNodes.apply(this, arguments));","			},","","			/**","			 * Whether the current TreeNode is selected or not.","			 *","			 * @method isSelected","			 * @return {boolean}","			 */","			isSelected: function() {","				return this.get(CONTENT_BOX).hasClass(CSS_TREE_NODE_SELECTED);","			},","","			/**","			 * Whether the current TreeNode is a leaf or not.","			 *","			 * @method isLeaf","			 * @return {boolean}","			 */","			isLeaf: function() {","				var instance = this;","","				return instance.get(LEAF);","			},","","			/**","			 * Whether the current TreeNode is ancestor of the passed <code>node</code> or not.","			 *","			 * @method isLeaf","			 * @return {boolean}","			 */","			isAncestor: function(node) {","				var instance = this;","","				var parentNode = instance.get(PARENT_NODE);","","				while (parentNode) {","					if (parentNode === node) {","						return true;","					}","					parentNode = parentNode.get(PARENT_NODE);","				}","","				return false;","			},","","			/**","			 * Toggle the current TreeNode, <code>collapsed</code> or <code>expanded</code>.","			 *","			 * @method toggle","			 */","			toggle: function() {","				var instance = this;","","				if (instance.get(EXPANDED)) {","					instance.collapse();","				}","				else {","					instance.expand();","				}","			},","","			/*","			* Select the current TreeNode.","			*","			* @method select","			*/","			select: function() {","				var instance = this;","","				var ownerTree = instance.get(OWNER_TREE);","","				if (ownerTree) {","					ownerTree.set(LAST_SELECTED, instance);","				}","","				instance.get(CONTENT_BOX).addClass(CSS_TREE_NODE_SELECTED);","","				instance.fire('select');","			},","","			/*","			* Unselect the current TreeNode.","			*","			* @method unselect","			*/","			unselect: function() {","				var instance = this;","","				instance.get(CONTENT_BOX).removeClass(CSS_TREE_NODE_SELECTED);","","				instance.fire('unselect');","			},","","			/*","			* Fires when <code>mouseover</code> the current TreeNode.","			*","			* @method over","			*/","			over: function() {","				this.get(CONTENT_BOX).addClass(CSS_TREE_NODE_OVER);","			},","","			/*","			* Fires when <code>mouseout</code> the current TreeNode.","			*","			* @method over","			*/","			out: function() {","				this.get(CONTENT_BOX).removeClass(CSS_TREE_NODE_OVER);","			},","","			/*","			* Show hitarea icon.","			*","			* @method showHitArea","			*/","			showHitArea: function() {","				var instance = this;","","				var hitAreaEl = instance.get(HIT_AREA_EL);","","				hitAreaEl.removeClass(CSS_TREE_NODE_HIDDEN_HITAREA);","			},","","			/*","			* Hide hitarea icon.","			*","			* @method hideHitArea","			*/","			hideHitArea: function() {","				var instance = this;","","				var hitAreaEl = instance.get(HIT_AREA_EL);","","				hitAreaEl.addClass(CSS_TREE_NODE_HIDDEN_HITAREA);","			},","","			/**","			 * Set the <code>boundingBox</code> id.","			 *","			 * @method _syncTreeNodeBBId","			 * @param {String} id","			 * @protected","			 */","			_syncTreeNodeBBId: function(id) {","				var instance = this;","","				instance.get(BOUNDING_BOX).attr(","					ID,","					instance.get(ID)","				);","			},","","			_getSibling: function(value, attrName) {","				var instance = this;","","				var propName = '_' + attrName;","				var sibling = instance[propName];","","				if (sibling !== null && !isTreeNode(sibling)) {","					sibling = null;","					instance[propName] = sibling;","				}","","				return sibling;","			},","","			_uiSetDraggable: function(val) {","				var instance = this;","				var contentBox = instance.get(CONTENT_BOX);","","				contentBox.toggleClass(CSS_TREE_NODE_CONTENT_INVALID, !val);","			},","","			_uiSetExpanded: function(val) {","				var instance = this;","","				if (!instance.isLeaf()) {","					var container = instance.get(CONTAINER);","					var contentBox = instance.get(CONTENT_BOX);","","					if (val) {","						contentBox.replaceClass(CSS_TREE_COLLAPSED, CSS_TREE_EXPANDED);","","						if (container) {","							container.removeClass(CSS_HIDE);","						}","					}","					else {","						contentBox.replaceClass(CSS_TREE_EXPANDED, CSS_TREE_COLLAPSED);","","						if (container) {","							container.addClass(CSS_HIDE);","						}","					}","				}","			},","","			_uiSetLeaf: function(val) {","				var instance = this;","","				var contentBox = instance.get(CONTENT_BOX);","","				if (val) {","					instance.get(CONTAINER).remove();","					instance.get(HIT_AREA_EL).remove();","				}","				else {","					// append hitarea element","					contentBox.prepend( instance.get(HIT_AREA_EL) );","","					// if has children append them to this model","					instance._createNodeContainer();","","					instance._uiSetExpanded(instance.get(EXPANDED));","				}","","				// add leaf css classes","				contentBox.toggleClass(CSS_TREE_NODE_LEAF, val);","			}","		}","	}",");","","A.TreeNode = TreeNode;","","/*","* TreeNodeIO","*/","var TREE_NODE_IO = 'tree-node-io';","","/**"," * A base class for TreeNodeIO, providing:"," * <ul>"," *	<li>Widget Lifecycle (initializer, renderUI, bindUI, syncUI, destructor)</li>"," *	<li>Ajax support to load the children of the current TreeNode</li>"," * </ul>"," *"," * Quick Example:<br/>"," *"," * <pre><code>var treeNodeIO = new A.TreeNodeIO({"," *		label: 'TreeNodeIO',"," *		cache: false,"," *		io: {"," *			url: 'assets/content.html'"," *		}"," *  });"," * </code></pre>"," *"," * Check the list of <a href=\"TreeNodeIO.html#configattributes\">Configuration Attributes</a> available for"," * TreeNodeIO."," *"," * @param config {Object} Object literal specifying widget configuration properties."," *"," * @class TreeNodeIO"," * @constructor"," * @extends TreeNode"," */","var TreeNodeIO = A.Component.create(","	{","		/**","		 * Static property provides a string to identify the class.","		 *","		 * @property TreeNode.NAME","		 * @type String","		 * @static","		 */","		NAME: TREE_NODE_IO,","","		/**","		 * Static property used to define the default attribute","		 * configuration for the TreeNode.","		 *","		 * @property TreeNode.ATTRS","		 * @type Object","		 * @static","		 */","		ATTRS: {","			/**","			 * Whether the current TreeNode IO transaction is loading.","			 *","			 * @attribute loading","			 * @default false","			 * @type boolean","			 */","			loading: {","				value: false,","				validator: isBoolean","			},","","			/**","			 * Whether the current TreeNode has loaded the content.","			 *","			 * @attribute loaded","			 * @default false","			 * @type boolean","			 */","			loaded: {","				value: false,","				validator: isBoolean","			},","","			/**","			 * Whether the current TreeNode should cache the loaded content or not.","			 *","			 * @attribute cache","			 * @default true","			 * @type boolean","			 */","			cache: {","				value: true,","				validator: isBoolean","			},","","			leaf: {","				value: false,","				validator: isBoolean","			}","		},","","		AUGMENTS: [A.TreeViewPaginator, A.TreeViewIO],","","		EXTENDS: A.TreeNode,","","		prototype: {","			/**","			 * Bind the events on the TreeNodeIO UI. Lifecycle.","			 *","			 * @method bindUI","			 * @protected","			 */","			bindUI: function() {","				var instance = this;","","				A.TreeNodeIO.superclass.bindUI.apply(this, arguments);","","				instance.on('ioRequestSuccess', instance._onIOSuccess, instance);","			},","","			syncUI: function() {","				var instance = this;","","				A.TreeNodeIO.superclass.syncUI.apply(this, arguments);","			},","","			/*","			* Methods","			*/","			createNodes: function(nodes) {","				var instance = this;","","				A.Array.each(A.Array(nodes), function(node) {","					var newNode = instance.createNode(node);","","					instance.appendChild(newNode);","				});","","				instance._syncPaginatorUI(nodes);","			},","","			expand: function() {","				var instance = this;","","				var cache = instance.get(CACHE);","				var io = instance.get(IO);","				var loaded = instance.get(LOADED);","				var loading = instance.get(LOADING);","","				if (!cache) {","					// if cache is false on expand, always set LOADED to false","					instance.set(LOADED, false);","				}","","				if (io && !loaded && !loading && !this.hasChildNodes()) {","					if (!cache) {","						// remove all children to reload","						instance.empty();","					}","","					instance.initIO();","				}","				else {","					A.TreeNodeIO.superclass.expand.apply(this, arguments);","				}","			},","","			/**","			 * If not specified on the TreeNode some attributes are inherited from the","			 * ownerTree by this method.","			 *","			 * @method _inheritOwnerTreeAttrs","			 * @protected","			 */","			_inheritOwnerTreeAttrs: function() {","				var instance = this;","","				var ownerTree = instance.get(OWNER_TREE);","","				if (ownerTree) {","					if (!instance.get(IO)) {","						var io = A.clone(","							ownerTree.get(IO),","							true,","							function(value, key) {","								if (isFunction(value) && (value.defaultFn || value.wrappedFn)) {","									return false;","								}","","								return true;","							}","						);","","						instance.set(IO, io);","					}","","					if (!instance.get(PAGINATOR)) {","						var ownerTreePaginator = ownerTree.get(PAGINATOR);","","						var paginator = A.clone(ownerTreePaginator);","","						// make sure we are not using the same element passed to the ownerTree on the TreeNode","						if (paginator && paginator.element) {","							paginator.element = ownerTreePaginator.element.clone();","						}","","						instance.set(PAGINATOR, paginator);","					}","				}","			},","","			_onIOSuccess: function(event) {","				var instance = this;","","				instance.expand();","			}","		}","	}",");","","A.TreeNodeIO = TreeNodeIO;","","/*","* TreeNodeCheck","*/","var CHECKBOX = 'checkbox',","	CHECKED = 'checked',","	CHECK_CONTAINER_EL = 'checkContainerEl',","	CHECK_EL = 'checkEl',","	CHECK_NAME = 'checkName',","	DOT = '.',","	NAME = 'name',","	TREE_NODE_CHECK = 'tree-node-check',","","	CSS_TREE_NODE_CHECKBOX = getCN(TREE, NODE, CHECKBOX),","	CSS_TREE_NODE_CHECKBOX_CONTAINER = getCN(TREE, NODE, CHECKBOX, CONTAINER),","	CSS_TREE_NODE_CHECKED = getCN(TREE, NODE, CHECKED),","","	CHECKBOX_CONTAINER_TPL = '<i class=\"'+CSS_TREE_NODE_CHECKBOX_CONTAINER+'\"></i>',","	CHECKBOX_TPL = '<input class=\"'+CSS_TREE_NODE_CHECKBOX+'\" type=\"checkbox\" />';","","/**"," * <p><img src=\"assets/images/aui-tree-nod-check/main.png\"/></p>"," *"," * A base class for TreeNodeCheck, providing:"," * <ul>"," *	<li>Widget Lifecycle (initializer, renderUI, bindUI, syncUI, destructor)</li>"," *	<li>Checkbox support for the TreeNode</li>"," * </ul>"," *"," * Check the list of <a href=\"TreeNodeCheck.html#configattributes\">Configuration Attributes</a> available for"," * TreeNodeCheck."," *"," * @param config {Object} Object literal specifying widget configuration properties."," *"," * @class TreeNodeCheck"," * @constructor"," * @extends TreeNodeIO"," */","var TreeNodeCheck = A.Component.create(","	{","		/**","		 * Static property provides a string to identify the class.","		 *","		 * @property TreeNode.NAME","		 * @type String","		 * @static","		 */","		NAME: TREE_NODE_CHECK,","","		/**","		 * Static property used to define the default attribute","		 * configuration for the TreeNode.","		 *","		 * @property TreeNode.ATTRS","		 * @type Object","		 * @static","		 */","		ATTRS: {","			/**","			 * Whether the TreeNode is checked or not.","			 *","			 * @attribute checked","			 * @default false","			 * @type boolean","			 */","			checked: {","				value: false,","				validator: isBoolean","			},","","			/**","			 * Name of the checkbox element used on the current TreeNode.","			 *","			 * @attribute checkName","			 * @default 'tree-node-check'","			 * @type String","			 */","			checkName: {","				value: TREE_NODE_CHECK,","				validator: isString","			},","","			/**","			 * Container element for the checkbox.","			 *","			 * @attribute checkContainerEl","			 * @default Generated DOM element.","			 * @type Node | String","			 */","			checkContainerEl: {","				setter: A.one,","				valueFn: function() {","					return A.Node.create(CHECKBOX_CONTAINER_TPL);","				}","			},","","			/**","			 * Checkbox element.","			 *","			 * @attribute checkEl","			 * @default Generated DOM element.","			 * @type Node | String","			 */","			checkEl: {","				setter: A.one,","				valueFn: function() {","					var checkName = this.get(CHECK_NAME);","","					return A.Node.create(CHECKBOX_TPL).attr(NAME, checkName);","				}","			}","		},","","		EXTENDS: A.TreeNodeIO,","","		prototype: {","","			initializer: function() {","				var instance = this;","","				instance._uiSetChecked(instance.get(CHECKED));","			},","","			/*","			* Lifecycle","			*/","			renderUI: function() {","				var instance = this;","","				A.TreeNodeCheck.superclass.renderUI.apply(instance, arguments);","","				var labelEl = instance.get(LABEL_EL);","				var checkEl = instance.get(CHECK_EL);","				var checkContainerEl = instance.get(CHECK_CONTAINER_EL);","","				checkEl.hide();","","				checkContainerEl.append(checkEl);","","				labelEl.placeBefore(checkContainerEl);","","				if (instance.isChecked()) {","					instance.check();","				}","			},","","			bindUI: function() {","				var instance = this;","","				var contentBox = instance.get(CONTENT_BOX);","				var labelEl = instance.get(LABEL_EL);","","				A.TreeNodeCheck.superclass.bindUI.apply(instance, arguments);","","				instance.after('checkedChange', A.bind(instance._afterCheckedChange, instance));","","				contentBox.delegate('click', A.bind(instance.toggleCheck, instance), DOT+CSS_TREE_NODE_CHECKBOX_CONTAINER);","				contentBox.delegate('click', A.bind(instance.toggleCheck, instance), DOT+CSS_TREE_LABEL);","","				// cancel dblclick because of the check","				labelEl.swallowEvent('dblclick');","			},","","			/**","			 * Check the current TreeNode.","			 *","			 * @method check","			 */","			check: function(originalTarget) {","				var instance = this;","","				instance.set(CHECKED, true, {","					originalTarget: originalTarget","				});","			},","","			/**","			 * Uncheck the current TreeNode.","			 *","			 * @method uncheck","			 */","			uncheck: function(originalTarget) {","				var instance = this;","","				instance.set(CHECKED, false, {","					originalTarget: originalTarget","				});","			},","","			/**","			 * Toggle the check status of the current TreeNode.","			 *","			 * @method toggleCheck","			 */","			toggleCheck: function() {","				var instance = this;","","				var checkEl = instance.get(CHECK_EL);","				var checked = checkEl.attr(CHECKED);","","				if (!checked) {","					instance.check();","				}","				else {","					instance.uncheck();","				}","			},","","			/*","			* Whether the current TreeNodeCheck is checked.","			*","			* @method isChecked","			* @return boolean","			*/","			isChecked: function() {","				var instance = this;","","				return instance.get(CHECKED);","			},","","			_syncIconCheckUI: function() {","				var instance = this,","					ownerTree = instance.get(OWNER_TREE);","","				if (ownerTree) {","					var type = ownerTree.get('type'),","						cssClasses = instance.get('cssClasses.' + type);","","					if (!cssClasses) {","						return;","					}","","					var checkContainerEl = instance.get(CHECK_CONTAINER_EL),","						isChecked = instance.isChecked();","					checkContainerEl.removeClass(","						isChecked ?","							cssClasses.iconUncheck : cssClasses.iconCheck);","					checkContainerEl.addClass(","						isChecked ?","							cssClasses.iconCheck : cssClasses.iconUncheck);","				}","			},","","			_afterCheckedChange: function(event) {","				var instance = this;","","				instance._uiSetChecked(event.newVal);","			},","","			_uiSetChecked: function(val) {","				var instance = this;","","				instance._syncIconCheckUI();","				instance.get(CHECK_EL).attr(CHECKED, val ? CHECKED : BLANK);","				instance.get(CONTENT_BOX).toggleClass(CSS_TREE_NODE_CHECKED, val);","			}","		}","	}",");","","A.TreeNodeCheck = TreeNodeCheck;","","/*","* TreeNodeTask","*/","var CHILD = 'child',","	TREE_NODE_TASK = 'tree-node-task',","	UNCHECKED = 'unchecked',","","	isTreeNodeTask = function(node) {","		return node instanceof A.TreeNodeCheck;","	},","","	CSS_TREE_NODE_CHILD_UNCHECKED = getCN(TREE, NODE, CHILD, UNCHECKED);","","/**"," * <p><img src=\"assets/images/aui-treeNodeTask/main.png\"/></p>"," *"," * A base class for TreeNodeTask, providing:"," * <ul>"," *	<li>Widget Lifecycle (initializer, renderUI, bindUI, syncUI, destructor)</li>"," *	<li>3 states checkbox support</li>"," *	<li>Automatic check/uncheck the parent status based on the children checked status</li>"," * </ul>"," *"," * Check the list of <a href=\"TreeNodeTask.html#configattributes\">Configuration Attributes</a> available for"," * TreeNodeTask."," *"," * @param config {Object} Object literal specifying widget configuration properties."," *"," * @class TreeNodeTask"," * @constructor"," * @extends TreeNodeCheck"," */","var TreeNodeTask = A.Component.create(","	{","		/**","		 * Static property provides a string to identify the class.","		 *","		 * @property TreeNode.NAME","		 * @type String","		 * @static","		 */","		NAME: TREE_NODE_TASK,","","		EXTENDS: A.TreeNodeCheck,","","		prototype: {","			/*","			* Methods","			*/","			check: function(originalTarget) {","				var instance = this;","","				var contentBox = instance.get(CONTENT_BOX);","","				originalTarget = originalTarget || instance;","","				if (!instance.isLeaf()) {","					instance.eachChildren(function(child) {","						if (isTreeNodeTask(child)) {","							child.check(originalTarget);","						}","					});","				}","","				instance.eachParent(","					function(parentNode) {","						if (isTreeNodeTask(parentNode) && !parentNode.isChecked()) {","							parentNode.get(CONTENT_BOX).addClass(CSS_TREE_NODE_CHILD_UNCHECKED);","						}","					}","				);","","				contentBox.removeClass(CSS_TREE_NODE_CHILD_UNCHECKED);","","				// invoke default check logic","				A.TreeNodeTask.superclass.check.call(this, originalTarget);","			},","","			uncheck: function(originalTarget) {","				var instance = this;","","				var contentBox = instance.get(CONTENT_BOX);","","				originalTarget = originalTarget || instance;","","				if (!instance.isLeaf()) {","					instance.eachChildren(function(child) {","						if (child instanceof A.TreeNodeCheck) {","							child.uncheck(originalTarget);","						}","					});","				}","","				instance.eachParent(","					function(parentNode) {","						if (isTreeNodeTask(parentNode) && !parentNode.isChecked()) {","							parentNode.get(CONTENT_BOX).removeClass(CSS_TREE_NODE_CHILD_UNCHECKED);","						}","					}","				);","","				contentBox.removeClass(CSS_TREE_NODE_CHILD_UNCHECKED);","","				// invoke default uncheck logic","				A.TreeNodeTask.superclass.uncheck.call(this, originalTarget);","			}","		}","	}",");","","A.TreeNodeTask = TreeNodeTask;","","/*","* TreeNodeRadio","*/","","var TREE_NODE_RADIO = 'tree-node-radio',","","	isTreeNodeRadio = function(node) {","		return node instanceof A.TreeNodeRadio;","	},","","	CSS_NODE_RADIO = getCN(TREE, NODE, RADIO);","","/**"," * <p><img src=\"assets/images/aui-treeNodeRadio/main.png\"/></p>"," *"," * A base class for TreeNodeRadio, providing:"," * <ul>"," *	<li>Widget Lifecycle (initializer, renderUI, bindUI, syncUI, destructor)</li>"," *	<li>3 states checkbox support</li>"," *	<li>Automatic check/uncheck the parent status based on the children checked status</li>"," * </ul>"," *"," * Check the list of <a href=\"TreeNodeRadio.html#configattributes\">Configuration Attributes</a> available for"," * TreeNodeRadio."," *"," * @param config {Object} Object literal specifying widget configuration properties."," *"," * @class TreeNodeRadio"," * @constructor"," * @extends TreeNodeTask"," */","var TreeNodeRadio = A.Component.create(","	{","		/**","		 * Static property provides a string to identify the class.","		 *","		 * @property TreeNode.NAME","		 * @type String","		 * @static","		 */","		NAME: TREE_NODE_RADIO,","","		ATTRS: {","			cssClasses: {","				value: {","					file: {","						iconCheck: CSS_ICON_OK_SIGN,","						iconCollapsed: CSS_ICON_FOLDER_CLOSE,","						iconExpanded: CSS_ICON_FOLDER_OPEN,","						iconHitAreaCollapsed: [ CSS_TREE_HITAREA, CSS_ICON_ICON_PLUS ].join(SPACE),","						iconHitAreaExpanded: [ CSS_TREE_HITAREA, CSS_ICON_ICON_MINUS ].join(SPACE),","						iconLeaf: CSS_ICON_ICON_FILE,","						iconLoading: CSS_ICON_ICON_REFRESH,","						iconUncheck: CSS_ICON_OK_SIGN","					},","					normal: {","						iconCheck: CSS_ICON_OK_SIGN,","						iconHitAreaCollapsed: [ CSS_TREE_HITAREA, CSS_ICON_ICON_PLUS ].join(SPACE),","						iconHitAreaExpanded: [ CSS_TREE_HITAREA, CSS_ICON_ICON_MINUS ].join(SPACE),","						iconLoading: CSS_ICON_ICON_REFRESH,","						iconUncheck: CSS_ICON_OK_SIGN","					}","				}","			}","		},","","		EXTENDS: A.TreeNodeTask,","","		prototype: {","			/*","			* Methods","			*/","			renderUI: function() {","				var instance = this;","","				A.TreeNodeRadio.superclass.renderUI.apply(instance, arguments);","","				instance.get(CONTENT_BOX).addClass(CSS_NODE_RADIO);","			},","","			check: function() {","				var instance = this;","","				instance._uncheckNodesRadio();","","				A.TreeNodeRadio.superclass.check.apply(this, arguments);","			},","","			_uncheckNodesRadio: function(node) {","				var instance = this;","","				var children;","","				if (node) {","					children = node.get(CHILDREN);","				}","				else {","					var ownerTree = instance.get(OWNER_TREE);","","					if (ownerTree) {","						children = ownerTree.get(CHILDREN);","					}","					else {","						return;","					}","				}","","				A.Array.each(","					children,","					function(value, index, collection) {","						if (!value.isLeaf()) {","							instance._uncheckNodesRadio(value);","						}","","						if (isTreeNodeRadio(value)) {","							value.uncheck();","						}","					}","				);","			}","		}","	}",");","","A.TreeNodeRadio = TreeNodeRadio;","","/**"," * TreeNode types hash map."," *"," * <pre><code>A.TreeNode.nodeTypes = {"," *  radio: A.TreeNodeRadio,"," *  task: A.TreeNodeTask,"," *  check: A.TreeNodeCheck,"," *  node: A.TreeNode,"," *  io: A.TreeNodeIO"," *};</code></pre>"," *"," * @for TreeNode"," * @property A.TreeNode.nodeTypes"," * @type Object"," */","A.TreeNode.nodeTypes = {","	radio: A.TreeNodeRadio,","	task: A.TreeNodeTask,","	check: A.TreeNodeCheck,","	node: A.TreeNode,","	io: A.TreeNodeIO","};","","}, '2.0.0pr1', {\"requires\": [\"json\", \"querystring-stringify\", \"aui-tree-data\", \"aui-tree-io\", \"aui-tree-paginator\"]});"];
_yuitest_coverage["build/aui-tree-node/aui-tree-node.js"].lines = {"1":0,"10":0,"64":0,"68":0,"127":0,"150":0,"156":0,"239":0,"255":0,"256":0,"259":0,"300":0,"314":0,"316":0,"330":0,"355":0,"398":0,"400":0,"402":0,"405":0,"407":0,"408":0,"409":0,"419":0,"421":0,"432":0,"434":0,"435":0,"436":0,"437":0,"439":0,"442":0,"443":0,"444":0,"446":0,"448":0,"449":0,"461":0,"463":0,"464":0,"474":0,"476":0,"477":0,"481":0,"483":0,"484":0,"488":0,"490":0,"491":0,"495":0,"497":0,"498":0,"502":0,"504":0,"515":0,"517":0,"518":0,"529":0,"531":0,"533":0,"534":0,"537":0,"541":0,"542":0,"546":0,"557":0,"559":0,"560":0,"562":0,"563":0,"564":0,"566":0,"568":0,"569":0,"570":0,"573":0,"576":0,"587":0,"590":0,"592":0,"595":0,"597":0,"608":0,"610":0,"611":0,"614":0,"616":0,"628":0,"631":0,"632":0,"635":0,"636":0,"639":0,"649":0,"650":0,"653":0,"654":0,"662":0,"664":0,"665":0,"675":0,"677":0,"681":0,"683":0,"686":0,"697":0,"706":0,"708":0,"712":0,"714":0,"717":0,"727":0,"729":0,"731":0,"733":0,"734":0,"735":0,"738":0,"742":0,"744":0,"755":0,"765":0,"767":0,"777":0,"779":0,"781":0,"782":0,"783":0,"785":0,"788":0,"797":0,"799":0,"800":0,"803":0,"813":0,"815":0,"817":0,"818":0,"821":0,"823":0,"832":0,"834":0,"836":0,"845":0,"854":0,"863":0,"865":0,"867":0,"876":0,"878":0,"880":0,"891":0,"893":0,"900":0,"902":0,"903":0,"905":0,"906":0,"907":0,"910":0,"914":0,"915":0,"917":0,"921":0,"923":0,"924":0,"925":0,"927":0,"928":0,"930":0,"931":0,"935":0,"937":0,"938":0,"945":0,"947":0,"949":0,"950":0,"951":0,"955":0,"958":0,"960":0,"964":0,"970":0,"975":0,"1004":0,"1078":0,"1080":0,"1082":0,"1086":0,"1088":0,"1095":0,"1097":0,"1098":0,"1100":0,"1103":0,"1107":0,"1109":0,"1110":0,"1111":0,"1112":0,"1114":0,"1116":0,"1119":0,"1120":0,"1122":0,"1125":0,"1128":0,"1140":0,"1142":0,"1144":0,"1145":0,"1146":0,"1150":0,"1151":0,"1154":0,"1158":0,"1161":0,"1162":0,"1164":0,"1167":0,"1168":0,"1171":0,"1177":0,"1179":0,"1185":0,"1190":0,"1224":0,"1278":0,"1292":0,"1294":0,"1304":0,"1306":0,"1313":0,"1315":0,"1317":0,"1318":0,"1319":0,"1321":0,"1323":0,"1325":0,"1327":0,"1328":0,"1333":0,"1335":0,"1336":0,"1338":0,"1340":0,"1342":0,"1343":0,"1346":0,"1355":0,"1357":0,"1368":0,"1370":0,"1381":0,"1383":0,"1384":0,"1386":0,"1387":0,"1390":0,"1401":0,"1403":0,"1407":0,"1410":0,"1411":0,"1414":0,"1415":0,"1418":0,"1420":0,"1423":0,"1430":0,"1432":0,"1436":0,"1438":0,"1439":0,"1440":0,"1446":0,"1451":0,"1456":0,"1480":0,"1498":0,"1500":0,"1502":0,"1504":0,"1505":0,"1506":0,"1507":0,"1512":0,"1514":0,"1515":0,"1520":0,"1523":0,"1527":0,"1529":0,"1531":0,"1533":0,"1534":0,"1535":0,"1536":0,"1541":0,"1543":0,"1544":0,"1549":0,"1552":0,"1558":0,"1564":0,"1567":0,"1591":0,"1633":0,"1635":0,"1637":0,"1641":0,"1643":0,"1645":0,"1649":0,"1651":0,"1653":0,"1654":0,"1657":0,"1659":0,"1660":0,"1663":0,"1667":0,"1670":0,"1671":0,"1674":0,"1675":0,"1684":0,"1701":0};
_yuitest_coverage["build/aui-tree-node/aui-tree-node.js"].functions = {"isTreeNode:63":0,"isTreeView:67":0,"valueFn:149":0,"valueFn:155":0,"valueFn:238":0,"setter:253":0,"validator:299":0,"valueFn:313":0,"valueFn:329":0,"valueFn:354":0,"initializer:397":0,"bindUI:418":0,"render:431":0,"renderUI:460":0,"syncUI:473":0,"_afterDraggableChange:480":0,"_afterExpandedChange:487":0,"_afterLeafChange:494":0,"_afterLoadingChange:501":0,"_afterSetChildren:514":0,"_renderContentBox:528":0,"_renderBoundingBox:556":0,"_createNodeContainer:586":0,"_syncHitArea:607":0,"_syncIconUI:627":0,"appendChild:661":0,"collapse:674":0,"collapseAll:680":0,"contains:696":0,"expand:705":0,"expandAll:711":0,"getDepth:726":0,"hasChildNodes:741":0,"isSelected:754":0,"isLeaf:764":0,"isAncestor:776":0,"toggle:796":0,"select:812":0,"unselect:831":0,"over:844":0,"out:853":0,"showHitArea:862":0,"hideHitArea:875":0,"_syncTreeNodeBBId:890":0,"_getSibling:899":0,"_uiSetDraggable:913":0,"_uiSetExpanded:920":0,"_uiSetLeaf:944":0,"bindUI:1077":0,"syncUI:1085":0,"(anonymous 2):1097":0,"createNodes:1094":0,"expand:1106":0,"(anonymous 3):1149":0,"_inheritOwnerTreeAttrs:1139":0,"_onIOSuccess:1176":0,"valueFn:1277":0,"valueFn:1291":0,"initializer:1303":0,"renderUI:1312":0,"bindUI:1332":0,"check:1354":0,"uncheck:1367":0,"toggleCheck:1380":0,"isChecked:1400":0,"_syncIconCheckUI:1406":0,"_afterCheckedChange:1429":0,"_uiSetChecked:1435":0,"isTreeNodeTask:1455":0,"(anonymous 4):1505":0,"(anonymous 5):1513":0,"check:1497":0,"(anonymous 6):1534":0,"(anonymous 7):1542":0,"uncheck:1526":0,"isTreeNodeRadio:1566":0,"renderUI:1632":0,"check:1640":0,"(anonymous 8):1669":0,"_uncheckNodesRadio:1648":0,"(anonymous 1):1":0};
_yuitest_coverage["build/aui-tree-node/aui-tree-node.js"].coveredLines = 330;
_yuitest_coverage["build/aui-tree-node/aui-tree-node.js"].coveredFunctions = 81;
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1);
YUI.add('aui-tree-node', function (A, NAME) {

/**
 * The TreeNode Utility
 *
 * @module aui-tree
 * @submodule aui-tree-node
 */

_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "(anonymous 1)", 1);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 10);
var Lang = A.Lang,
	isString = Lang.isString,
	isBoolean = Lang.isBoolean,
	isFunction = Lang.isFunction,

	CACHE = 'cache',
	IO = 'io',
	LOADED = 'loaded',
	LOADING = 'loading',
	PAGINATOR = 'paginator',
	ALWAYS_SHOW_HITAREA = 'alwaysShowHitArea',
	BLANK = '',
	BOUNDING_BOX = 'boundingBox',
	CHILDREN = 'children',
	COLLAPSED = 'collapsed',
	CONTAINER = 'container',
	CONTENT = 'content',
	CONTENT_BOX = 'contentBox',
	DRAGGABLE = 'draggable',
	EXPANDED = 'expanded',
	HIDDEN = 'hidden',
	HIT_AREA_EL = 'hitAreaEl',
	HITAREA = 'hitarea',
	ICON = 'icon',
	ICON_EL = 'iconEl',
	INVALID = 'invalid',
	HIDE = 'hide',
	ID = 'id',
	LABEL = 'label',
	LABEL_EL = 'labelEl',
	LAST_SELECTED = 'lastSelected',
	LEAF = 'leaf',
	NODE = 'node',
	OVER = 'over',
	OWNER_TREE = 'ownerTree',
	PARENT_NODE = 'parentNode',
	RADIO = 'radio',
	RENDERED = 'rendered',
	SELECTED = 'selected',
	SPACE = ' ',
	TREE = 'tree',
	TREE_NODE = 'tree-node',
	OK = 'ok',
	REFRESH = 'refresh',
	MINUS = 'minus',
	PLUS = 'plus',
	FILE = 'file',
	CLOSE = 'close',
	FOLDER = 'folder',
	SIGN = 'sign',
	OPEN = 'open',
	CHECK = 'check',

	isTreeNode = function(v) {
		_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "isTreeNode", 63);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 64);
return ( v instanceof A.TreeNode );
	},

	isTreeView = function(v) {
		_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "isTreeView", 67);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 68);
return ( v instanceof A.TreeView );
	},

	getCN = A.getClassName,

	CSS_TREE_COLLAPSED = getCN(TREE, COLLAPSED),
	CSS_TREE_CONTAINER = getCN(TREE, CONTAINER),
	CSS_TREE_EXPANDED = getCN(TREE, EXPANDED),
	CSS_HIDE = getCN(HIDE),
	CSS_TREE_HITAREA = getCN(TREE, HITAREA),
	CSS_TREE_ICON = getCN(TREE, ICON),
	CSS_TREE_LABEL = getCN(TREE, LABEL),
	CSS_TREE_NODE = getCN(TREE, NODE),
	CSS_TREE_NODE_CONTENT = getCN(TREE, NODE, CONTENT),
	CSS_TREE_NODE_CONTENT_INVALID = getCN(TREE, NODE, CONTENT, INVALID),
	CSS_TREE_NODE_HIDDEN_HITAREA = getCN(TREE, NODE, HIDDEN, HITAREA),
	CSS_TREE_NODE_LEAF = getCN(TREE, NODE, LEAF),
	CSS_TREE_NODE_OVER = getCN(TREE, NODE, OVER),
	CSS_TREE_NODE_SELECTED = getCN(TREE, NODE, SELECTED),
	CSS_ICON_FOLDER_CLOSE = getCN(ICON, FOLDER, CLOSE),
	CSS_ICON_FOLDER_OPEN = getCN(ICON, FOLDER, OPEN),
	CSS_ICON_ICON_PLUS = getCN(ICON, PLUS),
	CSS_ICON_ICON_MINUS = getCN(ICON, MINUS),
	CSS_ICON_ICON_FILE = getCN(ICON, FILE),
	CSS_ICON_ICON_REFRESH = getCN(ICON, REFRESH),
	CSS_ICON_OK_SIGN = getCN(ICON, OK, SIGN),
	CSS_ICON_CHECK = getCN(ICON, CHECK),

	HIT_AREA_TPL = '<i class="'+CSS_TREE_HITAREA+'"></i>',
	ICON_TPL = '<i class="'+CSS_TREE_ICON+'"></i>',
	LABEL_TPL = '<span class="'+CSS_TREE_LABEL+'"></span>',
	NODE_CONTAINER_TPL = '<ul></ul>',

	NODE_BOUNDING_TEMPLATE = '<li class="'+CSS_TREE_NODE+'"></li>',
	NODE_CONTENT_TEMPLATE = '<div class="'+CSS_TREE_NODE_CONTENT+'"></div>';

/**
 * A base class for TreeNode, providing:
 * <ul>
 *	<li>Widget Lifecycle (initializer, renderUI, bindUI, syncUI, destructor)</li>
 *	<li>The node for the TreeView component</li>
 * </ul>
 *
 * Quick Example:<br/>
 *
 * <pre><code>var instance = new A.TreeNode({
	boundingBox: ''
}).render();
 * </code></pre>
 *
 * Check the list of <a href="TreeNode.html#configattributes">Configuration Attributes</a> available for
 * TreeNode.
 *
 * @param config {Object} Object literal specifying widget configuration properties.
 *
 * @class TreeNode
 * @constructor
 * @extends TreeData
 */
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 127);
var TreeNode = A.Component.create(
	{
		/**
		 * Static property provides a string to identify the class.
		 *
		 * @property TreeNode.NAME
		 * @type String
		 * @static
		 */
		NAME: TREE_NODE,

		/**
		 * Static property used to define the default attribute
		 * configuration for the TreeNode.
		 *
		 * @property TreeNode.ATTRS
		 * @type Object
		 * @static
		 */
		ATTRS: {

			boundingBox: {
				valueFn: function() {
					_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "valueFn", 149);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 150);
return A.Node.create(NODE_BOUNDING_TEMPLATE);
				}
			},

			contentBox: {
				valueFn: function() {
					_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "valueFn", 155);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 156);
return A.Node.create(NODE_CONTENT_TEMPLATE);
				}
			},

			cssClasses: {
				value: {
					file: {
						iconCheck: CSS_ICON_CHECK,
						iconCollapsed: CSS_ICON_FOLDER_CLOSE,
						iconExpanded: CSS_ICON_FOLDER_OPEN,
						iconHitAreaCollapsed: [ CSS_TREE_HITAREA, CSS_ICON_ICON_PLUS ].join(SPACE),
						iconHitAreaExpanded: [ CSS_TREE_HITAREA, CSS_ICON_ICON_MINUS ].join(SPACE),
						iconLeaf: CSS_ICON_ICON_FILE,
						iconLoading: CSS_ICON_ICON_REFRESH,
						iconUncheck: CSS_ICON_CHECK
					},
					normal: {
						iconCheck: CSS_ICON_CHECK,
						iconHitAreaCollapsed: [ CSS_TREE_HITAREA, CSS_ICON_ICON_PLUS ].join(SPACE),
						iconHitAreaExpanded: [ CSS_TREE_HITAREA, CSS_ICON_ICON_MINUS ].join(SPACE),
						iconLoading: CSS_ICON_ICON_REFRESH,
						iconUncheck: CSS_ICON_CHECK
					}
				}
			},

			/**
			 * If true the TreeNode is draggable.
			 *
			 * @attribute draggable
			 * @default true
			 * @type boolean
			 */
			draggable: {
				value: true,
				validator: isBoolean
			},

			/**
			 * TreeView which contains the current TreeNode.
			 *
			 * @attribute ownerTree
			 * @default null
			 * @type TreeView
			 */
			ownerTree: {
				value: null
			},

			/**
			 * Label of the TreeNode.
			 *
			 * @attribute label
			 * @default ''
			 * @type String
			 */
			label: {
				value: BLANK,
				validator: isString
			},

			/**
			 * Whether the TreeNode is expanded by default.
			 *
			 * @attribute expanded
			 * @default false
			 * @type boolean
			 */
			expanded: {
				value: false,
				validator: isBoolean
			},

			/**
			 * Id of the TreeNode.
			 *
			 * @attribute id
			 * @default null
			 * @type String
			 */
			id: {
				validator: isString,
				valueFn: function() {
					_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "valueFn", 238);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 239);
return A.guid();
				}
			},

			/**
			 * Whether the TreeNode could have children or not (i.e. if any
			 * children is present the TreeNode is a leaf).
			 *
			 * @attribute leaf
			 * @default true
			 * @type boolean
			 */
			leaf: {
				value: true,
				setter: function(v) {
					// if has children it's not a leaf
					_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "setter", 253);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 255);
if (v && this.get(CHILDREN).length) {
						_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 256);
return false;
					}

					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 259);
return v;
				},
				validator: isBoolean
			},

			/**
			 * Next sibling of the current TreeNode.
			 *
			 * @attribute nextSibling
			 * @default null
			 * @type TreeNode
			 */
			nextSibling: {
				getter: '_getSibling',
				value: null,
				validator: isTreeNode
			},

			/**
			 * Previous sibling of the current TreeNode.
			 *
			 * @attribute prevSibling
			 * @default null
			 * @type TreeNode
			 */
			prevSibling: {
				getter: '_getSibling',
				value: null,
				validator: isTreeNode
			},

			/**
			 * Parent node of the current TreeNode.
			 *
			 * @attribute parentNode
			 * @default null
			 * @type TreeNode
			 */
			parentNode: {
				value: null,
				validator: function(val) {
					_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "validator", 299);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 300);
return isTreeNode(val) || isTreeView(val);
				}
			},

			/**
			 * Label element to house the <code>label</code> attribute.
			 *
			 * @attribute labelEl
			 * @default Generated DOM element.
			 * @type Node | String
			 */
			labelEl: {
				setter: A.one,
				valueFn: function() {
					_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "valueFn", 313);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 314);
var label = this.get(LABEL);

					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 316);
return A.Node.create(LABEL_TPL).html(label).unselectable();
				}
			},

			/**
			 * Hitarea element.
			 *
			 * @attribute hitAreaEl
			 * @default Generated DOM element.
			 * @type Node | String
			 */
			hitAreaEl: {
				setter: A.one,
				valueFn: function() {
					_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "valueFn", 329);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 330);
return A.Node.create(HIT_AREA_TPL);
				}
			},

			/**
			 * Always show the hitarea icon.
			 *
			 * @attribute alwaysShowHitArea
			 * @default true
			 * @type boolean
			 */
			alwaysShowHitArea: {
				value: true,
				validator: isBoolean
			},

			/**
			 * Icon element.
			 *
			 * @attribute iconEl
			 * @type Node | String
			 */
			iconEl: {
				setter: A.one,
				valueFn: function() {
					_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "valueFn", 354);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 355);
return A.Node.create(ICON_TPL);
				}
			},

			tabIndex: {
				value: null
			},

			rendered: {
				validator: isBoolean,
				value: false
			}
		},

		AUGMENTS: [A.TreeData],

		EXTENDS: A.Base,

		prototype: {
			/**
			 * Replaced BOUNDING_TEMPLATE with NODE_BOUNDING_TEMPLATE.
			 *
			 * @property BOUNDING_TEMPLATE
			 * @type String
			 * @protected
			 */
			BOUNDING_TEMPLATE: NODE_BOUNDING_TEMPLATE,
			/**
			 * Replaced CONTENT_TEMPLATE with NODE_CONTENT_TEMPLATE.
			 *
			 * @property CONTENT_TEMPLATE
			 * @type String
			 * @protected
			 */
			CONTENT_TEMPLATE: NODE_CONTENT_TEMPLATE,

			/**
			 * Construction logic executed during TreeNode instantiation. Lifecycle.
			 *
			 * @method initializer
			 * @protected
			 */
			initializer: function() {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "initializer", 397);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 398);
var instance = this;

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 400);
var boundingBox = instance.get(BOUNDING_BOX);

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 402);
boundingBox.setData(TREE_NODE, instance);

				// Sync the Widget TreeNode id with the BOUNDING_BOX id
				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 405);
instance._syncTreeNodeBBId();

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 407);
instance._uiSetDraggable(instance.get(DRAGGABLE));
				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 408);
instance._uiSetExpanded(instance.get(EXPANDED));
				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 409);
instance._uiSetLeaf(instance.get(LEAF));
			},

			/**
			 * Bind the events on the TreeNode UI. Lifecycle.
			 *
			 * @method bindUI
			 * @protected
			 */
			bindUI: function() {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "bindUI", 418);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 419);
var instance = this;

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 421);
instance.after({
					childrenChange: instance._afterSetChildren,
					draggableChange: instance._afterDraggableChange,
					expandedChange: instance._afterExpandedChange,
					idChange: instance._afterSetId,
					leafChange: instance._afterLeafChange,
					loadingChange: instance._afterLoadingChange
				});
			},

			render: function(container) {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "render", 431);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 432);
var instance = this;

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 434);
if (!instance.get(RENDERED)) {
					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 435);
instance.renderUI();
					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 436);
instance.bindUI();
					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 437);
instance.syncUI();

					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 439);
instance.set(RENDERED, true);
				}

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 442);
if (container) {
					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 443);
var boundingBox = instance.get(BOUNDING_BOX);
					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 444);
var paginator = instance.get(PAGINATOR);

					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 446);
boundingBox.appendTo(container);

					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 448);
if (paginator) {
						_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 449);
boundingBox.insertBefore(paginator.element);
					}
				}
			},

			/**
			 * Create the DOM structure for the TreeNode. Lifecycle.
			 *
			 * @method renderUI
			 * @protected
			 */
			renderUI: function() {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "renderUI", 460);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 461);
var instance = this;

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 463);
instance._renderBoundingBox();
				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 464);
instance._renderContentBox();
			},

			/**
			 * Sync the TreeNode UI. Lifecycle.
			 *
			 * @method syncUI
			 * @protected
			 */
			syncUI: function() {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "syncUI", 473);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 474);
var instance = this;

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 476);
instance._syncHitArea( instance.get( CHILDREN ) );
				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 477);
instance._syncIconUI();
			},

			_afterDraggableChange: function(event) {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "_afterDraggableChange", 480);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 481);
var instance = this;

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 483);
instance._uiSetDraggable(event.newVal);
				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 484);
instance._syncIconUI();
			},

			_afterExpandedChange: function(event) {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "_afterExpandedChange", 487);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 488);
var instance = this;

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 490);
instance._uiSetExpanded(event.newVal);
				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 491);
instance._syncIconUI();
			},

			_afterLeafChange: function(event) {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "_afterLeafChange", 494);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 495);
var instance = this;

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 497);
instance._uiSetLeaf(event.newVal);
				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 498);
instance._syncIconUI();
			},

			_afterLoadingChange: function(event) {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "_afterLoadingChange", 501);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 502);
var instance = this;

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 504);
instance._syncIconUI();
			},

			/**
			 * Fires after set children.
			 *
			 * @method _afterSetChildren
			 * @param {EventFacade} event
			 * @protected
			 */
			_afterSetChildren: function(event) {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "_afterSetChildren", 514);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 515);
var instance = this;

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 517);
instance._syncHitArea(event.newVal);
				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 518);
instance._syncIconUI();
			},

			/**
			 * Render the <code>contentBox</code> node.
			 *
			 * @method _renderContentBox
			 * @protected
			 * @return {Node}
			 */
			_renderContentBox: function(v) {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "_renderContentBox", 528);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 529);
var instance = this;

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 531);
var contentBox = instance.get(CONTENT_BOX);

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 533);
if (!instance.isLeaf()) {
					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 534);
var expanded = instance.get(EXPANDED);

					// add folder css classes state
					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 537);
contentBox.addClass(
						expanded ? CSS_TREE_EXPANDED : CSS_TREE_COLLAPSED
					);

					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 541);
if (expanded) {
						_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 542);
instance.expand();
					}
				}

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 546);
return contentBox;
			},

			/**
			 * Render the <code>boundingBox</code> node.
			 *
			 * @method _renderBoundingBox
			 * @protected
			 * @return {Node}
			 */
			_renderBoundingBox: function() {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "_renderBoundingBox", 556);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 557);
var instance = this;

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 559);
var boundingBox = instance.get(BOUNDING_BOX);
				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 560);
var contentBox = instance.get(CONTENT_BOX);

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 562);
contentBox.append( instance.get(ICON_EL) );
				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 563);
contentBox.append( instance.get(LABEL_EL) );
				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 564);
boundingBox.append(contentBox);

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 566);
var nodeContainer = instance.get(CONTAINER);

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 568);
if (nodeContainer) {
					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 569);
if (!instance.get(EXPANDED)) {
						_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 570);
nodeContainer.addClass(CSS_HIDE);
					}

					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 573);
boundingBox.append(nodeContainer);
				}

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 576);
return boundingBox;
			},

			/**
			 * Render the node container.
			 *
			 * @method _createNodeContainer
			 * @protected
			 * @return {Node}
			 */
			_createNodeContainer: function() {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "_createNodeContainer", 586);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 587);
var instance = this;

				// creating <ul class="aui-tree-container">
				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 590);
var nodeContainer = instance.get(CONTAINER) || A.Node.create(NODE_CONTAINER_TPL);

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 592);
nodeContainer.addClass(CSS_TREE_CONTAINER);

				// when it's not a leaf it has a <ul> container
				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 595);
instance.set(CONTAINER, nodeContainer);

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 597);
return nodeContainer;
			},

			/**
			 * Sync the hitarea UI.
			 *
			 * @method _syncHitArea
			 * @param {Array} children
			 * @protected
			 */
			_syncHitArea: function(children) {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "_syncHitArea", 607);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 608);
var instance = this;

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 610);
if (instance.get(ALWAYS_SHOW_HITAREA) || children.length) {
					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 611);
instance.showHitArea();
				}
				else {
					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 614);
instance.hideHitArea();

					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 616);
instance.collapse();
				}
			},

			/**
			 * Sync the hitarea UI.
			 *
			 * @method _syncIconUI
			 * @param {Array} children
			 * @protected
			 */
			_syncIconUI: function() {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "_syncIconUI", 627);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 628);
var instance = this,
					ownerTree = instance.get(OWNER_TREE);

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 631);
if (ownerTree) {
					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 632);
var type = ownerTree.get('type'),
						cssClasses = instance.get('cssClasses.' + type);

					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 635);
if (!cssClasses) {
						_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 636);
return;
					}

					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 639);
var expanded = instance.get(EXPANDED),
						iconEl = instance.get(ICON_EL),
						hitAreaEl = instance.get(HIT_AREA_EL),
						icon = instance.isLeaf() ?
								cssClasses.iconLeaf :
								(expanded ? cssClasses.iconExpanded : cssClasses.iconCollapsed),
						iconHitArea = expanded ?
										cssClasses.iconHitAreaExpanded :
										cssClasses.iconHitAreaCollapsed;

					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 649);
if (instance.get(LOADING)) {
						_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 650);
icon = cssClasses.iconLoading;
					}

					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 653);
iconEl.setAttribute('className', icon || BLANK);
					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 654);
hitAreaEl.setAttribute('className', iconHitArea || BLANK);
				}
			},

			/*
			* Methods
			*/
			appendChild: function() {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "appendChild", 661);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 662);
var instance = this;

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 664);
if (!instance.isLeaf()) {
					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 665);
A.TreeNode.superclass.appendChild.apply(instance, arguments);
				}
			},

			/**
			 * Collapse the current TreeNode.
			 *
			 * @method collapse
			 */
			collapse: function() {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "collapse", 674);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 675);
var instance = this;

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 677);
instance.set(EXPANDED, false);
			},

			collapseAll: function() {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "collapseAll", 680);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 681);
var instance = this;

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 683);
A.TreeNode.superclass.collapseAll.apply(instance, arguments);

				// instance is also a node, so collapse itself
				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 686);
instance.collapse();
			},

			/**
			 * Check if the current TreeNode contains the passed <code>node</code>.
			 *
			 * @method contains
			 * @param {TreeNode} node
			 * @return {boolean}
			 */
			contains: function(node) {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "contains", 696);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 697);
return node.isAncestor(this);
			},

			/**
			 * Expand the current TreeNode.
			 *
			 * @method expand
			 */
			expand: function() {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "expand", 705);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 706);
var instance = this;

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 708);
instance.set(EXPANDED, true);
			},

			expandAll: function() {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "expandAll", 711);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 712);
var instance = this;

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 714);
A.TreeNode.superclass.expandAll.apply(instance, arguments);

				// instance is also a node, so expand itself
				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 717);
instance.expand();
			},

			/**
			 * Get the depth of the current TreeNode.
			 *
			 * @method getDepth
			 * @return {Number}
			 */
			getDepth: function() {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "getDepth", 726);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 727);
var instance = this;

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 729);
var depth = 0;

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 731);
var parentNode = instance.get(PARENT_NODE);

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 733);
while (parentNode) {
					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 734);
++depth;
					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 735);
parentNode = parentNode.get(PARENT_NODE);
				}

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 738);
return depth;
			},

			hasChildNodes: function() {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "hasChildNodes", 741);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 742);
var instance = this;

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 744);
return (!instance.isLeaf() &&
						A.TreeNode.superclass.hasChildNodes.apply(this, arguments));
			},

			/**
			 * Whether the current TreeNode is selected or not.
			 *
			 * @method isSelected
			 * @return {boolean}
			 */
			isSelected: function() {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "isSelected", 754);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 755);
return this.get(CONTENT_BOX).hasClass(CSS_TREE_NODE_SELECTED);
			},

			/**
			 * Whether the current TreeNode is a leaf or not.
			 *
			 * @method isLeaf
			 * @return {boolean}
			 */
			isLeaf: function() {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "isLeaf", 764);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 765);
var instance = this;

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 767);
return instance.get(LEAF);
			},

			/**
			 * Whether the current TreeNode is ancestor of the passed <code>node</code> or not.
			 *
			 * @method isLeaf
			 * @return {boolean}
			 */
			isAncestor: function(node) {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "isAncestor", 776);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 777);
var instance = this;

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 779);
var parentNode = instance.get(PARENT_NODE);

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 781);
while (parentNode) {
					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 782);
if (parentNode === node) {
						_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 783);
return true;
					}
					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 785);
parentNode = parentNode.get(PARENT_NODE);
				}

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 788);
return false;
			},

			/**
			 * Toggle the current TreeNode, <code>collapsed</code> or <code>expanded</code>.
			 *
			 * @method toggle
			 */
			toggle: function() {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "toggle", 796);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 797);
var instance = this;

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 799);
if (instance.get(EXPANDED)) {
					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 800);
instance.collapse();
				}
				else {
					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 803);
instance.expand();
				}
			},

			/*
			* Select the current TreeNode.
			*
			* @method select
			*/
			select: function() {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "select", 812);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 813);
var instance = this;

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 815);
var ownerTree = instance.get(OWNER_TREE);

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 817);
if (ownerTree) {
					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 818);
ownerTree.set(LAST_SELECTED, instance);
				}

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 821);
instance.get(CONTENT_BOX).addClass(CSS_TREE_NODE_SELECTED);

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 823);
instance.fire('select');
			},

			/*
			* Unselect the current TreeNode.
			*
			* @method unselect
			*/
			unselect: function() {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "unselect", 831);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 832);
var instance = this;

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 834);
instance.get(CONTENT_BOX).removeClass(CSS_TREE_NODE_SELECTED);

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 836);
instance.fire('unselect');
			},

			/*
			* Fires when <code>mouseover</code> the current TreeNode.
			*
			* @method over
			*/
			over: function() {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "over", 844);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 845);
this.get(CONTENT_BOX).addClass(CSS_TREE_NODE_OVER);
			},

			/*
			* Fires when <code>mouseout</code> the current TreeNode.
			*
			* @method over
			*/
			out: function() {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "out", 853);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 854);
this.get(CONTENT_BOX).removeClass(CSS_TREE_NODE_OVER);
			},

			/*
			* Show hitarea icon.
			*
			* @method showHitArea
			*/
			showHitArea: function() {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "showHitArea", 862);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 863);
var instance = this;

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 865);
var hitAreaEl = instance.get(HIT_AREA_EL);

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 867);
hitAreaEl.removeClass(CSS_TREE_NODE_HIDDEN_HITAREA);
			},

			/*
			* Hide hitarea icon.
			*
			* @method hideHitArea
			*/
			hideHitArea: function() {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "hideHitArea", 875);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 876);
var instance = this;

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 878);
var hitAreaEl = instance.get(HIT_AREA_EL);

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 880);
hitAreaEl.addClass(CSS_TREE_NODE_HIDDEN_HITAREA);
			},

			/**
			 * Set the <code>boundingBox</code> id.
			 *
			 * @method _syncTreeNodeBBId
			 * @param {String} id
			 * @protected
			 */
			_syncTreeNodeBBId: function(id) {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "_syncTreeNodeBBId", 890);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 891);
var instance = this;

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 893);
instance.get(BOUNDING_BOX).attr(
					ID,
					instance.get(ID)
				);
			},

			_getSibling: function(value, attrName) {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "_getSibling", 899);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 900);
var instance = this;

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 902);
var propName = '_' + attrName;
				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 903);
var sibling = instance[propName];

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 905);
if (sibling !== null && !isTreeNode(sibling)) {
					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 906);
sibling = null;
					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 907);
instance[propName] = sibling;
				}

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 910);
return sibling;
			},

			_uiSetDraggable: function(val) {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "_uiSetDraggable", 913);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 914);
var instance = this;
				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 915);
var contentBox = instance.get(CONTENT_BOX);

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 917);
contentBox.toggleClass(CSS_TREE_NODE_CONTENT_INVALID, !val);
			},

			_uiSetExpanded: function(val) {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "_uiSetExpanded", 920);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 921);
var instance = this;

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 923);
if (!instance.isLeaf()) {
					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 924);
var container = instance.get(CONTAINER);
					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 925);
var contentBox = instance.get(CONTENT_BOX);

					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 927);
if (val) {
						_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 928);
contentBox.replaceClass(CSS_TREE_COLLAPSED, CSS_TREE_EXPANDED);

						_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 930);
if (container) {
							_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 931);
container.removeClass(CSS_HIDE);
						}
					}
					else {
						_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 935);
contentBox.replaceClass(CSS_TREE_EXPANDED, CSS_TREE_COLLAPSED);

						_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 937);
if (container) {
							_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 938);
container.addClass(CSS_HIDE);
						}
					}
				}
			},

			_uiSetLeaf: function(val) {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "_uiSetLeaf", 944);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 945);
var instance = this;

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 947);
var contentBox = instance.get(CONTENT_BOX);

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 949);
if (val) {
					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 950);
instance.get(CONTAINER).remove();
					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 951);
instance.get(HIT_AREA_EL).remove();
				}
				else {
					// append hitarea element
					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 955);
contentBox.prepend( instance.get(HIT_AREA_EL) );

					// if has children append them to this model
					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 958);
instance._createNodeContainer();

					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 960);
instance._uiSetExpanded(instance.get(EXPANDED));
				}

				// add leaf css classes
				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 964);
contentBox.toggleClass(CSS_TREE_NODE_LEAF, val);
			}
		}
	}
);

_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 970);
A.TreeNode = TreeNode;

/*
* TreeNodeIO
*/
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 975);
var TREE_NODE_IO = 'tree-node-io';

/**
 * A base class for TreeNodeIO, providing:
 * <ul>
 *	<li>Widget Lifecycle (initializer, renderUI, bindUI, syncUI, destructor)</li>
 *	<li>Ajax support to load the children of the current TreeNode</li>
 * </ul>
 *
 * Quick Example:<br/>
 *
 * <pre><code>var treeNodeIO = new A.TreeNodeIO({
 *		label: 'TreeNodeIO',
 *		cache: false,
 *		io: {
 *			url: 'assets/content.html'
 *		}
 *  });
 * </code></pre>
 *
 * Check the list of <a href="TreeNodeIO.html#configattributes">Configuration Attributes</a> available for
 * TreeNodeIO.
 *
 * @param config {Object} Object literal specifying widget configuration properties.
 *
 * @class TreeNodeIO
 * @constructor
 * @extends TreeNode
 */
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1004);
var TreeNodeIO = A.Component.create(
	{
		/**
		 * Static property provides a string to identify the class.
		 *
		 * @property TreeNode.NAME
		 * @type String
		 * @static
		 */
		NAME: TREE_NODE_IO,

		/**
		 * Static property used to define the default attribute
		 * configuration for the TreeNode.
		 *
		 * @property TreeNode.ATTRS
		 * @type Object
		 * @static
		 */
		ATTRS: {
			/**
			 * Whether the current TreeNode IO transaction is loading.
			 *
			 * @attribute loading
			 * @default false
			 * @type boolean
			 */
			loading: {
				value: false,
				validator: isBoolean
			},

			/**
			 * Whether the current TreeNode has loaded the content.
			 *
			 * @attribute loaded
			 * @default false
			 * @type boolean
			 */
			loaded: {
				value: false,
				validator: isBoolean
			},

			/**
			 * Whether the current TreeNode should cache the loaded content or not.
			 *
			 * @attribute cache
			 * @default true
			 * @type boolean
			 */
			cache: {
				value: true,
				validator: isBoolean
			},

			leaf: {
				value: false,
				validator: isBoolean
			}
		},

		AUGMENTS: [A.TreeViewPaginator, A.TreeViewIO],

		EXTENDS: A.TreeNode,

		prototype: {
			/**
			 * Bind the events on the TreeNodeIO UI. Lifecycle.
			 *
			 * @method bindUI
			 * @protected
			 */
			bindUI: function() {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "bindUI", 1077);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1078);
var instance = this;

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1080);
A.TreeNodeIO.superclass.bindUI.apply(this, arguments);

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1082);
instance.on('ioRequestSuccess', instance._onIOSuccess, instance);
			},

			syncUI: function() {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "syncUI", 1085);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1086);
var instance = this;

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1088);
A.TreeNodeIO.superclass.syncUI.apply(this, arguments);
			},

			/*
			* Methods
			*/
			createNodes: function(nodes) {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "createNodes", 1094);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1095);
var instance = this;

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1097);
A.Array.each(A.Array(nodes), function(node) {
					_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "(anonymous 2)", 1097);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1098);
var newNode = instance.createNode(node);

					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1100);
instance.appendChild(newNode);
				});

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1103);
instance._syncPaginatorUI(nodes);
			},

			expand: function() {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "expand", 1106);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1107);
var instance = this;

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1109);
var cache = instance.get(CACHE);
				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1110);
var io = instance.get(IO);
				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1111);
var loaded = instance.get(LOADED);
				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1112);
var loading = instance.get(LOADING);

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1114);
if (!cache) {
					// if cache is false on expand, always set LOADED to false
					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1116);
instance.set(LOADED, false);
				}

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1119);
if (io && !loaded && !loading && !this.hasChildNodes()) {
					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1120);
if (!cache) {
						// remove all children to reload
						_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1122);
instance.empty();
					}

					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1125);
instance.initIO();
				}
				else {
					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1128);
A.TreeNodeIO.superclass.expand.apply(this, arguments);
				}
			},

			/**
			 * If not specified on the TreeNode some attributes are inherited from the
			 * ownerTree by this method.
			 *
			 * @method _inheritOwnerTreeAttrs
			 * @protected
			 */
			_inheritOwnerTreeAttrs: function() {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "_inheritOwnerTreeAttrs", 1139);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1140);
var instance = this;

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1142);
var ownerTree = instance.get(OWNER_TREE);

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1144);
if (ownerTree) {
					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1145);
if (!instance.get(IO)) {
						_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1146);
var io = A.clone(
							ownerTree.get(IO),
							true,
							function(value, key) {
								_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "(anonymous 3)", 1149);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1150);
if (isFunction(value) && (value.defaultFn || value.wrappedFn)) {
									_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1151);
return false;
								}

								_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1154);
return true;
							}
						);

						_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1158);
instance.set(IO, io);
					}

					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1161);
if (!instance.get(PAGINATOR)) {
						_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1162);
var ownerTreePaginator = ownerTree.get(PAGINATOR);

						_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1164);
var paginator = A.clone(ownerTreePaginator);

						// make sure we are not using the same element passed to the ownerTree on the TreeNode
						_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1167);
if (paginator && paginator.element) {
							_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1168);
paginator.element = ownerTreePaginator.element.clone();
						}

						_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1171);
instance.set(PAGINATOR, paginator);
					}
				}
			},

			_onIOSuccess: function(event) {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "_onIOSuccess", 1176);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1177);
var instance = this;

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1179);
instance.expand();
			}
		}
	}
);

_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1185);
A.TreeNodeIO = TreeNodeIO;

/*
* TreeNodeCheck
*/
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1190);
var CHECKBOX = 'checkbox',
	CHECKED = 'checked',
	CHECK_CONTAINER_EL = 'checkContainerEl',
	CHECK_EL = 'checkEl',
	CHECK_NAME = 'checkName',
	DOT = '.',
	NAME = 'name',
	TREE_NODE_CHECK = 'tree-node-check',

	CSS_TREE_NODE_CHECKBOX = getCN(TREE, NODE, CHECKBOX),
	CSS_TREE_NODE_CHECKBOX_CONTAINER = getCN(TREE, NODE, CHECKBOX, CONTAINER),
	CSS_TREE_NODE_CHECKED = getCN(TREE, NODE, CHECKED),

	CHECKBOX_CONTAINER_TPL = '<i class="'+CSS_TREE_NODE_CHECKBOX_CONTAINER+'"></i>',
	CHECKBOX_TPL = '<input class="'+CSS_TREE_NODE_CHECKBOX+'" type="checkbox" />';

/**
 * <p><img src="assets/images/aui-tree-nod-check/main.png"/></p>
 *
 * A base class for TreeNodeCheck, providing:
 * <ul>
 *	<li>Widget Lifecycle (initializer, renderUI, bindUI, syncUI, destructor)</li>
 *	<li>Checkbox support for the TreeNode</li>
 * </ul>
 *
 * Check the list of <a href="TreeNodeCheck.html#configattributes">Configuration Attributes</a> available for
 * TreeNodeCheck.
 *
 * @param config {Object} Object literal specifying widget configuration properties.
 *
 * @class TreeNodeCheck
 * @constructor
 * @extends TreeNodeIO
 */
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1224);
var TreeNodeCheck = A.Component.create(
	{
		/**
		 * Static property provides a string to identify the class.
		 *
		 * @property TreeNode.NAME
		 * @type String
		 * @static
		 */
		NAME: TREE_NODE_CHECK,

		/**
		 * Static property used to define the default attribute
		 * configuration for the TreeNode.
		 *
		 * @property TreeNode.ATTRS
		 * @type Object
		 * @static
		 */
		ATTRS: {
			/**
			 * Whether the TreeNode is checked or not.
			 *
			 * @attribute checked
			 * @default false
			 * @type boolean
			 */
			checked: {
				value: false,
				validator: isBoolean
			},

			/**
			 * Name of the checkbox element used on the current TreeNode.
			 *
			 * @attribute checkName
			 * @default 'tree-node-check'
			 * @type String
			 */
			checkName: {
				value: TREE_NODE_CHECK,
				validator: isString
			},

			/**
			 * Container element for the checkbox.
			 *
			 * @attribute checkContainerEl
			 * @default Generated DOM element.
			 * @type Node | String
			 */
			checkContainerEl: {
				setter: A.one,
				valueFn: function() {
					_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "valueFn", 1277);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1278);
return A.Node.create(CHECKBOX_CONTAINER_TPL);
				}
			},

			/**
			 * Checkbox element.
			 *
			 * @attribute checkEl
			 * @default Generated DOM element.
			 * @type Node | String
			 */
			checkEl: {
				setter: A.one,
				valueFn: function() {
					_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "valueFn", 1291);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1292);
var checkName = this.get(CHECK_NAME);

					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1294);
return A.Node.create(CHECKBOX_TPL).attr(NAME, checkName);
				}
			}
		},

		EXTENDS: A.TreeNodeIO,

		prototype: {

			initializer: function() {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "initializer", 1303);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1304);
var instance = this;

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1306);
instance._uiSetChecked(instance.get(CHECKED));
			},

			/*
			* Lifecycle
			*/
			renderUI: function() {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "renderUI", 1312);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1313);
var instance = this;

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1315);
A.TreeNodeCheck.superclass.renderUI.apply(instance, arguments);

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1317);
var labelEl = instance.get(LABEL_EL);
				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1318);
var checkEl = instance.get(CHECK_EL);
				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1319);
var checkContainerEl = instance.get(CHECK_CONTAINER_EL);

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1321);
checkEl.hide();

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1323);
checkContainerEl.append(checkEl);

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1325);
labelEl.placeBefore(checkContainerEl);

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1327);
if (instance.isChecked()) {
					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1328);
instance.check();
				}
			},

			bindUI: function() {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "bindUI", 1332);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1333);
var instance = this;

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1335);
var contentBox = instance.get(CONTENT_BOX);
				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1336);
var labelEl = instance.get(LABEL_EL);

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1338);
A.TreeNodeCheck.superclass.bindUI.apply(instance, arguments);

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1340);
instance.after('checkedChange', A.bind(instance._afterCheckedChange, instance));

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1342);
contentBox.delegate('click', A.bind(instance.toggleCheck, instance), DOT+CSS_TREE_NODE_CHECKBOX_CONTAINER);
				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1343);
contentBox.delegate('click', A.bind(instance.toggleCheck, instance), DOT+CSS_TREE_LABEL);

				// cancel dblclick because of the check
				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1346);
labelEl.swallowEvent('dblclick');
			},

			/**
			 * Check the current TreeNode.
			 *
			 * @method check
			 */
			check: function(originalTarget) {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "check", 1354);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1355);
var instance = this;

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1357);
instance.set(CHECKED, true, {
					originalTarget: originalTarget
				});
			},

			/**
			 * Uncheck the current TreeNode.
			 *
			 * @method uncheck
			 */
			uncheck: function(originalTarget) {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "uncheck", 1367);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1368);
var instance = this;

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1370);
instance.set(CHECKED, false, {
					originalTarget: originalTarget
				});
			},

			/**
			 * Toggle the check status of the current TreeNode.
			 *
			 * @method toggleCheck
			 */
			toggleCheck: function() {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "toggleCheck", 1380);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1381);
var instance = this;

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1383);
var checkEl = instance.get(CHECK_EL);
				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1384);
var checked = checkEl.attr(CHECKED);

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1386);
if (!checked) {
					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1387);
instance.check();
				}
				else {
					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1390);
instance.uncheck();
				}
			},

			/*
			* Whether the current TreeNodeCheck is checked.
			*
			* @method isChecked
			* @return boolean
			*/
			isChecked: function() {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "isChecked", 1400);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1401);
var instance = this;

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1403);
return instance.get(CHECKED);
			},

			_syncIconCheckUI: function() {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "_syncIconCheckUI", 1406);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1407);
var instance = this,
					ownerTree = instance.get(OWNER_TREE);

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1410);
if (ownerTree) {
					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1411);
var type = ownerTree.get('type'),
						cssClasses = instance.get('cssClasses.' + type);

					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1414);
if (!cssClasses) {
						_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1415);
return;
					}

					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1418);
var checkContainerEl = instance.get(CHECK_CONTAINER_EL),
						isChecked = instance.isChecked();
					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1420);
checkContainerEl.removeClass(
						isChecked ?
							cssClasses.iconUncheck : cssClasses.iconCheck);
					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1423);
checkContainerEl.addClass(
						isChecked ?
							cssClasses.iconCheck : cssClasses.iconUncheck);
				}
			},

			_afterCheckedChange: function(event) {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "_afterCheckedChange", 1429);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1430);
var instance = this;

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1432);
instance._uiSetChecked(event.newVal);
			},

			_uiSetChecked: function(val) {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "_uiSetChecked", 1435);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1436);
var instance = this;

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1438);
instance._syncIconCheckUI();
				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1439);
instance.get(CHECK_EL).attr(CHECKED, val ? CHECKED : BLANK);
				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1440);
instance.get(CONTENT_BOX).toggleClass(CSS_TREE_NODE_CHECKED, val);
			}
		}
	}
);

_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1446);
A.TreeNodeCheck = TreeNodeCheck;

/*
* TreeNodeTask
*/
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1451);
var CHILD = 'child',
	TREE_NODE_TASK = 'tree-node-task',
	UNCHECKED = 'unchecked',

	isTreeNodeTask = function(node) {
		_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "isTreeNodeTask", 1455);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1456);
return node instanceof A.TreeNodeCheck;
	},

	CSS_TREE_NODE_CHILD_UNCHECKED = getCN(TREE, NODE, CHILD, UNCHECKED);

/**
 * <p><img src="assets/images/aui-treeNodeTask/main.png"/></p>
 *
 * A base class for TreeNodeTask, providing:
 * <ul>
 *	<li>Widget Lifecycle (initializer, renderUI, bindUI, syncUI, destructor)</li>
 *	<li>3 states checkbox support</li>
 *	<li>Automatic check/uncheck the parent status based on the children checked status</li>
 * </ul>
 *
 * Check the list of <a href="TreeNodeTask.html#configattributes">Configuration Attributes</a> available for
 * TreeNodeTask.
 *
 * @param config {Object} Object literal specifying widget configuration properties.
 *
 * @class TreeNodeTask
 * @constructor
 * @extends TreeNodeCheck
 */
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1480);
var TreeNodeTask = A.Component.create(
	{
		/**
		 * Static property provides a string to identify the class.
		 *
		 * @property TreeNode.NAME
		 * @type String
		 * @static
		 */
		NAME: TREE_NODE_TASK,

		EXTENDS: A.TreeNodeCheck,

		prototype: {
			/*
			* Methods
			*/
			check: function(originalTarget) {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "check", 1497);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1498);
var instance = this;

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1500);
var contentBox = instance.get(CONTENT_BOX);

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1502);
originalTarget = originalTarget || instance;

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1504);
if (!instance.isLeaf()) {
					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1505);
instance.eachChildren(function(child) {
						_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "(anonymous 4)", 1505);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1506);
if (isTreeNodeTask(child)) {
							_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1507);
child.check(originalTarget);
						}
					});
				}

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1512);
instance.eachParent(
					function(parentNode) {
						_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "(anonymous 5)", 1513);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1514);
if (isTreeNodeTask(parentNode) && !parentNode.isChecked()) {
							_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1515);
parentNode.get(CONTENT_BOX).addClass(CSS_TREE_NODE_CHILD_UNCHECKED);
						}
					}
				);

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1520);
contentBox.removeClass(CSS_TREE_NODE_CHILD_UNCHECKED);

				// invoke default check logic
				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1523);
A.TreeNodeTask.superclass.check.call(this, originalTarget);
			},

			uncheck: function(originalTarget) {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "uncheck", 1526);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1527);
var instance = this;

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1529);
var contentBox = instance.get(CONTENT_BOX);

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1531);
originalTarget = originalTarget || instance;

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1533);
if (!instance.isLeaf()) {
					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1534);
instance.eachChildren(function(child) {
						_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "(anonymous 6)", 1534);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1535);
if (child instanceof A.TreeNodeCheck) {
							_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1536);
child.uncheck(originalTarget);
						}
					});
				}

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1541);
instance.eachParent(
					function(parentNode) {
						_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "(anonymous 7)", 1542);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1543);
if (isTreeNodeTask(parentNode) && !parentNode.isChecked()) {
							_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1544);
parentNode.get(CONTENT_BOX).removeClass(CSS_TREE_NODE_CHILD_UNCHECKED);
						}
					}
				);

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1549);
contentBox.removeClass(CSS_TREE_NODE_CHILD_UNCHECKED);

				// invoke default uncheck logic
				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1552);
A.TreeNodeTask.superclass.uncheck.call(this, originalTarget);
			}
		}
	}
);

_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1558);
A.TreeNodeTask = TreeNodeTask;

/*
* TreeNodeRadio
*/

_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1564);
var TREE_NODE_RADIO = 'tree-node-radio',

	isTreeNodeRadio = function(node) {
		_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "isTreeNodeRadio", 1566);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1567);
return node instanceof A.TreeNodeRadio;
	},

	CSS_NODE_RADIO = getCN(TREE, NODE, RADIO);

/**
 * <p><img src="assets/images/aui-treeNodeRadio/main.png"/></p>
 *
 * A base class for TreeNodeRadio, providing:
 * <ul>
 *	<li>Widget Lifecycle (initializer, renderUI, bindUI, syncUI, destructor)</li>
 *	<li>3 states checkbox support</li>
 *	<li>Automatic check/uncheck the parent status based on the children checked status</li>
 * </ul>
 *
 * Check the list of <a href="TreeNodeRadio.html#configattributes">Configuration Attributes</a> available for
 * TreeNodeRadio.
 *
 * @param config {Object} Object literal specifying widget configuration properties.
 *
 * @class TreeNodeRadio
 * @constructor
 * @extends TreeNodeTask
 */
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1591);
var TreeNodeRadio = A.Component.create(
	{
		/**
		 * Static property provides a string to identify the class.
		 *
		 * @property TreeNode.NAME
		 * @type String
		 * @static
		 */
		NAME: TREE_NODE_RADIO,

		ATTRS: {
			cssClasses: {
				value: {
					file: {
						iconCheck: CSS_ICON_OK_SIGN,
						iconCollapsed: CSS_ICON_FOLDER_CLOSE,
						iconExpanded: CSS_ICON_FOLDER_OPEN,
						iconHitAreaCollapsed: [ CSS_TREE_HITAREA, CSS_ICON_ICON_PLUS ].join(SPACE),
						iconHitAreaExpanded: [ CSS_TREE_HITAREA, CSS_ICON_ICON_MINUS ].join(SPACE),
						iconLeaf: CSS_ICON_ICON_FILE,
						iconLoading: CSS_ICON_ICON_REFRESH,
						iconUncheck: CSS_ICON_OK_SIGN
					},
					normal: {
						iconCheck: CSS_ICON_OK_SIGN,
						iconHitAreaCollapsed: [ CSS_TREE_HITAREA, CSS_ICON_ICON_PLUS ].join(SPACE),
						iconHitAreaExpanded: [ CSS_TREE_HITAREA, CSS_ICON_ICON_MINUS ].join(SPACE),
						iconLoading: CSS_ICON_ICON_REFRESH,
						iconUncheck: CSS_ICON_OK_SIGN
					}
				}
			}
		},

		EXTENDS: A.TreeNodeTask,

		prototype: {
			/*
			* Methods
			*/
			renderUI: function() {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "renderUI", 1632);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1633);
var instance = this;

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1635);
A.TreeNodeRadio.superclass.renderUI.apply(instance, arguments);

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1637);
instance.get(CONTENT_BOX).addClass(CSS_NODE_RADIO);
			},

			check: function() {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "check", 1640);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1641);
var instance = this;

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1643);
instance._uncheckNodesRadio();

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1645);
A.TreeNodeRadio.superclass.check.apply(this, arguments);
			},

			_uncheckNodesRadio: function(node) {
				_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "_uncheckNodesRadio", 1648);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1649);
var instance = this;

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1651);
var children;

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1653);
if (node) {
					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1654);
children = node.get(CHILDREN);
				}
				else {
					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1657);
var ownerTree = instance.get(OWNER_TREE);

					_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1659);
if (ownerTree) {
						_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1660);
children = ownerTree.get(CHILDREN);
					}
					else {
						_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1663);
return;
					}
				}

				_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1667);
A.Array.each(
					children,
					function(value, index, collection) {
						_yuitest_coverfunc("build/aui-tree-node/aui-tree-node.js", "(anonymous 8)", 1669);
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1670);
if (!value.isLeaf()) {
							_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1671);
instance._uncheckNodesRadio(value);
						}

						_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1674);
if (isTreeNodeRadio(value)) {
							_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1675);
value.uncheck();
						}
					}
				);
			}
		}
	}
);

_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1684);
A.TreeNodeRadio = TreeNodeRadio;

/**
 * TreeNode types hash map.
 *
 * <pre><code>A.TreeNode.nodeTypes = {
 *  radio: A.TreeNodeRadio,
 *  task: A.TreeNodeTask,
 *  check: A.TreeNodeCheck,
 *  node: A.TreeNode,
 *  io: A.TreeNodeIO
 *};</code></pre>
 *
 * @for TreeNode
 * @property A.TreeNode.nodeTypes
 * @type Object
 */
_yuitest_coverline("build/aui-tree-node/aui-tree-node.js", 1701);
A.TreeNode.nodeTypes = {
	radio: A.TreeNodeRadio,
	task: A.TreeNodeTask,
	check: A.TreeNodeCheck,
	node: A.TreeNode,
	io: A.TreeNodeIO
};

}, '2.0.0pr1', {"requires": ["json", "querystring-stringify", "aui-tree-data", "aui-tree-io", "aui-tree-paginator"]});
